# ifndef yyTree
# define yyTree

# if defined __STDC__ | defined __cplusplus
# define ARGS(parameters)	parameters
# else
# define ARGS(parameters)	()
# endif


# ifndef bool
# define bool char
# endif
# define NoTree (tTree) 0L
# define kCOMP_UNIT 1
# define kBODY_NODE 2
# define kTYPE_NODE 3
# define kDUMMY_TYPE 4
# define kVOID_TYPE 5
# define kINTEGER_TYPE 6
# define kCARDINAL_TYPE 7
# define kREAL_TYPE 8
# define kBOOLEAN_TYPE 9
# define kCOMPLEX_TYPE 10
# define kCHAR_TYPE 11
# define kSTRING_TYPE 12
# define kINDEX_TYPE 13
# define kTYPE_ID 14
# define kARRAY_TYPE 15
# define kRECORD_TYPE 16
# define kUNION_TYPE 17
# define kENUM_TYPE 18
# define kDYNAMIC 19
# define kPOINTER_TYPE 20
# define kARRAY1_TYPE 21
# define kFUNCTION_TYPE 22
# define kTYPE_NODE_LIST 23
# define kTYPE_EMPTY 24
# define kTYPE_LIST 25
# define kDECL_NODE 26
# define kMODULE_DECL 27
# define kPROGRAM_DECL 28
# define kPROC_DECL 29
# define kFUNC_DECL 30
# define kBLOCK_DATA_DECL 31
# define kTYPE_DECL 32
# define kNAME_DECL 33
# define kRENAME_DECL 34
# define kENTITY_DECL 35
# define kVAR_DECL 36
# define kCOMMON_DECL 37
# define kNAMELIST_DECL 38
# define kTEMPLATE_DECL 39
# define kPROCESSORS_DECL 40
# define kINHERIT_DECL 41
# define kSTMT_FUNC_DECL 42
# define kINTERFACE_DECL 43
# define kEXT_PROC_DECL 44
# define kEXT_FUNC_DECL 45
# define kVAL_PARAM_DECL 46
# define kVAR_PARAM_DECL 47
# define kPROC_PARAM_DECL 48
# define kFUNC_PARAM_DECL 49
# define kELIPSIS_PARAM_DECL 50
# define kRET_PARAM_DECL 51
# define kIMPLICIT_DECL 52
# define kUSE_DECL 53
# define kONLY_USE_DECL 54
# define kEQV_DECL 55
# define kDATA_DECL 56
# define kDIMENSION_DECL 57
# define kINIT_DATA_DECL 58
# define kTYPESPEC_DECL 59
# define kALLOCATABLE_DECL 60
# define kEXTERNAL_DECL 61
# define kINTENT_DECL 62
# define kINTRINSIC_DECL 63
# define kOPTIONAL_DECL 64
# define kPOINTER_DECL 65
# define kSAVE_DECL 66
# define kTARGET_DECL 67
# define kPARAMETER_DECL 68
# define kPUBLIC_DECL 69
# define kPRIVATE_DECL 70
# define kDISTRIBUTE_DECL 71
# define kALIGN_DECL 72
# define kDYNAMIC_DECL 73
# define kSEQUENCE_DECL 74
# define kNOSEQUENCE_DECL 75
# define kDECL_NODE_LIST 76
# define kDECL_EMPTY 77
# define kDECL_LIST 78
# define kDISTRIBUTION_SPEC 79
# define kHOST_DISTRIBUTION 80
# define kREPL_DISTRIBUTION 81
# define kNODE_DISTRIBUTION 82
# define kDISTRIBUTION_FORMAT 83
# define kBLOCK_DISTRIBUTION 84
# define kCYCLIC_DISTRIBUTION 85
# define kSERIAL_DISTRIBUTION 86
# define kDIST_FORMAT_LIST 87
# define kDIST_EMPTY 88
# define kDIST_LIST 89
# define kGENERIC_SPEC 90
# define kNO_GENERIC_SPEC 91
# define kID_GENERIC_SPEC 92
# define kOP_GENERIC_SPEC 93
# define kASSIGN_GENERIC_SPEC 94
# define kACF_NODE_LIST 95
# define kACF_EMPTY 96
# define kACF_LIST 97
# define kACF_NODE 98
# define kACF_DUMMY 99
# define kACF_BASIC 100
# define kACF_IF 101
# define kACF_WHERE 102
# define kACF_SWITCH 103
# define kACF_ALTER 104
# define kACF_CASE 105
# define kACF_WHILE 106
# define kACF_REPEAT 107
# define kACF_WITH 108
# define kACF_LOOP 109
# define kACF_DO 110
# define kACF_DOLOCAL 111
# define kACF_DOVEC 112
# define kACF_DOALL 113
# define kACF_FORALL 114
# define kACF_ON 115
# define kACF_BODY 116
# define kACF_FLOW_GRAPH 117
# define kACF_ENTRY 118
# define kACF_FLOW_KIND 119
# define kACF_COMPLEX_FLOW 120
# define kACF_INTERVAL_FLOW 121
# define kACF_SIMPLE_FLOW 122
# define kSELECTED_ACF_NODE_LIST 123
# define kSELECTED_ACF_EMPTY 124
# define kSELECTED_ACF_LIST 125
# define kSELECTED_ACF_NODE 126
# define kBT_STMT 127
# define kEXP_STMT 128
# define kASSIGN_STMT 129
# define kPTR_ASSIGN_STMT 130
# define kLABEL_ASSIGN_STMT 131
# define kCALL_STMT 132
# define kIO_STMT 133
# define kGOTO_STMT 134
# define kASS_GOTO_STMT 135
# define kCOMP_GOTO_STMT 136
# define kCOMP_IF_STMT 137
# define kRETURN_STMT 138
# define kPAUSE_STMT 139
# define kEXIT_STMT 140
# define kCYCLE_STMT 141
# define kSTOP_STMT 142
# define kFORMAT_STMT 143
# define kALLOCATE_STMT 144
# define kDEALLOCATE_STMT 145
# define kNULLIFY_STMT 146
# define kREDUCE_STMT 147
# define kGLOBAL_STMT 148
# define kALIGN_STMT 149
# define kDISTRIBUTE_STMT 150
# define kLABEL_USE_LIST 151
# define kLABEL_EMPTY 152
# define kLABEL_LIST 153
# define kOP 154
# define kOP_EQ 155
# define kOP_NE 156
# define kOP_LT 157
# define kOP_GT 158
# define kOP_GE 159
# define kOP_LE 160
# define kOP_PLUS 161
# define kOP_MINUS 162
# define kOP_XOR 163
# define kOP_OR 164
# define kOP_CONCAT 165
# define kOP_TIMES 166
# define kOP_DIVIDE 167
# define kOP_DIV 168
# define kOP_AND 169
# define kOP_EQV 170
# define kOP_NEQV 171
# define kOP_EXPO 172
# define kOP_MOD 173
# define kOP_IN 174
# define kOP_DEFINED 175
# define kOP_ASSIGN 176
# define kOP_LEFT 177
# define kOP_RIGHT 178
# define kOP_LIST 179
# define kOP_IOR 180
# define kOP_IXOR 181
# define kOP_IAND 182
# define kOP1_NOT 183
# define kOP1_SIGN 184
# define kOP1_INOT 185
# define kOP1_SIZE 186
# define kOP1_DEC 187
# define kOP1_INC 188
# define kOP1_ADDRESS 189
# define kOP1_DEREF 190
# define kBT_EXP 191
# define kDUMMY_EXP 192
# define kCONST_EXP 193
# define kOP_EXP 194
# define kOP1_EXP 195
# define kSLICE_EXP 196
# define kPOSTFIX_EXP 197
# define kCALL_EXP 198
# define kCAST_EXP 199
# define kINDEXED_EXP 200
# define kSELECTED_EXP 201
# define kASSIGN_EXP 202
# define kUSED_EXP 203
# define kCOND_EXP 204
# define kVAR_EXP 205
# define kFUNC_CALL_EXP 206
# define kNAMED_EXP 207
# define kDO_EXP 208
# define kTYPE_EXP 209
# define kARRAY_EXP 210
# define kBT_EXP_LIST 211
# define kBTE_EMPTY 212
# define kBTE_LIST 213
# define kBT_VAR 214
# define kDUMMY_VAR 215
# define kUSED_VAR 216
# define kINDEXED_VAR 217
# define kSUBSTRING_VAR 218
# define kSELECTED_VAR 219
# define kLOOP_VAR 220
# define kADDR 221
# define kDO_VAR 222
# define kBT_VAR_LIST 223
# define kBTV_EMPTY 224
# define kBTV_LIST 225
# define kBT_PARAM 226
# define kVAR_PARAM 227
# define kVALUE_PARAM 228
# define kNAMED_PARAM 229
# define kPROC_PARAM 230
# define kFUNC_PARAM 231
# define kFORMAT_PARAM 232
# define kRETURN_PARAM 233
# define kNO_PARAM 234
# define kBT_PARAM_LIST 235
# define kBTP_EMPTY 236
# define kBTP_LIST 237
# define kCONSTANT 238
# define kBOOL_CONSTANT 239
# define kINT_CONSTANT 240
# define kREAL_CONSTANT 241
# define kDREAL_CONSTANT 242
# define kCHAR_CONSTANT 243
# define kSTRING_CONSTANT 244
# define kCOMPLEX_CONSTANT 245
# define kPROC_OBJ 246
# define kVAR_OBJ 247
# define kTYPE_OBJ 248
# define kREC_COMP 249

typedef unsigned char Tree_tKind;
typedef unsigned short Tree_tMark;
typedef unsigned short Tree_tLabel;
typedef union Tree_Node * tTree;
typedef void (* Tree_tProcTree) ();
/* line 44 "ast.cg" */


#include "Idents.h"

tIdent DefaultId ();  /* will be used later for queries about such an id */


/* line 650 "ast.cg" */

# include "Definiti.h"


# ifndef Tree_NodeHead
# define Tree_NodeHead
# endif
# define yyIsCompMax 0
typedef struct { Tree_tKind yyKind; unsigned char yyIsComp0, yyIsDone0; Tree_tMark yyMark, yyOffset; tTree yyParent; Tree_NodeHead } Tree_tNodeHead;
typedef struct { Tree_tNodeHead yyHead; tTree COMP_ELEMENTS; } yCOMP_UNIT;
typedef struct { Tree_tNodeHead yyHead; tTree DECLS; tTree STATS; tTree INTERNALS; } yBODY_NODE;
typedef struct { Tree_tNodeHead yyHead; } yTYPE_NODE;
typedef struct { Tree_tNodeHead yyHead; } yDUMMY_TYPE;
typedef struct { Tree_tNodeHead yyHead; } yVOID_TYPE;
typedef struct { Tree_tNodeHead yyHead; int size; } yINTEGER_TYPE;
typedef struct { Tree_tNodeHead yyHead; int size; } yCARDINAL_TYPE;
typedef struct { Tree_tNodeHead yyHead; int size; } yREAL_TYPE;
typedef struct { Tree_tNodeHead yyHead; int size; } yBOOLEAN_TYPE;
typedef struct { Tree_tNodeHead yyHead; int size; } yCOMPLEX_TYPE;
typedef struct { Tree_tNodeHead yyHead; } yCHAR_TYPE;
typedef struct { Tree_tNodeHead yyHead; tTree LENGTH; } ySTRING_TYPE;
typedef struct { Tree_tNodeHead yyHead; tTree LOWER; tTree UPPER; int left_overlap; int right_overlap; } yINDEX_TYPE;
typedef struct { Tree_tNodeHead yyHead; tTree ID; } yTYPE_ID;
typedef struct { Tree_tNodeHead yyHead; tTree ARRAY_INDEX_TYPES; tTree ARRAY_COMP_TYPE; } yARRAY_TYPE;
typedef struct { Tree_tNodeHead yyHead; tIdent Name; tTree COMPONENTS; } yRECORD_TYPE;
typedef struct { Tree_tNodeHead yyHead; tIdent Name; tTree COMPONENTS; } yUNION_TYPE;
typedef struct { Tree_tNodeHead yyHead; tIdent Name; tTree COMPONENTS; } yENUM_TYPE;
typedef struct { Tree_tNodeHead yyHead; tTree Shape; int left_overlap; int right_overlap; } yDYNAMIC;
typedef struct { Tree_tNodeHead yyHead; tTree PTR_COMP; } yPOINTER_TYPE;
typedef struct { Tree_tNodeHead yyHead; tTree SIZE; tTree ARRAY1_COMP_TYPE; } yARRAY1_TYPE;
typedef struct { Tree_tNodeHead yyHead; tTree FORMALS; tTree RESULT_TYPE; } yFUNCTION_TYPE;
typedef struct { Tree_tNodeHead yyHead; } yTYPE_NODE_LIST;
typedef struct { Tree_tNodeHead yyHead; } yTYPE_EMPTY;
typedef struct { Tree_tNodeHead yyHead; tTree Elem; tTree Next; } yTYPE_LIST;
typedef struct { Tree_tNodeHead yyHead; tIdent Name; int Pos; } yDECL_NODE;
typedef struct { Tree_tNodeHead yyHead; tIdent Name; int Pos; tTree MODULE_BODY; } yMODULE_DECL;
typedef struct { Tree_tNodeHead yyHead; tIdent Name; int Pos; tTree FORMALS; tTree PROGRAM_BODY; } yPROGRAM_DECL;
typedef struct { Tree_tNodeHead yyHead; tIdent Name; int Pos; tTree FORMALS; tTree PROC_BODY; bool IsRecursive; bool IsPure; int HPFExtrinsic; } yPROC_DECL;
typedef struct { Tree_tNodeHead yyHead; tIdent Name; int Pos; tTree FORMALS; tTree FUNC_BODY; tTree RESULT_TYPE; tIdent RESULT_ID; bool IsRecursive; bool IsPure; int HPFExtrinsic; } yFUNC_DECL;
typedef struct { Tree_tNodeHead yyHead; tIdent Name; int Pos; tTree DATA_BODY; } yBLOCK_DATA_DECL;
typedef struct { Tree_tNodeHead yyHead; tIdent Name; int Pos; tTree VAL; } yTYPE_DECL;
typedef struct { Tree_tNodeHead yyHead; tIdent Name; int Pos; } yNAME_DECL;
typedef struct { Tree_tNodeHead yyHead; tIdent Name; int Pos; tIdent oldname; } yRENAME_DECL;
typedef struct { Tree_tNodeHead yyHead; tIdent Name; int Pos; tTree ATTRIBUTES; } yENTITY_DECL;
typedef struct { Tree_tNodeHead yyHead; tIdent Name; int Pos; tTree VAL; } yVAR_DECL;
typedef struct { Tree_tNodeHead yyHead; tIdent Name; int Pos; tTree IDS; } yCOMMON_DECL;
typedef struct { Tree_tNodeHead yyHead; tIdent Name; int Pos; tTree IDS; } yNAMELIST_DECL;
typedef struct { Tree_tNodeHead yyHead; tIdent Name; int Pos; tTree DIMENSIONS; } yTEMPLATE_DECL;
typedef struct { Tree_tNodeHead yyHead; tIdent Name; int Pos; tTree DIMENSIONS; } yPROCESSORS_DECL;
typedef struct { Tree_tNodeHead yyHead; tIdent Name; int Pos; } yINHERIT_DECL;
typedef struct { Tree_tNodeHead yyHead; tIdent Name; int Pos; tTree FORMALS; tTree RESULT_TYPE; tTree FFUNC_BODY; } ySTMT_FUNC_DECL;
typedef struct { Tree_tNodeHead yyHead; tIdent Name; int Pos; tTree SPEC; tTree ITEMS; } yINTERFACE_DECL;
typedef struct { Tree_tNodeHead yyHead; tIdent Name; int Pos; tTree FORMALS; } yEXT_PROC_DECL;
typedef struct { Tree_tNodeHead yyHead; tIdent Name; int Pos; tTree FORMALS; tTree RESULT_TYPE; } yEXT_FUNC_DECL;
typedef struct { Tree_tNodeHead yyHead; tIdent Name; int Pos; tTree VAL; } yVAL_PARAM_DECL;
typedef struct { Tree_tNodeHead yyHead; tIdent Name; int Pos; tTree VAL; } yVAR_PARAM_DECL;
typedef struct { Tree_tNodeHead yyHead; tIdent Name; int Pos; tTree FORMAL; } yPROC_PARAM_DECL;
typedef struct { Tree_tNodeHead yyHead; tIdent Name; int Pos; tTree FORMAL; tTree RESULT_TYPE; } yFUNC_PARAM_DECL;
typedef struct { Tree_tNodeHead yyHead; tIdent Name; int Pos; } yELIPSIS_PARAM_DECL;
typedef struct { Tree_tNodeHead yyHead; tIdent Name; int Pos; } yRET_PARAM_DECL;
typedef struct { Tree_tNodeHead yyHead; tIdent Name; int Pos; tIdent first; tIdent last; tTree VAL; } yIMPLICIT_DECL;
typedef struct { Tree_tNodeHead yyHead; tIdent Name; int Pos; tIdent use; tTree RENAMINGS; } yUSE_DECL;
typedef struct { Tree_tNodeHead yyHead; tIdent Name; int Pos; tIdent use; tTree NAMES; } yONLY_USE_DECL;
typedef struct { Tree_tNodeHead yyHead; tIdent Name; int Pos; tTree VARS; } yEQV_DECL;
typedef struct { Tree_tNodeHead yyHead; tIdent Name; int Pos; tTree VARS; tTree VALS; } yDATA_DECL;
typedef struct { Tree_tNodeHead yyHead; tIdent Name; int Pos; tTree INDEXES; } yDIMENSION_DECL;
typedef struct { Tree_tNodeHead yyHead; tIdent Name; int Pos; tTree VAL; } yINIT_DATA_DECL;
typedef struct { Tree_tNodeHead yyHead; tIdent Name; int Pos; tTree VAL; } yTYPESPEC_DECL;
typedef struct { Tree_tNodeHead yyHead; tIdent Name; int Pos; } yALLOCATABLE_DECL;
typedef struct { Tree_tNodeHead yyHead; tIdent Name; int Pos; } yEXTERNAL_DECL;
typedef struct { Tree_tNodeHead yyHead; tIdent Name; int Pos; int intent; } yINTENT_DECL;
typedef struct { Tree_tNodeHead yyHead; tIdent Name; int Pos; } yINTRINSIC_DECL;
typedef struct { Tree_tNodeHead yyHead; tIdent Name; int Pos; } yOPTIONAL_DECL;
typedef struct { Tree_tNodeHead yyHead; tIdent Name; int Pos; } yPOINTER_DECL;
typedef struct { Tree_tNodeHead yyHead; tIdent Name; int Pos; } ySAVE_DECL;
typedef struct { Tree_tNodeHead yyHead; tIdent Name; int Pos; } yTARGET_DECL;
typedef struct { Tree_tNodeHead yyHead; tIdent Name; int Pos; tTree VAL; } yPARAMETER_DECL;
typedef struct { Tree_tNodeHead yyHead; tIdent Name; int Pos; } yPUBLIC_DECL;
typedef struct { Tree_tNodeHead yyHead; tIdent Name; int Pos; } yPRIVATE_DECL;
typedef struct { Tree_tNodeHead yyHead; tIdent Name; int Pos; tTree DISTRIBUTION; tIdent target; } yDISTRIBUTE_DECL;
typedef struct { Tree_tNodeHead yyHead; tIdent Name; int Pos; tTree ALIGN_SOURCE; tTree ALIGN_SPEC; } yALIGN_DECL;
typedef struct { Tree_tNodeHead yyHead; tIdent Name; int Pos; } yDYNAMIC_DECL;
typedef struct { Tree_tNodeHead yyHead; tIdent Name; int Pos; } ySEQUENCE_DECL;
typedef struct { Tree_tNodeHead yyHead; tIdent Name; int Pos; } yNOSEQUENCE_DECL;
typedef struct { Tree_tNodeHead yyHead; } yDECL_NODE_LIST;
typedef struct { Tree_tNodeHead yyHead; } yDECL_EMPTY;
typedef struct { Tree_tNodeHead yyHead; tTree Elem; tTree Next; } yDECL_LIST;
typedef struct { Tree_tNodeHead yyHead; } yDISTRIBUTION_SPEC;
typedef struct { Tree_tNodeHead yyHead; } yHOST_DISTRIBUTION;
typedef struct { Tree_tNodeHead yyHead; } yREPL_DISTRIBUTION;
typedef struct { Tree_tNodeHead yyHead; tTree MAPPING; } yNODE_DISTRIBUTION;
typedef struct { Tree_tNodeHead yyHead; } yDISTRIBUTION_FORMAT;
typedef struct { Tree_tNodeHead yyHead; tTree SIZE; } yBLOCK_DISTRIBUTION;
typedef struct { Tree_tNodeHead yyHead; tTree SIZE; } yCYCLIC_DISTRIBUTION;
typedef struct { Tree_tNodeHead yyHead; } ySERIAL_DISTRIBUTION;
typedef struct { Tree_tNodeHead yyHead; } yDIST_FORMAT_LIST;
typedef struct { Tree_tNodeHead yyHead; } yDIST_EMPTY;
typedef struct { Tree_tNodeHead yyHead; tTree Elem; tTree Next; } yDIST_LIST;
typedef struct { Tree_tNodeHead yyHead; } yGENERIC_SPEC;
typedef struct { Tree_tNodeHead yyHead; } yNO_GENERIC_SPEC;
typedef struct { Tree_tNodeHead yyHead; tIdent name; } yID_GENERIC_SPEC;
typedef struct { Tree_tNodeHead yyHead; tTree OPERATOR; } yOP_GENERIC_SPEC;
typedef struct { Tree_tNodeHead yyHead; } yASSIGN_GENERIC_SPEC;
typedef struct { Tree_tNodeHead yyHead; } yACF_NODE_LIST;
typedef struct { Tree_tNodeHead yyHead; } yACF_EMPTY;
typedef struct { Tree_tNodeHead yyHead; tTree Elem; tTree Next; } yACF_LIST;
typedef struct { Tree_tNodeHead yyHead; int Label; int Line; } yACF_NODE;
typedef struct { Tree_tNodeHead yyHead; int Label; int Line; } yACF_DUMMY;
typedef struct { Tree_tNodeHead yyHead; int Label; int Line; tTree BASIC_STMT; } yACF_BASIC;
typedef struct { Tree_tNodeHead yyHead; int Label; int Line; tTree IF_EXP; tTree THEN_PART; tTree ELSE_PART; } yACF_IF;
typedef struct { Tree_tNodeHead yyHead; int Label; int Line; tTree WHERE_EXP; tTree TRUE_PART; tTree FALSE_PART; } yACF_WHERE;
typedef struct { Tree_tNodeHead yyHead; int Label; int Line; tTree SWITCH_EXP; tTree SWITCH_STMT; } yACF_SWITCH;
typedef struct { Tree_tNodeHead yyHead; int Label; int Line; tTree ALTER_EXP; tTree ALTER_STMT; } yACF_ALTER;
typedef struct { Tree_tNodeHead yyHead; int Label; int Line; tTree CASE_EXP; tTree CASE_ALTS; tTree CASE_OTHERWISE; } yACF_CASE;
typedef struct { Tree_tNodeHead yyHead; int Label; int Line; tTree WHILE_EXP; tTree WHILE_BODY; } yACF_WHILE;
typedef struct { Tree_tNodeHead yyHead; int Label; int Line; tTree REPEAT_BODY; tTree REPEAT_EXP; } yACF_REPEAT;
typedef struct { Tree_tNodeHead yyHead; int Label; int Line; tTree WITH_VARS; tTree WITH_BODY; } yACF_WITH;
typedef struct { Tree_tNodeHead yyHead; int Label; int Line; tTree LOOP_BODY; } yACF_LOOP;
typedef struct { Tree_tNodeHead yyHead; int Label; int Line; tTree DO_ID; tTree DO_RANGE; tTree DO_BODY; } yACF_DO;
typedef struct { Tree_tNodeHead yyHead; int Label; int Line; tTree DOLOCAL_ID; tTree DOLOCAL_RANGE; tTree DOLOCAL_BODY; } yACF_DOLOCAL;
typedef struct { Tree_tNodeHead yyHead; int Label; int Line; tTree DOVEC_ID; tTree DOVEC_RANGE; tTree DOVEC_BODY; } yACF_DOVEC;
typedef struct { Tree_tNodeHead yyHead; int Label; int Line; tTree DOALL_NEW; tTree DOALL_ID; tTree DOALL_RANGE; tTree DOALL_BODY; } yACF_DOALL;
typedef struct { Tree_tNodeHead yyHead; int Label; int Line; tTree FORALL_ID; tTree FORALL_RANGE; tTree FORALL_BODY; } yACF_FORALL;
typedef struct { Tree_tNodeHead yyHead; int Label; int Line; tTree ON_VAR; tTree ON_STMT; } yACF_ON;
typedef struct { Tree_tNodeHead yyHead; int Label; int Line; tTree NEW_BODY; tDefinitions Entries; } yACF_BODY;
typedef struct { Tree_tNodeHead yyHead; int Label; int Line; tTree FLOW_NODES; } yACF_FLOW_GRAPH;
typedef struct { Tree_tNodeHead yyHead; int Label; int Line; tTree ENTRY_DECL; } yACF_ENTRY;
typedef struct { Tree_tNodeHead yyHead; } yACF_FLOW_KIND;
typedef struct { Tree_tNodeHead yyHead; } yACF_COMPLEX_FLOW;
typedef struct { Tree_tNodeHead yyHead; } yACF_INTERVAL_FLOW;
typedef struct { Tree_tNodeHead yyHead; } yACF_SIMPLE_FLOW;
typedef struct { Tree_tNodeHead yyHead; } ySELECTED_ACF_NODE_LIST;
typedef struct { Tree_tNodeHead yyHead; } ySELECTED_ACF_EMPTY;
typedef struct { Tree_tNodeHead yyHead; tTree Elem; tTree Next; } ySELECTED_ACF_LIST;
typedef struct { Tree_tNodeHead yyHead; tTree SELECT_LIST; tTree SELECT_ACFS; } ySELECTED_ACF_NODE;
typedef struct { Tree_tNodeHead yyHead; } yBT_STMT;
typedef struct { Tree_tNodeHead yyHead; tTree STMT_EXP; } yEXP_STMT;
typedef struct { Tree_tNodeHead yyHead; tTree ASSIGN_VAR; tTree ASSIGN_EXP; } yASSIGN_STMT;
typedef struct { Tree_tNodeHead yyHead; tTree ASSIGN_VAR; tTree ASSIGN_EXP; } yPTR_ASSIGN_STMT;
typedef struct { Tree_tNodeHead yyHead; int assign_label; tTree LABEL_VAR; } yLABEL_ASSIGN_STMT;
typedef struct { Tree_tNodeHead yyHead; tTree CALL_ID; tTree CALL_PARAMS; } yCALL_STMT;
typedef struct { Tree_tNodeHead yyHead; tTree ID; tTree IO_SPECS; tTree IO_ITEMS; } yIO_STMT;
typedef struct { Tree_tNodeHead yyHead; int GOTO_LABEL; } yGOTO_STMT;
typedef struct { Tree_tNodeHead yyHead; tTree GOTO_VAR; tTree LABELS; } yASS_GOTO_STMT;
typedef struct { Tree_tNodeHead yyHead; tTree GOTO_LABELS; tTree GOTO_EXP; } yCOMP_GOTO_STMT;
typedef struct { Tree_tNodeHead yyHead; tTree IF_EXP; int IF_LT_LABEL; int IF_EQ_LABEL; int IF_GT_LABEL; } yCOMP_IF_STMT;
typedef struct { Tree_tNodeHead yyHead; tTree RETURN_EXP; } yRETURN_STMT;
typedef struct { Tree_tNodeHead yyHead; tTree PAUSE_CONST; } yPAUSE_STMT;
typedef struct { Tree_tNodeHead yyHead; tIdent loopid; } yEXIT_STMT;
typedef struct { Tree_tNodeHead yyHead; tIdent loopid; } yCYCLE_STMT;
typedef struct { Tree_tNodeHead yyHead; tTree STOP_CONST; } ySTOP_STMT;
typedef struct { Tree_tNodeHead yyHead; tTree FORMAT_PARAMS; } yFORMAT_STMT;
typedef struct { Tree_tNodeHead yyHead; tTree PARAMS; tTree STAT; } yALLOCATE_STMT;
typedef struct { Tree_tNodeHead yyHead; tTree PARAMS; tTree STAT; } yDEALLOCATE_STMT;
typedef struct { Tree_tNodeHead yyHead; tTree PARAMS; } yNULLIFY_STMT;
typedef struct { Tree_tNodeHead yyHead; tTree RED_FUNC; tTree RED_PARAMS; } yREDUCE_STMT;
typedef struct { Tree_tNodeHead yyHead; tIdent func; tTree ARRAY; tTree INDEXED_ARRAY; tTree INDEXES; tTree MASK; } yGLOBAL_STMT;
typedef struct { Tree_tNodeHead yyHead; tTree ALIGNEE; tTree ALIGN_SPEC; } yALIGN_STMT;
typedef struct { Tree_tNodeHead yyHead; tTree DISTRIBUTEE; tTree DISTRIBUTION; tIdent target; } yDISTRIBUTE_STMT;
typedef struct { Tree_tNodeHead yyHead; } yLABEL_USE_LIST;
typedef struct { Tree_tNodeHead yyHead; } yLABEL_EMPTY;
typedef struct { Tree_tNodeHead yyHead; int Elem; tTree Next; } yLABEL_LIST;
typedef struct { Tree_tNodeHead yyHead; } yOP;
typedef struct { Tree_tNodeHead yyHead; } yOP_EQ;
typedef struct { Tree_tNodeHead yyHead; } yOP_NE;
typedef struct { Tree_tNodeHead yyHead; } yOP_LT;
typedef struct { Tree_tNodeHead yyHead; } yOP_GT;
typedef struct { Tree_tNodeHead yyHead; } yOP_GE;
typedef struct { Tree_tNodeHead yyHead; } yOP_LE;
typedef struct { Tree_tNodeHead yyHead; } yOP_PLUS;
typedef struct { Tree_tNodeHead yyHead; } yOP_MINUS;
typedef struct { Tree_tNodeHead yyHead; } yOP_XOR;
typedef struct { Tree_tNodeHead yyHead; } yOP_OR;
typedef struct { Tree_tNodeHead yyHead; } yOP_CONCAT;
typedef struct { Tree_tNodeHead yyHead; } yOP_TIMES;
typedef struct { Tree_tNodeHead yyHead; } yOP_DIVIDE;
typedef struct { Tree_tNodeHead yyHead; } yOP_DIV;
typedef struct { Tree_tNodeHead yyHead; } yOP_AND;
typedef struct { Tree_tNodeHead yyHead; } yOP_EQV;
typedef struct { Tree_tNodeHead yyHead; } yOP_NEQV;
typedef struct { Tree_tNodeHead yyHead; } yOP_EXPO;
typedef struct { Tree_tNodeHead yyHead; } yOP_MOD;
typedef struct { Tree_tNodeHead yyHead; } yOP_IN;
typedef struct { Tree_tNodeHead yyHead; tIdent opname; } yOP_DEFINED;
typedef struct { Tree_tNodeHead yyHead; } yOP_ASSIGN;
typedef struct { Tree_tNodeHead yyHead; } yOP_LEFT;
typedef struct { Tree_tNodeHead yyHead; } yOP_RIGHT;
typedef struct { Tree_tNodeHead yyHead; } yOP_LIST;
typedef struct { Tree_tNodeHead yyHead; } yOP_IOR;
typedef struct { Tree_tNodeHead yyHead; } yOP_IXOR;
typedef struct { Tree_tNodeHead yyHead; } yOP_IAND;
typedef struct { Tree_tNodeHead yyHead; } yOP1_NOT;
typedef struct { Tree_tNodeHead yyHead; } yOP1_SIGN;
typedef struct { Tree_tNodeHead yyHead; } yOP1_INOT;
typedef struct { Tree_tNodeHead yyHead; } yOP1_SIZE;
typedef struct { Tree_tNodeHead yyHead; } yOP1_DEC;
typedef struct { Tree_tNodeHead yyHead; } yOP1_INC;
typedef struct { Tree_tNodeHead yyHead; } yOP1_ADDRESS;
typedef struct { Tree_tNodeHead yyHead; } yOP1_DEREF;
typedef struct { Tree_tNodeHead yyHead; } yBT_EXP;
typedef struct { Tree_tNodeHead yyHead; } yDUMMY_EXP;
typedef struct { Tree_tNodeHead yyHead; tTree C; } yCONST_EXP;
typedef struct { Tree_tNodeHead yyHead; tTree EXP_OP; tTree OPND1; tTree OPND2; } yOP_EXP;
typedef struct { Tree_tNodeHead yyHead; tTree EXP_OP1; tTree OPND; } yOP1_EXP;
typedef struct { Tree_tNodeHead yyHead; tTree START; tTree STOP; tTree INC; } ySLICE_EXP;
typedef struct { Tree_tNodeHead yyHead; tTree POSTFIX_OP; tTree OPND; } yPOSTFIX_EXP;
typedef struct { Tree_tNodeHead yyHead; tTree FUNC_ID; tTree FUNC_PARAMS; } yCALL_EXP;
typedef struct { Tree_tNodeHead yyHead; tTree ID; tTree CAST; } yCAST_EXP;
typedef struct { Tree_tNodeHead yyHead; tTree IND_EXP; tTree INDEX; } yINDEXED_EXP;
typedef struct { Tree_tNodeHead yyHead; tTree SELEC_EXP; tTree SELECTOR; } ySELECTED_EXP;
typedef struct { Tree_tNodeHead yyHead; tTree ASSIGN_OP; tTree LHS; tTree RHS; } yASSIGN_EXP;
typedef struct { Tree_tNodeHead yyHead; tTree VARNAME; } yUSED_EXP;
typedef struct { Tree_tNodeHead yyHead; tTree COND; tTree TRUE_EXP; tTree FALSE_EXP; } yCOND_EXP;
typedef struct { Tree_tNodeHead yyHead; tTree V; } yVAR_EXP;
typedef struct { Tree_tNodeHead yyHead; tTree FUNC_ID; tTree FUNC_PARAMS; } yFUNC_CALL_EXP;
typedef struct { Tree_tNodeHead yyHead; tIdent Name; tTree VAL; } yNAMED_EXP;
typedef struct { Tree_tNodeHead yyHead; tTree DO_ID; tTree RANGE; tTree BODY; } yDO_EXP;
typedef struct { Tree_tNodeHead yyHead; tTree ID; tTree ELEMENTS; } yTYPE_EXP;
typedef struct { Tree_tNodeHead yyHead; tTree ELEMENTS; } yARRAY_EXP;
typedef struct { Tree_tNodeHead yyHead; } yBT_EXP_LIST;
typedef struct { Tree_tNodeHead yyHead; } yBTE_EMPTY;
typedef struct { Tree_tNodeHead yyHead; tTree Elem; tTree Next; } yBTE_LIST;
typedef struct { Tree_tNodeHead yyHead; } yBT_VAR;
typedef struct { Tree_tNodeHead yyHead; } yDUMMY_VAR;
typedef struct { Tree_tNodeHead yyHead; tTree VARNAME; } yUSED_VAR;
typedef struct { Tree_tNodeHead yyHead; tTree IND_VAR; tTree IND_EXPS; } yINDEXED_VAR;
typedef struct { Tree_tNodeHead yyHead; tTree IND_VAR; tTree IND_EXP; } ySUBSTRING_VAR;
typedef struct { Tree_tNodeHead yyHead; tTree SELEC_VAR; tTree SELECTOR; } ySELECTED_VAR;
typedef struct { Tree_tNodeHead yyHead; tTree LOOP_VARNAME; } yLOOP_VAR;
typedef struct { Tree_tNodeHead yyHead; tTree E; } yADDR;
typedef struct { Tree_tNodeHead yyHead; tTree DO_ID; tTree RANGE; tTree BODY; } yDO_VAR;
typedef struct { Tree_tNodeHead yyHead; } yBT_VAR_LIST;
typedef struct { Tree_tNodeHead yyHead; } yBTV_EMPTY;
typedef struct { Tree_tNodeHead yyHead; tTree Elem; tTree Next; } yBTV_LIST;
typedef struct { Tree_tNodeHead yyHead; } yBT_PARAM;
typedef struct { Tree_tNodeHead yyHead; tTree V; } yVAR_PARAM;
typedef struct { Tree_tNodeHead yyHead; tTree E; } yVALUE_PARAM;
typedef struct { Tree_tNodeHead yyHead; tIdent Name; tTree VAL; } yNAMED_PARAM;
typedef struct { Tree_tNodeHead yyHead; tTree P; } yPROC_PARAM;
typedef struct { Tree_tNodeHead yyHead; tTree F; } yFUNC_PARAM;
typedef struct { Tree_tNodeHead yyHead; tStringRef S; } yFORMAT_PARAM;
typedef struct { Tree_tNodeHead yyHead; int label; } yRETURN_PARAM;
typedef struct { Tree_tNodeHead yyHead; } yNO_PARAM;
typedef struct { Tree_tNodeHead yyHead; } yBT_PARAM_LIST;
typedef struct { Tree_tNodeHead yyHead; } yBTP_EMPTY;
typedef struct { Tree_tNodeHead yyHead; tTree Elem; tTree Next; } yBTP_LIST;
typedef struct { Tree_tNodeHead yyHead; } yCONSTANT;
typedef struct { Tree_tNodeHead yyHead; int value; } yBOOL_CONSTANT;
typedef struct { Tree_tNodeHead yyHead; int value; } yINT_CONSTANT;
typedef struct { Tree_tNodeHead yyHead; tStringRef value; } yREAL_CONSTANT;
typedef struct { Tree_tNodeHead yyHead; tStringRef value; } yDREAL_CONSTANT;
typedef struct { Tree_tNodeHead yyHead; char value; } yCHAR_CONSTANT;
typedef struct { Tree_tNodeHead yyHead; tStringRef value; } ySTRING_CONSTANT;
typedef struct { Tree_tNodeHead yyHead; tStringRef rvalue; tStringRef ivalue; } yCOMPLEX_CONSTANT;
typedef struct { Tree_tNodeHead yyHead; tIdent Ident; tDefinitions Object; } yPROC_OBJ;
typedef struct { Tree_tNodeHead yyHead; int Pos; tIdent Ident; tDefinitions Object; } yVAR_OBJ;
typedef struct { Tree_tNodeHead yyHead; tIdent Ident; tDefinitions Object; } yTYPE_OBJ;
typedef struct { Tree_tNodeHead yyHead; tIdent Ident; tDefinitions Object; } yREC_COMP;

union Tree_Node {
 Tree_tKind Kind;
 Tree_tNodeHead yyHead;
 yCOMP_UNIT COMP_UNIT;
 yBODY_NODE BODY_NODE;
 yTYPE_NODE TYPE_NODE;
 yDUMMY_TYPE DUMMY_TYPE;
 yVOID_TYPE VOID_TYPE;
 yINTEGER_TYPE INTEGER_TYPE;
 yCARDINAL_TYPE CARDINAL_TYPE;
 yREAL_TYPE REAL_TYPE;
 yBOOLEAN_TYPE BOOLEAN_TYPE;
 yCOMPLEX_TYPE COMPLEX_TYPE;
 yCHAR_TYPE CHAR_TYPE;
 ySTRING_TYPE STRING_TYPE;
 yINDEX_TYPE INDEX_TYPE;
 yTYPE_ID TYPE_ID;
 yARRAY_TYPE ARRAY_TYPE;
 yRECORD_TYPE RECORD_TYPE;
 yUNION_TYPE UNION_TYPE;
 yENUM_TYPE ENUM_TYPE;
 yDYNAMIC DYNAMIC;
 yPOINTER_TYPE POINTER_TYPE;
 yARRAY1_TYPE ARRAY1_TYPE;
 yFUNCTION_TYPE FUNCTION_TYPE;
 yTYPE_NODE_LIST TYPE_NODE_LIST;
 yTYPE_EMPTY TYPE_EMPTY;
 yTYPE_LIST TYPE_LIST;
 yDECL_NODE DECL_NODE;
 yMODULE_DECL MODULE_DECL;
 yPROGRAM_DECL PROGRAM_DECL;
 yPROC_DECL PROC_DECL;
 yFUNC_DECL FUNC_DECL;
 yBLOCK_DATA_DECL BLOCK_DATA_DECL;
 yTYPE_DECL TYPE_DECL;
 yNAME_DECL NAME_DECL;
 yRENAME_DECL RENAME_DECL;
 yENTITY_DECL ENTITY_DECL;
 yVAR_DECL VAR_DECL;
 yCOMMON_DECL COMMON_DECL;
 yNAMELIST_DECL NAMELIST_DECL;
 yTEMPLATE_DECL TEMPLATE_DECL;
 yPROCESSORS_DECL PROCESSORS_DECL;
 yINHERIT_DECL INHERIT_DECL;
 ySTMT_FUNC_DECL STMT_FUNC_DECL;
 yINTERFACE_DECL INTERFACE_DECL;
 yEXT_PROC_DECL EXT_PROC_DECL;
 yEXT_FUNC_DECL EXT_FUNC_DECL;
 yVAL_PARAM_DECL VAL_PARAM_DECL;
 yVAR_PARAM_DECL VAR_PARAM_DECL;
 yPROC_PARAM_DECL PROC_PARAM_DECL;
 yFUNC_PARAM_DECL FUNC_PARAM_DECL;
 yELIPSIS_PARAM_DECL ELIPSIS_PARAM_DECL;
 yRET_PARAM_DECL RET_PARAM_DECL;
 yIMPLICIT_DECL IMPLICIT_DECL;
 yUSE_DECL USE_DECL;
 yONLY_USE_DECL ONLY_USE_DECL;
 yEQV_DECL EQV_DECL;
 yDATA_DECL DATA_DECL;
 yDIMENSION_DECL DIMENSION_DECL;
 yINIT_DATA_DECL INIT_DATA_DECL;
 yTYPESPEC_DECL TYPESPEC_DECL;
 yALLOCATABLE_DECL ALLOCATABLE_DECL;
 yEXTERNAL_DECL EXTERNAL_DECL;
 yINTENT_DECL INTENT_DECL;
 yINTRINSIC_DECL INTRINSIC_DECL;
 yOPTIONAL_DECL OPTIONAL_DECL;
 yPOINTER_DECL POINTER_DECL;
 ySAVE_DECL SAVE_DECL;
 yTARGET_DECL TARGET_DECL;
 yPARAMETER_DECL PARAMETER_DECL;
 yPUBLIC_DECL PUBLIC_DECL;
 yPRIVATE_DECL PRIVATE_DECL;
 yDISTRIBUTE_DECL DISTRIBUTE_DECL;
 yALIGN_DECL ALIGN_DECL;
 yDYNAMIC_DECL DYNAMIC_DECL;
 ySEQUENCE_DECL SEQUENCE_DECL;
 yNOSEQUENCE_DECL NOSEQUENCE_DECL;
 yDECL_NODE_LIST DECL_NODE_LIST;
 yDECL_EMPTY DECL_EMPTY;
 yDECL_LIST DECL_LIST;
 yDISTRIBUTION_SPEC DISTRIBUTION_SPEC;
 yHOST_DISTRIBUTION HOST_DISTRIBUTION;
 yREPL_DISTRIBUTION REPL_DISTRIBUTION;
 yNODE_DISTRIBUTION NODE_DISTRIBUTION;
 yDISTRIBUTION_FORMAT DISTRIBUTION_FORMAT;
 yBLOCK_DISTRIBUTION BLOCK_DISTRIBUTION;
 yCYCLIC_DISTRIBUTION CYCLIC_DISTRIBUTION;
 ySERIAL_DISTRIBUTION SERIAL_DISTRIBUTION;
 yDIST_FORMAT_LIST DIST_FORMAT_LIST;
 yDIST_EMPTY DIST_EMPTY;
 yDIST_LIST DIST_LIST;
 yGENERIC_SPEC GENERIC_SPEC;
 yNO_GENERIC_SPEC NO_GENERIC_SPEC;
 yID_GENERIC_SPEC ID_GENERIC_SPEC;
 yOP_GENERIC_SPEC OP_GENERIC_SPEC;
 yASSIGN_GENERIC_SPEC ASSIGN_GENERIC_SPEC;
 yACF_NODE_LIST ACF_NODE_LIST;
 yACF_EMPTY ACF_EMPTY;
 yACF_LIST ACF_LIST;
 yACF_NODE ACF_NODE;
 yACF_DUMMY ACF_DUMMY;
 yACF_BASIC ACF_BASIC;
 yACF_IF ACF_IF;
 yACF_WHERE ACF_WHERE;
 yACF_SWITCH ACF_SWITCH;
 yACF_ALTER ACF_ALTER;
 yACF_CASE ACF_CASE;
 yACF_WHILE ACF_WHILE;
 yACF_REPEAT ACF_REPEAT;
 yACF_WITH ACF_WITH;
 yACF_LOOP ACF_LOOP;
 yACF_DO ACF_DO;
 yACF_DOLOCAL ACF_DOLOCAL;
 yACF_DOVEC ACF_DOVEC;
 yACF_DOALL ACF_DOALL;
 yACF_FORALL ACF_FORALL;
 yACF_ON ACF_ON;
 yACF_BODY ACF_BODY;
 yACF_FLOW_GRAPH ACF_FLOW_GRAPH;
 yACF_ENTRY ACF_ENTRY;
 yACF_FLOW_KIND ACF_FLOW_KIND;
 yACF_COMPLEX_FLOW ACF_COMPLEX_FLOW;
 yACF_INTERVAL_FLOW ACF_INTERVAL_FLOW;
 yACF_SIMPLE_FLOW ACF_SIMPLE_FLOW;
 ySELECTED_ACF_NODE_LIST SELECTED_ACF_NODE_LIST;
 ySELECTED_ACF_EMPTY SELECTED_ACF_EMPTY;
 ySELECTED_ACF_LIST SELECTED_ACF_LIST;
 ySELECTED_ACF_NODE SELECTED_ACF_NODE;
 yBT_STMT BT_STMT;
 yEXP_STMT EXP_STMT;
 yASSIGN_STMT ASSIGN_STMT;
 yPTR_ASSIGN_STMT PTR_ASSIGN_STMT;
 yLABEL_ASSIGN_STMT LABEL_ASSIGN_STMT;
 yCALL_STMT CALL_STMT;
 yIO_STMT IO_STMT;
 yGOTO_STMT GOTO_STMT;
 yASS_GOTO_STMT ASS_GOTO_STMT;
 yCOMP_GOTO_STMT COMP_GOTO_STMT;
 yCOMP_IF_STMT COMP_IF_STMT;
 yRETURN_STMT RETURN_STMT;
 yPAUSE_STMT PAUSE_STMT;
 yEXIT_STMT EXIT_STMT;
 yCYCLE_STMT CYCLE_STMT;
 ySTOP_STMT STOP_STMT;
 yFORMAT_STMT FORMAT_STMT;
 yALLOCATE_STMT ALLOCATE_STMT;
 yDEALLOCATE_STMT DEALLOCATE_STMT;
 yNULLIFY_STMT NULLIFY_STMT;
 yREDUCE_STMT REDUCE_STMT;
 yGLOBAL_STMT GLOBAL_STMT;
 yALIGN_STMT ALIGN_STMT;
 yDISTRIBUTE_STMT DISTRIBUTE_STMT;
 yLABEL_USE_LIST LABEL_USE_LIST;
 yLABEL_EMPTY LABEL_EMPTY;
 yLABEL_LIST LABEL_LIST;
 yOP OP;
 yOP_EQ OP_EQ;
 yOP_NE OP_NE;
 yOP_LT OP_LT;
 yOP_GT OP_GT;
 yOP_GE OP_GE;
 yOP_LE OP_LE;
 yOP_PLUS OP_PLUS;
 yOP_MINUS OP_MINUS;
 yOP_XOR OP_XOR;
 yOP_OR OP_OR;
 yOP_CONCAT OP_CONCAT;
 yOP_TIMES OP_TIMES;
 yOP_DIVIDE OP_DIVIDE;
 yOP_DIV OP_DIV;
 yOP_AND OP_AND;
 yOP_EQV OP_EQV;
 yOP_NEQV OP_NEQV;
 yOP_EXPO OP_EXPO;
 yOP_MOD OP_MOD;
 yOP_IN OP_IN;
 yOP_DEFINED OP_DEFINED;
 yOP_ASSIGN OP_ASSIGN;
 yOP_LEFT OP_LEFT;
 yOP_RIGHT OP_RIGHT;
 yOP_LIST OP_LIST;
 yOP_IOR OP_IOR;
 yOP_IXOR OP_IXOR;
 yOP_IAND OP_IAND;
 yOP1_NOT OP1_NOT;
 yOP1_SIGN OP1_SIGN;
 yOP1_INOT OP1_INOT;
 yOP1_SIZE OP1_SIZE;
 yOP1_DEC OP1_DEC;
 yOP1_INC OP1_INC;
 yOP1_ADDRESS OP1_ADDRESS;
 yOP1_DEREF OP1_DEREF;
 yBT_EXP BT_EXP;
 yDUMMY_EXP DUMMY_EXP;
 yCONST_EXP CONST_EXP;
 yOP_EXP OP_EXP;
 yOP1_EXP OP1_EXP;
 ySLICE_EXP SLICE_EXP;
 yPOSTFIX_EXP POSTFIX_EXP;
 yCALL_EXP CALL_EXP;
 yCAST_EXP CAST_EXP;
 yINDEXED_EXP INDEXED_EXP;
 ySELECTED_EXP SELECTED_EXP;
 yASSIGN_EXP ASSIGN_EXP;
 yUSED_EXP USED_EXP;
 yCOND_EXP COND_EXP;
 yVAR_EXP VAR_EXP;
 yFUNC_CALL_EXP FUNC_CALL_EXP;
 yNAMED_EXP NAMED_EXP;
 yDO_EXP DO_EXP;
 yTYPE_EXP TYPE_EXP;
 yARRAY_EXP ARRAY_EXP;
 yBT_EXP_LIST BT_EXP_LIST;
 yBTE_EMPTY BTE_EMPTY;
 yBTE_LIST BTE_LIST;
 yBT_VAR BT_VAR;
 yDUMMY_VAR DUMMY_VAR;
 yUSED_VAR USED_VAR;
 yINDEXED_VAR INDEXED_VAR;
 ySUBSTRING_VAR SUBSTRING_VAR;
 ySELECTED_VAR SELECTED_VAR;
 yLOOP_VAR LOOP_VAR;
 yADDR ADDR;
 yDO_VAR DO_VAR;
 yBT_VAR_LIST BT_VAR_LIST;
 yBTV_EMPTY BTV_EMPTY;
 yBTV_LIST BTV_LIST;
 yBT_PARAM BT_PARAM;
 yVAR_PARAM VAR_PARAM;
 yVALUE_PARAM VALUE_PARAM;
 yNAMED_PARAM NAMED_PARAM;
 yPROC_PARAM PROC_PARAM;
 yFUNC_PARAM FUNC_PARAM;
 yFORMAT_PARAM FORMAT_PARAM;
 yRETURN_PARAM RETURN_PARAM;
 yNO_PARAM NO_PARAM;
 yBT_PARAM_LIST BT_PARAM_LIST;
 yBTP_EMPTY BTP_EMPTY;
 yBTP_LIST BTP_LIST;
 yCONSTANT CONSTANT;
 yBOOL_CONSTANT BOOL_CONSTANT;
 yINT_CONSTANT INT_CONSTANT;
 yREAL_CONSTANT REAL_CONSTANT;
 yDREAL_CONSTANT DREAL_CONSTANT;
 yCHAR_CONSTANT CHAR_CONSTANT;
 ySTRING_CONSTANT STRING_CONSTANT;
 yCOMPLEX_CONSTANT COMPLEX_CONSTANT;
 yPROC_OBJ PROC_OBJ;
 yVAR_OBJ VAR_OBJ;
 yTYPE_OBJ TYPE_OBJ;
 yREC_COMP REC_COMP;
};

extern tTree TreeRoot;
extern unsigned long Tree_HeapUsed;
extern char * Tree_PoolFreePtr, * Tree_PoolMaxPtr;
extern unsigned short Tree_NodeSize [249 + 1];
extern char * Tree_NodeName [249 + 1];

extern tTree Tree_Alloc ();
extern tTree MakeTree ARGS((Tree_tKind yyKind));
extern bool Tree_IsType ARGS((register tTree yyt, register Tree_tKind yyKind));

extern tTree mCOMP_UNIT ARGS((tTree pCOMP_ELEMENTS));
extern tTree mBODY_NODE ARGS((tTree pDECLS, tTree pSTATS, tTree pINTERNALS));
extern tTree mTYPE_NODE ARGS(());
extern tTree mDUMMY_TYPE ARGS(());
extern tTree mVOID_TYPE ARGS(());
extern tTree mINTEGER_TYPE ARGS((int psize));
extern tTree mCARDINAL_TYPE ARGS((int psize));
extern tTree mREAL_TYPE ARGS((int psize));
extern tTree mBOOLEAN_TYPE ARGS((int psize));
extern tTree mCOMPLEX_TYPE ARGS((int psize));
extern tTree mCHAR_TYPE ARGS(());
extern tTree mSTRING_TYPE ARGS((tTree pLENGTH));
extern tTree mINDEX_TYPE ARGS((tTree pLOWER, tTree pUPPER));
extern tTree mTYPE_ID ARGS((tTree pID));
extern tTree mARRAY_TYPE ARGS((tTree pARRAY_INDEX_TYPES, tTree pARRAY_COMP_TYPE));
extern tTree mRECORD_TYPE ARGS((tIdent pName, tTree pCOMPONENTS));
extern tTree mUNION_TYPE ARGS((tIdent pName, tTree pCOMPONENTS));
extern tTree mENUM_TYPE ARGS((tIdent pName, tTree pCOMPONENTS));
extern tTree mDYNAMIC ARGS(());
extern tTree mPOINTER_TYPE ARGS((tTree pPTR_COMP));
extern tTree mARRAY1_TYPE ARGS((tTree pSIZE, tTree pARRAY1_COMP_TYPE));
extern tTree mFUNCTION_TYPE ARGS((tTree pFORMALS, tTree pRESULT_TYPE));
extern tTree mTYPE_NODE_LIST ARGS(());
extern tTree mTYPE_EMPTY ARGS(());
extern tTree mTYPE_LIST ARGS((tTree pElem, tTree pNext));
extern tTree mDECL_NODE ARGS((tIdent pName, int pPos));
extern tTree mMODULE_DECL ARGS((tIdent pName, int pPos, tTree pMODULE_BODY));
extern tTree mPROGRAM_DECL ARGS((tIdent pName, int pPos, tTree pFORMALS, tTree pPROGRAM_BODY));
extern tTree mPROC_DECL ARGS((tIdent pName, int pPos, tTree pFORMALS, tTree pPROC_BODY));
extern tTree mFUNC_DECL ARGS((tIdent pName, int pPos, tTree pFORMALS, tTree pFUNC_BODY, tTree pRESULT_TYPE, tIdent pRESULT_ID));
extern tTree mBLOCK_DATA_DECL ARGS((tIdent pName, int pPos, tTree pDATA_BODY));
extern tTree mTYPE_DECL ARGS((tIdent pName, int pPos, tTree pVAL));
extern tTree mNAME_DECL ARGS((tIdent pName, int pPos));
extern tTree mRENAME_DECL ARGS((tIdent pName, int pPos, tIdent poldname));
extern tTree mENTITY_DECL ARGS((tIdent pName, int pPos, tTree pATTRIBUTES));
extern tTree mVAR_DECL ARGS((tIdent pName, int pPos, tTree pVAL));
extern tTree mCOMMON_DECL ARGS((tIdent pName, int pPos, tTree pIDS));
extern tTree mNAMELIST_DECL ARGS((tIdent pName, int pPos, tTree pIDS));
extern tTree mTEMPLATE_DECL ARGS((tIdent pName, int pPos, tTree pDIMENSIONS));
extern tTree mPROCESSORS_DECL ARGS((tIdent pName, int pPos, tTree pDIMENSIONS));
extern tTree mINHERIT_DECL ARGS((tIdent pName, int pPos));
extern tTree mSTMT_FUNC_DECL ARGS((tIdent pName, int pPos, tTree pFORMALS, tTree pRESULT_TYPE, tTree pFFUNC_BODY));
extern tTree mINTERFACE_DECL ARGS((tIdent pName, int pPos, tTree pSPEC, tTree pITEMS));
extern tTree mEXT_PROC_DECL ARGS((tIdent pName, int pPos, tTree pFORMALS));
extern tTree mEXT_FUNC_DECL ARGS((tIdent pName, int pPos, tTree pFORMALS, tTree pRESULT_TYPE));
extern tTree mVAL_PARAM_DECL ARGS((tIdent pName, int pPos, tTree pVAL));
extern tTree mVAR_PARAM_DECL ARGS((tIdent pName, int pPos, tTree pVAL));
extern tTree mPROC_PARAM_DECL ARGS((tIdent pName, int pPos, tTree pFORMAL));
extern tTree mFUNC_PARAM_DECL ARGS((tIdent pName, int pPos, tTree pFORMAL, tTree pRESULT_TYPE));
extern tTree mELIPSIS_PARAM_DECL ARGS((tIdent pName, int pPos));
extern tTree mRET_PARAM_DECL ARGS((tIdent pName, int pPos));
extern tTree mIMPLICIT_DECL ARGS((tIdent pName, int pPos, tIdent pfirst, tIdent plast, tTree pVAL));
extern tTree mUSE_DECL ARGS((tIdent pName, int pPos, tIdent puse, tTree pRENAMINGS));
extern tTree mONLY_USE_DECL ARGS((tIdent pName, int pPos, tIdent puse, tTree pNAMES));
extern tTree mEQV_DECL ARGS((tIdent pName, int pPos, tTree pVARS));
extern tTree mDATA_DECL ARGS((tIdent pName, int pPos, tTree pVARS, tTree pVALS));
extern tTree mDIMENSION_DECL ARGS((tIdent pName, int pPos, tTree pINDEXES));
extern tTree mINIT_DATA_DECL ARGS((tIdent pName, int pPos, tTree pVAL));
extern tTree mTYPESPEC_DECL ARGS((tIdent pName, int pPos, tTree pVAL));
extern tTree mALLOCATABLE_DECL ARGS((tIdent pName, int pPos));
extern tTree mEXTERNAL_DECL ARGS((tIdent pName, int pPos));
extern tTree mINTENT_DECL ARGS((tIdent pName, int pPos, int pintent));
extern tTree mINTRINSIC_DECL ARGS((tIdent pName, int pPos));
extern tTree mOPTIONAL_DECL ARGS((tIdent pName, int pPos));
extern tTree mPOINTER_DECL ARGS((tIdent pName, int pPos));
extern tTree mSAVE_DECL ARGS((tIdent pName, int pPos));
extern tTree mTARGET_DECL ARGS((tIdent pName, int pPos));
extern tTree mPARAMETER_DECL ARGS((tIdent pName, int pPos, tTree pVAL));
extern tTree mPUBLIC_DECL ARGS((tIdent pName, int pPos));
extern tTree mPRIVATE_DECL ARGS((tIdent pName, int pPos));
extern tTree mDISTRIBUTE_DECL ARGS((tIdent pName, int pPos, tTree pDISTRIBUTION, tIdent ptarget));
extern tTree mALIGN_DECL ARGS((tIdent pName, int pPos, tTree pALIGN_SOURCE, tTree pALIGN_SPEC));
extern tTree mDYNAMIC_DECL ARGS((tIdent pName, int pPos));
extern tTree mSEQUENCE_DECL ARGS((tIdent pName, int pPos));
extern tTree mNOSEQUENCE_DECL ARGS((tIdent pName, int pPos));
extern tTree mDECL_NODE_LIST ARGS(());
extern tTree mDECL_EMPTY ARGS(());
extern tTree mDECL_LIST ARGS((tTree pElem, tTree pNext));
extern tTree mDISTRIBUTION_SPEC ARGS(());
extern tTree mHOST_DISTRIBUTION ARGS(());
extern tTree mREPL_DISTRIBUTION ARGS(());
extern tTree mNODE_DISTRIBUTION ARGS((tTree pMAPPING));
extern tTree mDISTRIBUTION_FORMAT ARGS(());
extern tTree mBLOCK_DISTRIBUTION ARGS((tTree pSIZE));
extern tTree mCYCLIC_DISTRIBUTION ARGS((tTree pSIZE));
extern tTree mSERIAL_DISTRIBUTION ARGS(());
extern tTree mDIST_FORMAT_LIST ARGS(());
extern tTree mDIST_EMPTY ARGS(());
extern tTree mDIST_LIST ARGS((tTree pElem, tTree pNext));
extern tTree mGENERIC_SPEC ARGS(());
extern tTree mNO_GENERIC_SPEC ARGS(());
extern tTree mID_GENERIC_SPEC ARGS((tIdent pname));
extern tTree mOP_GENERIC_SPEC ARGS((tTree pOPERATOR));
extern tTree mASSIGN_GENERIC_SPEC ARGS(());
extern tTree mACF_NODE_LIST ARGS(());
extern tTree mACF_EMPTY ARGS(());
extern tTree mACF_LIST ARGS((tTree pElem, tTree pNext));
extern tTree mACF_NODE ARGS(());
extern tTree mACF_DUMMY ARGS(());
extern tTree mACF_BASIC ARGS((tTree pBASIC_STMT));
extern tTree mACF_IF ARGS((tTree pIF_EXP, tTree pTHEN_PART, tTree pELSE_PART));
extern tTree mACF_WHERE ARGS((tTree pWHERE_EXP, tTree pTRUE_PART, tTree pFALSE_PART));
extern tTree mACF_SWITCH ARGS((tTree pSWITCH_EXP, tTree pSWITCH_STMT));
extern tTree mACF_ALTER ARGS((tTree pALTER_EXP, tTree pALTER_STMT));
extern tTree mACF_CASE ARGS((tTree pCASE_EXP, tTree pCASE_ALTS, tTree pCASE_OTHERWISE));
extern tTree mACF_WHILE ARGS((tTree pWHILE_EXP, tTree pWHILE_BODY));
extern tTree mACF_REPEAT ARGS((tTree pREPEAT_BODY, tTree pREPEAT_EXP));
extern tTree mACF_WITH ARGS((tTree pWITH_VARS, tTree pWITH_BODY));
extern tTree mACF_LOOP ARGS((tTree pLOOP_BODY));
extern tTree mACF_DO ARGS((tTree pDO_ID, tTree pDO_RANGE, tTree pDO_BODY));
extern tTree mACF_DOLOCAL ARGS((tTree pDOLOCAL_ID, tTree pDOLOCAL_RANGE, tTree pDOLOCAL_BODY));
extern tTree mACF_DOVEC ARGS((tTree pDOVEC_ID, tTree pDOVEC_RANGE, tTree pDOVEC_BODY));
extern tTree mACF_DOALL ARGS((tTree pDOALL_NEW, tTree pDOALL_ID, tTree pDOALL_RANGE, tTree pDOALL_BODY));
extern tTree mACF_FORALL ARGS((tTree pFORALL_ID, tTree pFORALL_RANGE, tTree pFORALL_BODY));
extern tTree mACF_ON ARGS((tTree pON_VAR, tTree pON_STMT));
extern tTree mACF_BODY ARGS((tTree pNEW_BODY));
extern tTree mACF_FLOW_GRAPH ARGS((tTree pFLOW_NODES));
extern tTree mACF_ENTRY ARGS((tTree pENTRY_DECL));
extern tTree mACF_FLOW_KIND ARGS(());
extern tTree mACF_COMPLEX_FLOW ARGS(());
extern tTree mACF_INTERVAL_FLOW ARGS(());
extern tTree mACF_SIMPLE_FLOW ARGS(());
extern tTree mSELECTED_ACF_NODE_LIST ARGS(());
extern tTree mSELECTED_ACF_EMPTY ARGS(());
extern tTree mSELECTED_ACF_LIST ARGS((tTree pElem, tTree pNext));
extern tTree mSELECTED_ACF_NODE ARGS((tTree pSELECT_LIST, tTree pSELECT_ACFS));
extern tTree mBT_STMT ARGS(());
extern tTree mEXP_STMT ARGS((tTree pSTMT_EXP));
extern tTree mASSIGN_STMT ARGS((tTree pASSIGN_VAR, tTree pASSIGN_EXP));
extern tTree mPTR_ASSIGN_STMT ARGS((tTree pASSIGN_VAR, tTree pASSIGN_EXP));
extern tTree mLABEL_ASSIGN_STMT ARGS((int passign_label, tTree pLABEL_VAR));
extern tTree mCALL_STMT ARGS((tTree pCALL_ID, tTree pCALL_PARAMS));
extern tTree mIO_STMT ARGS((tTree pID, tTree pIO_SPECS, tTree pIO_ITEMS));
extern tTree mGOTO_STMT ARGS((int pGOTO_LABEL));
extern tTree mASS_GOTO_STMT ARGS((tTree pGOTO_VAR, tTree pLABELS));
extern tTree mCOMP_GOTO_STMT ARGS((tTree pGOTO_LABELS, tTree pGOTO_EXP));
extern tTree mCOMP_IF_STMT ARGS((tTree pIF_EXP, int pIF_LT_LABEL, int pIF_EQ_LABEL, int pIF_GT_LABEL));
extern tTree mRETURN_STMT ARGS((tTree pRETURN_EXP));
extern tTree mPAUSE_STMT ARGS((tTree pPAUSE_CONST));
extern tTree mEXIT_STMT ARGS((tIdent ploopid));
extern tTree mCYCLE_STMT ARGS((tIdent ploopid));
extern tTree mSTOP_STMT ARGS((tTree pSTOP_CONST));
extern tTree mFORMAT_STMT ARGS((tTree pFORMAT_PARAMS));
extern tTree mALLOCATE_STMT ARGS((tTree pPARAMS, tTree pSTAT));
extern tTree mDEALLOCATE_STMT ARGS((tTree pPARAMS, tTree pSTAT));
extern tTree mNULLIFY_STMT ARGS((tTree pPARAMS));
extern tTree mREDUCE_STMT ARGS((tTree pRED_FUNC, tTree pRED_PARAMS));
extern tTree mGLOBAL_STMT ARGS((tIdent pfunc, tTree pARRAY, tTree pINDEXED_ARRAY, tTree pINDEXES, tTree pMASK));
extern tTree mALIGN_STMT ARGS((tTree pALIGNEE, tTree pALIGN_SPEC));
extern tTree mDISTRIBUTE_STMT ARGS((tTree pDISTRIBUTEE, tTree pDISTRIBUTION, tIdent ptarget));
extern tTree mLABEL_USE_LIST ARGS(());
extern tTree mLABEL_EMPTY ARGS(());
extern tTree mLABEL_LIST ARGS((int pElem, tTree pNext));
extern tTree mOP ARGS(());
extern tTree mOP_EQ ARGS(());
extern tTree mOP_NE ARGS(());
extern tTree mOP_LT ARGS(());
extern tTree mOP_GT ARGS(());
extern tTree mOP_GE ARGS(());
extern tTree mOP_LE ARGS(());
extern tTree mOP_PLUS ARGS(());
extern tTree mOP_MINUS ARGS(());
extern tTree mOP_XOR ARGS(());
extern tTree mOP_OR ARGS(());
extern tTree mOP_CONCAT ARGS(());
extern tTree mOP_TIMES ARGS(());
extern tTree mOP_DIVIDE ARGS(());
extern tTree mOP_DIV ARGS(());
extern tTree mOP_AND ARGS(());
extern tTree mOP_EQV ARGS(());
extern tTree mOP_NEQV ARGS(());
extern tTree mOP_EXPO ARGS(());
extern tTree mOP_MOD ARGS(());
extern tTree mOP_IN ARGS(());
extern tTree mOP_DEFINED ARGS((tIdent popname));
extern tTree mOP_ASSIGN ARGS(());
extern tTree mOP_LEFT ARGS(());
extern tTree mOP_RIGHT ARGS(());
extern tTree mOP_LIST ARGS(());
extern tTree mOP_IOR ARGS(());
extern tTree mOP_IXOR ARGS(());
extern tTree mOP_IAND ARGS(());
extern tTree mOP1_NOT ARGS(());
extern tTree mOP1_SIGN ARGS(());
extern tTree mOP1_INOT ARGS(());
extern tTree mOP1_SIZE ARGS(());
extern tTree mOP1_DEC ARGS(());
extern tTree mOP1_INC ARGS(());
extern tTree mOP1_ADDRESS ARGS(());
extern tTree mOP1_DEREF ARGS(());
extern tTree mBT_EXP ARGS(());
extern tTree mDUMMY_EXP ARGS(());
extern tTree mCONST_EXP ARGS((tTree pC));
extern tTree mOP_EXP ARGS((tTree pEXP_OP, tTree pOPND1, tTree pOPND2));
extern tTree mOP1_EXP ARGS((tTree pEXP_OP1, tTree pOPND));
extern tTree mSLICE_EXP ARGS((tTree pSTART, tTree pSTOP, tTree pINC));
extern tTree mPOSTFIX_EXP ARGS((tTree pPOSTFIX_OP, tTree pOPND));
extern tTree mCALL_EXP ARGS((tTree pFUNC_ID, tTree pFUNC_PARAMS));
extern tTree mCAST_EXP ARGS((tTree pID, tTree pCAST));
extern tTree mINDEXED_EXP ARGS((tTree pIND_EXP, tTree pINDEX));
extern tTree mSELECTED_EXP ARGS((tTree pSELEC_EXP, tTree pSELECTOR));
extern tTree mASSIGN_EXP ARGS((tTree pASSIGN_OP, tTree pLHS, tTree pRHS));
extern tTree mUSED_EXP ARGS((tTree pVARNAME));
extern tTree mCOND_EXP ARGS((tTree pCOND, tTree pTRUE_EXP, tTree pFALSE_EXP));
extern tTree mVAR_EXP ARGS((tTree pV));
extern tTree mFUNC_CALL_EXP ARGS((tTree pFUNC_ID, tTree pFUNC_PARAMS));
extern tTree mNAMED_EXP ARGS((tIdent pName, tTree pVAL));
extern tTree mDO_EXP ARGS((tTree pDO_ID, tTree pRANGE, tTree pBODY));
extern tTree mTYPE_EXP ARGS((tTree pID, tTree pELEMENTS));
extern tTree mARRAY_EXP ARGS((tTree pELEMENTS));
extern tTree mBT_EXP_LIST ARGS(());
extern tTree mBTE_EMPTY ARGS(());
extern tTree mBTE_LIST ARGS((tTree pElem, tTree pNext));
extern tTree mBT_VAR ARGS(());
extern tTree mDUMMY_VAR ARGS(());
extern tTree mUSED_VAR ARGS((tTree pVARNAME));
extern tTree mINDEXED_VAR ARGS((tTree pIND_VAR, tTree pIND_EXPS));
extern tTree mSUBSTRING_VAR ARGS((tTree pIND_VAR, tTree pIND_EXP));
extern tTree mSELECTED_VAR ARGS((tTree pSELEC_VAR, tTree pSELECTOR));
extern tTree mLOOP_VAR ARGS((tTree pLOOP_VARNAME));
extern tTree mADDR ARGS((tTree pE));
extern tTree mDO_VAR ARGS((tTree pDO_ID, tTree pRANGE, tTree pBODY));
extern tTree mBT_VAR_LIST ARGS(());
extern tTree mBTV_EMPTY ARGS(());
extern tTree mBTV_LIST ARGS((tTree pElem, tTree pNext));
extern tTree mBT_PARAM ARGS(());
extern tTree mVAR_PARAM ARGS((tTree pV));
extern tTree mVALUE_PARAM ARGS((tTree pE));
extern tTree mNAMED_PARAM ARGS((tIdent pName, tTree pVAL));
extern tTree mPROC_PARAM ARGS((tTree pP));
extern tTree mFUNC_PARAM ARGS((tTree pF));
extern tTree mFORMAT_PARAM ARGS((tStringRef pS));
extern tTree mRETURN_PARAM ARGS((int plabel));
extern tTree mNO_PARAM ARGS(());
extern tTree mBT_PARAM_LIST ARGS(());
extern tTree mBTP_EMPTY ARGS(());
extern tTree mBTP_LIST ARGS((tTree pElem, tTree pNext));
extern tTree mCONSTANT ARGS(());
extern tTree mBOOL_CONSTANT ARGS((int pvalue));
extern tTree mINT_CONSTANT ARGS((int pvalue));
extern tTree mREAL_CONSTANT ARGS((tStringRef pvalue));
extern tTree mDREAL_CONSTANT ARGS((tStringRef pvalue));
extern tTree mCHAR_CONSTANT ARGS((char pvalue));
extern tTree mSTRING_CONSTANT ARGS((tStringRef pvalue));
extern tTree mCOMPLEX_CONSTANT ARGS((tStringRef prvalue, tStringRef pivalue));
extern tTree mPROC_OBJ ARGS((tIdent pIdent));
extern tTree mVAR_OBJ ARGS((int pPos, tIdent pIdent));
extern tTree mTYPE_OBJ ARGS((tIdent pIdent));
extern tTree mREC_COMP ARGS((tIdent pIdent));

extern void WriteTreeNode ARGS((FILE * yyyf, tTree yyt));
extern void WriteTree ARGS((FILE * yyyf, tTree yyt));
extern tTree ReverseTree ARGS((tTree yyOld));
extern tTree CopyTree ARGS((tTree yyt));
extern bool CheckTree ARGS((tTree yyt));
extern void InitTree ARGS((register tTree yyt));
extern void BeginTree ();
extern void CloseTree ();

# endif
