diff -c ./ar.c d:./ar.c
*** ./ar.c	Wed Jun 13 05:47:50 1990
--- d:./ar.c	Thu Aug 06 23:53:56 1992
***************
*** 1,3 ****
--- 1,5 ----
+ /* ar.c -- changed for emx by Eberhard Mattes -- Aug 1992 */
+ 
  /* ar.c - Archive modify and extract.
     Copyright (C) 1988 Free Software Foundation, Inc.
  
***************
*** 29,35 ****
  #ifdef COFF_ENCAPSULATE
  #include "a.out.encap.h"
  #else
! #include <a.out.h>
  #endif
  #endif
  
--- 31,37 ----
  #ifdef COFF_ENCAPSULATE
  #include "a.out.encap.h"
  #else
! #include <a_out.h>
  #endif
  #endif
  
***************
*** 298,303 ****
--- 300,307 ----
    files = 0;
    lock_indesc = -1;
  
+   _response (&argc, &argv);
+   _wildcard (&argc, &argv);
    if (argc < 2)
      usage ("too few command arguments", 0);
  
***************
*** 470,476 ****
       void (*function) ();
       int crflag;
  {
!   FILE *arcstream = fopen (archive, "r");
  
    if (arcstream == 0 && crflag)
      /* Creation-warning, if desired, will happen later.  */
--- 474,480 ----
       void (*function) ();
       int crflag;
  {
!   FILE *arcstream = fopen (archive, "rb");
  
    if (arcstream == 0 && crflag)
      /* Creation-warning, if desired, will happen later.  */
***************
*** 591,597 ****
    FILE *ostream;
  
    fseek (istream, member.data_offset, 0);
!   ostream = fopen (member.name, "w");
    if (!ostream)
      {
        perror_with_name (member.name);
--- 595,601 ----
    FILE *ostream;
  
    fseek (istream, member.data_offset, 0);
!   ostream = fopen (member.name, "wb");
    if (!ostream)
      {
        perror_with_name (member.name);
***************
*** 614,624 ****
        ncopied += tocopy;
      }
  
- #ifdef USG
    chmod (member.name, member.mode);
- #else
-   fchmod (fileno (ostream), member.mode);
- #endif
    if (ferror (ostream) || fclose (ostream) != 0)
      error ("%s: I/O error", member.name);
  
--- 618,624 ----
***************
*** 776,783 ****
  {
    /* Open the existing archive file; if that fails, create an empty one.  */
  
!   lock_indesc = open (archive, O_RDWR, 0);
! 
    if (lock_indesc < 0)
      {
        int outdesc;
--- 776,782 ----
  {
    /* Open the existing archive file; if that fails, create an empty one.  */
  
!   lock_indesc = open (archive, O_RDWR | O_BINARY, 0);
    if (lock_indesc < 0)
      {
        int outdesc;
***************
*** 784,790 ****
  
        if (!silent_create)
  	printf ("Creating archive file `%s'\n", archive);
!       outdesc = open (archive, O_WRONLY | O_APPEND | O_CREAT, 0666);
        if (outdesc < 0)
  	pfatal_with_name (archive);
        mywrite (outdesc, ARMAG, SARMAG, archive);
--- 783,789 ----
  
        if (!silent_create)
  	printf ("Creating archive file `%s'\n", archive);
!       outdesc = open (archive, O_WRONLY | O_APPEND | O_CREAT | O_BINARY, 0666);
        if (outdesc < 0)
  	pfatal_with_name (archive);
        mywrite (outdesc, ARMAG, SARMAG, archive);
***************
*** 792,798 ****
  
        /* Now we had better be able to open for update!  */
  
!       lock_indesc = open (archive, O_RDWR, 0);
        if (lock_indesc < 0)
  	pfatal_with_name (archive);
      }
--- 791,797 ----
  
        /* Now we had better be able to open for update!  */
  
!       lock_indesc = open (archive, O_RDWR | O_BINARY, 0);
        if (lock_indesc < 0)
  	pfatal_with_name (archive);
      }
***************
*** 894,900 ****
  	 There can never be two invocations trying to do this at once,
  	 because of the lock made on the old archive file.  */
  
!       outdesc = open (tempname, O_WRONLY | O_CREAT, 0666);
        if (outdesc < 0)
  	pfatal_with_name (tempname);
        outname = tempname;
--- 893,899 ----
  	 There can never be two invocations trying to do this at once,
  	 because of the lock made on the old archive file.  */
  
!       outdesc = open (tempname, O_WRONLY | O_CREAT | O_BINARY, 0666);
        if (outdesc < 0)
  	pfatal_with_name (tempname);
        outname = tempname;
***************
*** 904,910 ****
      {
        /* Fast-append to existing archive.  */
  
!       outdesc = open (archive, O_WRONLY | O_APPEND, 0);
        if (outdesc < 0)
  	pfatal_with_name (archive);
        outname = archive;
--- 903,909 ----
      {
        /* Fast-append to existing archive.  */
  
!       outdesc = open (archive, O_WRONLY | O_APPEND | O_BINARY, 0);
        if (outdesc < 0)
  	pfatal_with_name (archive);
        outname = archive;
***************
*** 992,1002 ****
  #endif
    close (outdesc);
  
    if (!appendflag)
      if (rename (tempname, archive))
        pfatal_with_name (tempname);
! 
!   close_archive ();
  }
  
  void
--- 991,1003 ----
  #endif
    close (outdesc);
  
+   close_archive ();
    if (!appendflag)
+     {
+     remove (archive);
      if (rename (tempname, archive))
        pfatal_with_name (tempname);
!     }
  }
  
  void
***************
*** 1064,1070 ****
      }
    else
      {
!       indesc = open (mapelt->info.name, 0, 0);
        if (indesc < 0)
  	{
  	  perror_with_name (mapelt->info.name);
--- 1065,1071 ----
      }
    else
      {
!       indesc = open (mapelt->info.name, O_BINARY, 0);
        if (indesc < 0)
  	{
  	  perror_with_name (mapelt->info.name);
***************
*** 1128,1134 ****
  make_tempname (name)
       char *name;
  {
!   return concat (name, "", "_supersede");
  }
  
  void
--- 1129,1135 ----
  make_tempname (name)
       char *name;
  {
!   return concat (name, "", "$!");
  }
  
  void
***************
*** 1380,1386 ****
        return;
      }
  
!   arcstream = fopen (archive, "r");
    if (!arcstream)
      fatal ("failure opening archive %s for the second time", archive);
    map = make_map (0);
--- 1381,1387 ----
        return;
      }
  
!   arcstream = fopen (archive, "rb");
    if (!arcstream)
      fatal ("failure opening archive %s for the second time", archive);
    map = make_map (0);
***************
*** 1584,1590 ****
      }
    else
      {
!       indesc = open (mapelt->info.name, 0, 0);
        if (indesc < 0)
  	{
  	  perror_with_name (mapelt->info.name);
--- 1585,1591 ----
      }
    else
      {
!       indesc = open (mapelt->info.name, O_BINARY, 0);
        if (indesc < 0)
  	{
  	  perror_with_name (mapelt->info.name);
***************
*** 1603,1609 ****
    /* Number of symbol entries in the file.  */
    symcount = syms_size / sizeof (struct nlist);
    /* Allocate temporary space for the symbol entries.  */
!   symbols = (struct nlist *) alloca (syms_size);
    /* Read in the symbols.  */
    lseek (indesc, syms_offset + offset, 0);
    if (read (indesc, (char *) symbols, syms_size) != syms_size)
--- 1604,1610 ----
    /* Number of symbol entries in the file.  */
    symcount = syms_size / sizeof (struct nlist);
    /* Allocate temporary space for the symbol entries.  */
!   symbols = (struct nlist *) xmalloc (syms_size);
    /* Read in the symbols.  */
    lseek (indesc, syms_offset + offset, 0);
    if (read (indesc, (char *) symbols, syms_size) != syms_size)
***************
*** 1611,1616 ****
--- 1612,1618 ----
        error_with_file ("premature end of file in symbols of ", mapelt);
        if (mapelt->info.offset == 0)
  	(void) close (indesc);
+       free (symbols);
        return;
      }
  
***************
*** 1620,1625 ****
--- 1622,1628 ----
        error_with_file ("bad string table size in ", mapelt);
        if (mapelt->info.offset == 0)
  	(void) close (indesc);
+       free (symbols);
        return;
      }
    strs_size -= sizeof (strs_size);
***************
*** 1634,1639 ****
--- 1637,1643 ----
        error_with_file ("premature end of file in strings of ", mapelt);
        if (mapelt->info.offset == 0)
  	(void) close (indesc);
+       free (symbols);
        return;
      }
  
***************
*** 1658,1668 ****
--- 1662,1674 ----
  	  sprintf (buf, "ridiculous string offset %lu in symbol %u of ",
  		   stroff + sizeof (strs_size), i);
  	  error_with_file (buf, mapelt);
+       free (symbols);
  	  return;
  	}
        mapelt->info.symdefs[i].s.name = symname;
        mapelt->info.string_size += strlen (symname) + 1;
      }
+ free (symbols);
  }
  
  /* Choose which symbol entries to mention in __.SYMDEF;
diff -c ./getopt.c d:./getopt.c
*** ./getopt.c	Sat Jun 16 15:19:42 1990
--- d:./getopt.c	Sun May 03 12:42:06 1992
***************
*** 1,3 ****
--- 1,5 ----
+ /* getopt.c -- changed for emx by Eberhard Mattes -- Feb 1992 */
+ 
  /* Getopt for GNU.
     Copyright (C) 1987, 1989 Free Software Foundation, Inc.
  
***************
*** 20,25 ****
--- 22,29 ----
  #else
  #define CONST
  #endif
+ 
+ #include <strings.h>
  
  /* This version of `getopt' appears to the caller like standard Unix `getopt'
     but it behaves differently for the user, since it allows the user
diff -c ./getopt1.c d:./getopt1.c
*** ./getopt1.c	Mon Apr 16 17:51:20 1990
--- d:./getopt1.c	Sun May 03 12:42:06 1992
***************
*** 1,3 ****
--- 1,5 ----
+ /* getopt1.c -- changed for emx by Eberhard Mattes -- Feb 1992 */
+ 
  /* Getopt for GNU.
     Copyright (C) 1987, 1989 Free Software Foundation, Inc.
  
***************
*** 15,20 ****
--- 17,24 ----
     along with this program; if not, write to the Free Software
     Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.  */
  
+ #include <strings.h>
+ 
  #include "getopt.h"
  
  #ifdef __STDC__
diff -c ./ld.c d:./ld.c
*** ./ld.c	Fri Jul 06 11:48:52 1990
--- d:./ld.c	Sat Jan 02 14:42:52 1993
***************
*** 1,3 ****
--- 1,5 ----
+ /* ld.c -- changed for emx by Eberhard Mattes -- Jan 1993 */
+ 
  /* Linker `ld' for GNU
     Copyright (C) 1988 Free Software Foundation, Inc.
  
***************
*** 20,25 ****
--- 22,31 ----
  
  #include <ar.h>
  #include <stdio.h>
+ #if defined (__EMX__)
+ #include <stdlib.h>
+ #include <process.h>        /* for running emxbind */
+ #endif
  #include <sys/types.h>
  #include <sys/stat.h>
  #include <sys/file.h>
***************
*** 39,47 ****
--- 45,57 ----
  #ifdef COFF_ENCAPSULATE
  #include "a.out.encap.h"
  #else
+ #if defined (__EMX__)
+ #include <a_out.h>
+ #else
  #include <a.out.h>
  #endif
  #endif
+ #endif
  
  #ifdef MACH_O
  #ifndef A_OUT
***************
*** 493,498 ****
--- 503,512 ----
  #define N_SETV	0x1C		/* Pointer to set vector in data area.  */
  #endif				/* This is output from LD.  */
  
+ #if defined (__EMX__)
+ #define N_IMP1  0x68            /* Import definition symbol */
+ #endif
+ 
  /* If a this type of symbol is encountered, its name is a warning
     message to print each time the symbol referenced by the next symbol
     table entry is referenced.
***************
*** 835,840 ****
--- 849,862 ----
  /* The name of the file to write; "a.out" by default.  */
  
  char *output_filename;
+ #if defined (__EMX__)
+ char *exe_filename;
+ char *def_filename = NULL;
+ char *res_filename = NULL;
+ int reloc_flag = 0;
+ int dll_flag = 0;
+ int emxbind_strip = 0;
+ #endif
  
  /* What kind of output file to write.  */
  
***************
*** 979,987 ****
--- 1001,1013 ----
  #ifdef NON_NATIVE
    {"/usr/local/lib/gnu"};
  #else
+ #if defined (__EMX__)
+   {"/emx/lib"};
+ #else
    {"/lib", "/usr/lib", "/usr/local/lib"};
  #endif
  #endif
+ #endif
  
  /* If set STANDARD_SEARCH_DIRS is not searched.  */
  int no_standard_dirs;
***************
*** 1010,1017 ****
--- 1036,1045 ----
  #ifndef bcopy
  void bcopy (), bzero ();
  #endif
+ #if !defined (__EMX__)
  char *malloc (), *realloc ();
  void free ();
+ #endif
  
  char *xmalloc ();
  char *xrealloc ();
***************
*** 1045,1050 ****
--- 1073,1081 ----
  char *concat ();
  char *get_file_name ();
  symbol *getsym (), *getsym_soft ();
+ #if defined (__EMX__)
+ void check_exe (void);
+ #endif
  
  int
  main (argc, argv)
***************
*** 1051,1056 ****
--- 1082,1090 ----
       char **argv;
       int argc;
  {
+ #if defined (__EMX__)
+   _response (&argc, &argv);
+ #endif
    page_size = getpagesize ();
    progname = argv[0];
  
***************
*** 1116,1121 ****
--- 1150,1159 ----
  
    decode_command (argc, argv);
  
+ #if defined (__EMX__)
+   check_exe ();
+ #endif
+ 
    /* Load symbols of all input files.
       Also search all libraries and decide which library members to load.  */
  
***************
*** 1172,1177 ****
--- 1210,1218 ----
    {"D", 1, 0, 'D'},
    {"M", 0, 0, 'M'},
    {"N", 0, 0, 'N'},
+ #if defined (__EMX__)
+   {"R", 0, 0, 'R'},
+ #endif
    {"S", 0, 0, 'S'},
    {"T", 1, 0, 'T'},
    {"Ttext", 1, 0, 'T'},
***************
*** 1331,1336 ****
--- 1372,1383 ----
  	  output_style = OUTPUT_WRITABLE_TEXT;
  	  break;
  
+ #if defined (__EMX__)
+         case 'R':
+ 	  reloc_flag = 1;
+ 	  break;
+ #endif
+ 
  	case 'S':
  	  strip_symbols = STRIP_DEBUGGER;
  	  break;
***************
*** 1384,1389 ****
--- 1431,1455 ----
  	{
  	case 1:
  	  /* Non-option argument. */
+ #if defined (__EMX__)
+ 	  {
+ 	    char *ext = _getext (optarg);
+ 	    if (ext != NULL && stricmp (ext, ".def") == 0
+ 		&& def_filename == NULL)
+ 	      {
+ 		def_filename = optarg;
+ 		--number_of_files;
+ 		break;
+ 	      }
+             else if (ext != NULL && stricmp (ext, ".res") == 0
+                      && res_filename == NULL)
+ 	      {
+ 		res_filename = optarg;
+ 		--number_of_files;
+ 		break;
+ 	      }
+ 	  }
+ #endif
  	  p->filename = optarg;
  	  p->local_sym_name = optarg;
  	  p++;
***************
*** 1604,1610 ****
--- 1670,1680 ----
  	{
  	  register char *string
  	    = concat (search_dirs[i], "/", entry->filename);
+ #if defined (__EMX__)
+ 	  desc = open (string, O_RDONLY|O_BINARY, 0);
+ #else
  	  desc = open (string, O_RDONLY, 0);
+ #endif
  	  if (desc > 0)
  	    {
  	      entry->filename = string;
***************
*** 1615,1621 ****
--- 1685,1695 ----
  	}
      }
    else
+ #if defined (__EMX__)
+     desc = open (entry->filename, O_RDONLY|O_BINARY, 0);
+ #else
      desc = open (entry->filename, O_RDONLY, 0);
+ #endif
  
    if (desc > 0)
      {
***************
*** 2113,2118 ****
--- 2187,2196 ----
    for (p = entry->symbols; p < end; p++)
      {
        if (p->n_type == (N_SETV | N_EXT)) continue;
+ #if defined (__EMX__)
+       if (p->n_type == (N_IMP1 | N_EXT))
+         reloc_flag = 1;
+ #endif
        if (set_element_prefixes
  	  && set_element_prefixed_p (p->n_un.n_strx + entry->strings))
  	p->n_type += (N_SETA - N_ABS);
***************
*** 2348,2353 ****
--- 2426,2436 ----
  */
  #endif
  
+ #if defined (__EMX__)
+         case N_IMP1:
+           reftype = "imported";
+           break;
+ #endif
  	default:
  	  reftype = "I don't know this type";
  	  break;
***************
*** 2890,2896 ****
--- 2973,2984 ----
  		    }
  		  set_vectors[setv_fill_count++] = p->n_value;
  		}
+ #if defined (__EMX__)
+ 	      else if ((type & N_EXT) && type != (N_UNDF | N_EXT)
+                        && type != (N_IMP1 | N_EXT))
+ #else
  	      else if ((type & N_EXT) && type != (N_UNDF | N_EXT))
+ #endif
  		{
  		  /* non-common definition */
  		  if (defs++ && sp->value != p->n_value)
***************
*** 3877,3883 ****
--- 3965,3975 ----
  
    outheader.a_syms = nsyms * sizeof (struct nlist);
  
+ #if defined (__EMX__)
+   if (output_style == OUTPUT_RELOCATABLE || reloc_flag)
+ #else
    if (output_style == OUTPUT_RELOCATABLE)
+ #endif
      {
        outheader.a_trsize = text_reloc_size;
        outheader.a_drsize = data_reloc_size;
***************
*** 4501,4506 ****
--- 4593,4633 ----
    fatal ("unknown output file type (enum file_type)", (char *) 0);
  }
  
+ #if defined (__EMX__)
+ /* Parse output_filename and decide whether to create an exe file or not */
+ 
+ void check_exe (void)
+ {
+   char *name, *p;
+   int i;
+ 
+   name = output_filename;
+   for (p = output_filename; *p != 0; ++p)
+     if (*p == ':' || *p == '\\' || *p == '/')
+       name = p + 1;
+   p = strchr (name, '.');
+   if (p == NULL || (stricmp (p+1, "exe") != 0 && stricmp (p+1, "dll") != 0))
+     {
+       exe_filename = NULL;
+       return;
+     }
+   if (stricmp (p+1, "dll") == 0)
+     {
+       reloc_flag = 1; dll_flag = 1;
+     }
+   i = p - output_filename;
+   exe_filename = output_filename;
+   output_filename = xmalloc (i + 1);
+   (void)memcpy (output_filename, exe_filename, i);
+   output_filename[i] = 0;     /* remove .exe */
+   if (strip_symbols == STRIP_ALL)
+     {
+       strip_symbols = STRIP_DEBUGGER;
+       emxbind_strip = 1;
+     }
+ }
+ #endif
+ 
  /* Write the output file */
  
  void
***************
*** 4519,4525 ****
--- 4646,4658 ----
       the way Unix ld works; I'm going to consider it a feature.  */
    (void) unlink (output_filename);
    
+ #if defined (__EMX__)
+   if (exe_filename != NULL)
+     (void)unlink (exe_filename);
+   outdesc = open (output_filename, O_WRONLY | O_CREAT | O_TRUNC | O_BINARY, 0666);
+ #else
    outdesc = open (output_filename, O_WRONLY | O_CREAT | O_TRUNC, 0666);
+ #endif
    if (outdesc < 0) perror_name (output_filename);
  
    if (fstat (outdesc, &statbuf) < 0)
***************
*** 4527,4533 ****
--- 4660,4668 ----
  
    filemode = statbuf.st_mode;
  
+ #if !defined (__EMX__)
    chmod (output_filename, filemode & ~0111);
+ #endif
  
    /* Calculate the offsets of the various pieces of the output file.  */
    compute_section_offsets ();
***************
*** 4537,4543 ****
--- 4672,4682 ----
    write_data ();
  
    /* Output the merged relocation info, if requested with `-r'.  */
+ #if defined (__EMX__)
+   if (output_style == OUTPUT_RELOCATABLE || reloc_flag)
+ #else
    if (output_style == OUTPUT_RELOCATABLE)
+ #endif
      write_rel ();
  
    /* Output the symbol table (both globals and locals).  */
***************
*** 4560,4565 ****
--- 4699,4750 ----
  
    if (chmod (output_filename, filemode | (0111 & ~mask)) == -1)
      perror_name (output_filename);
+ 
+ #if defined (__EMX__)
+   if (exe_filename != NULL)
+     {
+       char *nargv[9];
+       char emxl_path[512];
+       int i;
+ 
+       i = 0;
+       nargv[i++] = "emxbind";
+       nargv[i++] = "-bq";
+       if (emxbind_strip)
+         nargv[i++] = "-s";
+       if (def_filename != NULL)
+ 	{
+ 	  nargv[i] = alloca (strlen (def_filename) + 3);
+ 	  strcpy (nargv[i], "-d");
+ 	  strcat (nargv[i], def_filename);
+ 	  i++;
+ 	}
+       else if (dll_flag)
+ 	nargv[i++] = "-d";
+       if (res_filename != NULL)
+ 	{
+ 	  nargv[i] = alloca (strlen (res_filename) + 3);
+ 	  strcpy (nargv[i], "-r");
+ 	  strcat (nargv[i], res_filename);
+ 	  i++;
+ 	}
+       if (_path (emxl_path, "emxl.exe") == 0)
+ 	nargv[i++] = emxl_path;
+       else
+ 	nargv[i++] = "/emx/bin/emxl.exe";
+       nargv[i++] = output_filename;
+       nargv[i++] = exe_filename;
+       nargv[i] = NULL;
+       i = spawnvp (P_WAIT, "emxbind", (const char * const *)nargv);
+       if (i < 0)
+         perror_name ("emxbind");
+       else if (i != 0)
+         fatal ("emxbind failed\n", NULL);
+       (void)unlink (output_filename);
+       if (chmod (exe_filename, filemode | (0111 & ~mask)) == -1)
+ 	perror_name (exe_filename);
+     }
+ #endif
  }
  
  void modify_location (), perform_relocation (), copy_text (), copy_data ();
***************
*** 4661,4667 ****
--- 4846,4856 ----
    /* Deal with relocation information however is appropriate */
  
    if (entry->textrel)  reloc = entry->textrel;
+ #if defined (__EMX__)
+   else if (output_style == OUTPUT_RELOCATABLE || reloc_flag)
+ #else
    else if (output_style == OUTPUT_RELOCATABLE)
+ #endif
      {
        read_file_relocation (entry);
        reloc = entry->textrel;
***************
*** 4743,4749 ****
--- 4932,4942 ----
    bytes = (char *) alloca (entry->data_size);
  
    if (entry->datarel) reloc = entry->datarel;
+ #if defined (__EMX__)
+   else if (output_style == OUTPUT_RELOCATABLE || reloc_flag) /* Will need this again */
+ #else
    else if (output_style == OUTPUT_RELOCATABLE)	/* Will need this again */
+ #endif
      {
        read_file_relocation (entry);
        reloc = entry->datarel;
***************
*** 5040,5046 ****
--- 5233,5243 ----
  	  /* If the symbol is now defined, change the external relocation
  	     to an internal one.  */
  
+ #if defined (__EMX__)
+ 	  if (symptr->defined && symptr->defined != (N_IMP1 | N_EXT))
+ #else
  	  if (symptr->defined)
+ #endif
  	    {
  	      RELOC_EXTERN_P(p) = 0;
  	      RELOC_SYMBOL(p) = (symptr->defined & ~N_EXT);
***************
*** 5206,5212 ****
--- 5403,5413 ----
    lseek (outdesc, output_strs_offset + output_strs_size, 0);
  
    if (!outstream)
+ #if defined (__EMX__)
+     outstream = fdopen (outdesc, "wb");
+ #else
      outstream = fdopen (outdesc, "w");
+ #endif
  
    for (i = 0; i < strtab_index; i++)
      {
***************
*** 5425,5431 ****
--- 5626,5646 ----
        struct nlist nl;
  
        nl.n_type = N_TEXT;
+ #if defined (__EMX__)
+       {
+         char *tmp;
+         int len;
+ 
+         tmp = entry->local_sym_name;
+         len = strlen (tmp);
+         if (strncmp (tmp, "-l", 2) != 0
+             && (len < 2 || strcmp (tmp+len-2, ".o") != 0))
+           tmp = concat (tmp, ".o", "");   /* Needed by GDB */
+         nl.n_un.n_strx = assign_string_table_index (tmp);
+       }
+ #else
        nl.n_un.n_strx = assign_string_table_index (entry->local_sym_name);
+ #endif
        nl.n_value = entry->text_start_address;
        nl.n_desc = 0;
  #ifdef N_SECT
***************
*** 5783,5790 ****
--- 5998,6007 ----
  perror_name (name)
       char *name;
  {
+ #if !defined (__EMX__)
    extern int errno, sys_nerr;
    extern char *sys_errlist[];
+ #endif
    char *s;
  
    if (errno < sys_nerr)
***************
*** 5801,5808 ****
--- 6018,6027 ----
  perror_file (entry)
       struct file_entry *entry;
  {
+ #if !defined (__EMX__)
    extern int errno, sys_nerr;
    extern char *sys_errlist[];
+ #endif
    char *s;
  
    if (errno < sys_nerr)
diff -c ./Makefile d:./makefile
*** ./makefile	Thu Jun 21 17:05:48 1990
--- d:./makefile	Sun May 03 12:42:18 1992
***************
*** 19,29 ****
  # the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
  
  
! GNUCC = gcc -O
! bindir=/usr/local/bin
  
! # for BSD systems
! CFLAGS = -g
  # Don't add robotussin; it won't compile on BSD or GNU systems.
  # objdump is not here because it (at least used to) not compile
  # on most systems (trouble with N_DATADDR).  I've fixed some of
--- 19,34 ----
  # the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
  
  
! GNUCC = gcc
! CC = gcc
! bindir=/emx/bin
  
! .c.o:
! 	$(CC) $(CFLAGS) -c $*.c
! 
! # for emx (-g breaks ar!)
! CFLAGS = -O -I. -B/emx/bin/ -DEMX
! 
  # Don't add robotussin; it won't compile on BSD or GNU systems.
  # objdump is not here because it (at least used to) not compile
  # on most systems (trouble with N_DATADDR).  I've fixed some of
***************
*** 74,89 ****
  # rounds this up to a power of two (e.g. 5M becomes 8M), and so it might 
  # fail unnecessarily.  I've also seen some unix malloc's fail, even when
  # there is enough memory.  So use the new GNU malloc.
! MALLOC = $(archpfx)gmalloc.o
  
  GNU_GETOPT = $(archpfx)getopt.o
  GNU_GETOPT_LONG = $(archpfx)getopt.o $(archpfx)getopt1.o
  
  # C++ demangler
! CPLUS_DEM = $(archpfx)cplus-dem.o
  
  LIBS=$(ALLOCALIBS) $(SIGNAME)
  
  all: $(PROGS)
  
  $(archpfx)ld: $(archpfx)ld.o $(GNU_GETOPT_LONG) $(CPLUS_DEM)
--- 79,96 ----
  # rounds this up to a power of two (e.g. 5M becomes 8M), and so it might 
  # fail unnecessarily.  I've also seen some unix malloc's fail, even when
  # there is enough memory.  So use the new GNU malloc.
! # MALLOC = $(archpfx)gmalloc.o
  
  GNU_GETOPT = $(archpfx)getopt.o
  GNU_GETOPT_LONG = $(archpfx)getopt.o $(archpfx)getopt1.o
  
  # C++ demangler
! CPLUS_DEM = $(archpfx)cplus-de.o
  
  LIBS=$(ALLOCALIBS) $(SIGNAME)
  
+ bin4emx: ar ld size nm objdump strip
+ 
  all: $(PROGS)
  
  $(archpfx)ld: $(archpfx)ld.o $(GNU_GETOPT_LONG) $(CPLUS_DEM)
***************
*** 115,121 ****
  $(archpfx)ranlib.o: ranlib.c
  	$(CC) -c $(CFLAGS) -DAR_PROG=\"$(bindir)/ar\" ranlib.c $(OUTPUT_OPTION)
  
! $(archpfx)objdump: $(archpfx)objdump.o $(GNU_GETOPT_LONG) a.out.gnu.h
  	$(CC) $(CFLAGS) -o $(archpfx)objdump $(archpfx)objdump.o \
  		$(GNU_GETOPT_LONG) $(LIBS)
  
--- 122,128 ----
  $(archpfx)ranlib.o: ranlib.c
  	$(CC) -c $(CFLAGS) -DAR_PROG=\"$(bindir)/ar\" ranlib.c $(OUTPUT_OPTION)
  
! $(archpfx)objdump: $(archpfx)objdump.o $(GNU_GETOPT_LONG)
  	$(CC) $(CFLAGS) -o $(archpfx)objdump $(archpfx)objdump.o \
  		$(GNU_GETOPT_LONG) $(LIBS)
  
***************
*** 131,139 ****
  	libconvert usg-gnulib gnulib
  
  clean:
! 	-rm -f *.o core
! 	-rm -f $(archpfx)*.o
! 	-rm -f $(PROGS)
  
  dist: binutils.tar.Z
  
--- 138,150 ----
  	libconvert usg-gnulib gnulib
  
  clean:
! 	-del *.o
! 	-del ar
! 	-del ld
! 	-del nm
! 	-del objdump
! 	-del size
! 	-del strip
  
  dist: binutils.tar.Z
  
diff -c ./nm.c d:./nm.c
*** ./nm.c	Tue Jun 12 02:47:34 1990
--- d:./nm.c	Sun Nov 01 18:28:28 1992
***************
*** 1,3 ****
--- 1,5 ----
+ /* nm.c -- changed for emx by Eberhard Mattes -- Nov 1992 */
+ 
  /* Describe symbol table of a rel file.
     Copyright (C) 1986, 1988 Free Software Foundation, Inc.
  
***************
*** 30,38 ****
--- 32,44 ----
  #include "a.out.encap.h"
  #else
  /* On native BSD systems, use the system's own a.out.h.  */
+ #if defined (__EMX__)
+ #include <a_out.h>
+ #else
  #include <a.out.h>
  #endif
  #endif
+ #endif
  
  #ifdef MACH_O
  #ifndef A_OUT
***************
*** 83,88 ****
--- 89,97 ----
  
  /* C++ demangler stuff.  */
  char *cplus_demangle ();
+ #if defined (__EMX__)
+ extern int no_demangle;
+ #endif
  
  /* Print NAME on STREAM, demangling if necessary.  */
  void
***************
*** 90,96 ****
--- 99,109 ----
       FILE *stream;
       char *name;
  {
+ #if defined (__EMX__)
+   char *demangled = no_demangle ? NULL : cplus_demangle (name);
+ #else
    char *demangled = cplus_demangle (name);
+ #endif
    if (demangled == NULL)
      fputs (name, stream);
    else
***************
*** 210,215 ****
--- 223,231 ----
  int file_on_each_line;	/* print file name on each line.  */
  int debugger_syms;	/* print the debugger-only symbols.  */
  int print_symdefs;	/* describe the __.SYMDEF data in any archive file specified.  */
+ #if defined (__EMX__)
+ int no_demangle;        /* do not demangle C++ names */
+ #endif
  
  /* The __.SYMDEF member of an archive has the following format:
     1) A longword saying the size of the symdef data that follows
***************
*** 258,266 ****
--- 274,288 ----
        {"reverse",	0, &reverse_sort,	1},
        {"print-symdefs",	0, &print_symdefs,	1},
        {"undefined-only",0, &undefined_only,	1},
+ #if defined (__EMX__)
+       {"no-demangle",   0, &no_demangle,	1},
+ #endif
        {NULL, 0, NULL, 0}
      };
  
+ #if defined (__EMX__)
+   _wildcard (&argc, &argv);
+ #endif
    program_name = argv[0];
  
    number_of_files = 0;
***************
*** 272,279 ****
--- 294,308 ----
    file_on_each_line = 0;
    debugger_syms = 0;
    print_symdefs = 0;
+ #if defined (__EMX__)
+   no_demangle = 0;
+ #endif
  
+ #if defined (__EMX__)
+   while ((c = getopt_long (argc, argv, "agnoprsud", long_options, &ind)) != EOF)
+ #else
    while ((c = getopt_long (argc, argv, "agnoprsu", long_options, &ind)) != EOF)
+ #endif
      switch (c)
        {
        case 0:
***************
*** 311,316 ****
--- 340,350 ----
  	undefined_only = 1;
  	break;
  
+ #if defined (__EMX__)
+       case 'd':
+ 	no_demangle = 1;
+ 	break;
+ #endif
        default:
  	fprintf (stderr, "\
  Usage: %s [-agnoprsu] [+all] [+extern-only] [+numeric-sort]\n\
***************
*** 351,358 ****
--- 385,399 ----
  {
    int len, desc, nchars;
    char armag[SARMAG];
+ #if defined (__EMX__)
+   long hdr_pos;
+ #endif
  
+ #if defined (__EMX__)
+   desc = open (name, O_RDONLY | O_BINARY, 0);
+ #else
    desc = open (name, O_RDONLY, 0);
+ #endif
  
    if (desc < 0)
      {
***************
*** 363,373 ****
--- 404,421 ----
    input_name = name;
    input_member = 0;
  
+ #if defined (__EMX__)
+   _seek_hdr (desc); hdr_pos = tell (desc);
+ #endif
    nchars = read (desc, armag, SARMAG);
    if (nchars == SARMAG && !strncmp(armag, ARMAG, SARMAG))
      scan_library (desc);
    else
+ #if defined (__EMX__)
+     do_one_rel_file (desc, hdr_pos);
+ #else
      do_one_rel_file (desc, 0);
+ #endif
  
    close (desc);
  }
diff -c ./objdump.c d:./objdump.c
*** ./objdump.c	Sat Dec 30 00:16:06 1989
--- d:./objdump.c	Sun May 03 12:42:22 1992
***************
*** 1,3 ****
--- 1,5 ----
+ /* objdump.c -- changed for emx by Eberhard Mattes -- Jan 1992 */
+ 
  /* objdump -- dump information about an object file.
     Copyright (C) 1988, Free Software Foundation, Inc.
  
***************
*** 22,42 ****
   * refer to the manual page dump(1) in the system 5 program's reference manual
   */
  #include <stdio.h>
  #include "getopt.h"
  
  #ifndef COFF_ENCAPSULATE
! #include <a.out.h>
! /* Tell a.out.gnu.h not to try to redefine some things.  */
! #define __STRUCT_EXEC_OVERRIDE__
! #define N_NLIST_DECLARED
! #define N_RELOCATION_INFO_DECLARED
! #define N_MAGIC(exec) ((exec).a_magic)
! #include "a.out.gnu.h"
  #else
  #include "a.out.encap.h"
  #endif
  
! char *malloc();
  char *xmalloc();
  int nsyms;
  struct nlist *symtbl;
--- 24,41 ----
   * refer to the manual page dump(1) in the system 5 program's reference manual
   */
  #include <stdio.h>
+ #include <stdlib.h>
  #include "getopt.h"
  
  #ifndef COFF_ENCAPSULATE
! #include <a_out.h>
  #else
  #include "a.out.encap.h"
  #endif
  
! #define HEADER_SEEK(f) _fseek_hdr(f)
! static long hdr_pos;
! 
  char *xmalloc();
  int nsyms;
  struct nlist *symtbl;
***************
*** 58,64 ****
  
  	symtbl = (struct nlist *)xmalloc (nsyms * sizeof (struct nlist));
  
! 	fseek (f, N_STROFF(*execp), 0);
  	if (fread ((char *)&strsize, sizeof strsize, 1, f) != 1) {
  		fprintf (stderr, "%s: can not read string table size\n",
  			 program_name);
--- 57,63 ----
  
  	symtbl = (struct nlist *)xmalloc (nsyms * sizeof (struct nlist));
  
!     fseek (f, N_STROFF(*execp) + hdr_pos, 0);
  	if (fread ((char *)&strsize, sizeof strsize, 1, f) != 1) {
  		fprintf (stderr, "%s: can not read string table size\n",
  			 program_name);
***************
*** 65,71 ****
  		exit (1);
  	}
  	strtbl = xmalloc (strsize);
! 	fseek (f, N_STROFF (*execp), 0);
  	if (fread (strtbl, 1, strsize, f) != strsize) {
  		fprintf (stderr, "%s: error reading string table\n",
  			 program_name);
--- 64,70 ----
  		exit (1);
  	}
  	strtbl = xmalloc (strsize);
!     fseek (f, N_STROFF (*execp) + hdr_pos, 0);
  	if (fread (strtbl, 1, strsize, f) != strsize) {
  		fprintf (stderr, "%s: error reading string table\n",
  			 program_name);
***************
*** 72,78 ****
  		exit (1);
  	}
  
! 	fseek (f, N_SYMOFF (*execp), 0);
  	if (fread ((char *)symtbl, sizeof (struct nlist), nsyms, f) != nsyms) {
  		fprintf (stderr, "%s: error reading symbol table\n",
  			 program_name);
--- 71,77 ----
  		exit (1);
  	}
  
!     fseek (f, N_SYMOFF (*execp) + hdr_pos, 0);
  	if (fread ((char *)symtbl, sizeof (struct nlist), nsyms, f) != nsyms) {
  		fprintf (stderr, "%s: error reading symbol table\n",
  			 program_name);
***************
*** 133,138 ****
--- 132,138 ----
  	    {NULL, 0, NULL, 0}
  	  };
  
+     _wildcard (&argc, &argv);
  	page_size = getpagesize ();
  
  	program_name = argv[0];
***************
*** 164,170 ****
  	FILE *f;
  	struct exec exec;
  	printf ("%s:\n", name);
! 	f = fopen (name, "r");
  	if (f == NULL) {
  		fprintf (stderr, "%s: can not open ", program_name);
  		perror (name);
--- 164,170 ----
  	FILE *f;
  	struct exec exec;
  	printf ("%s:\n", name);
!         f = fopen (name, "rb");
  	if (f == NULL) {
  		fprintf (stderr, "%s: can not open ", program_name);
  		perror (name);
***************
*** 173,178 ****
--- 173,179 ----
  #ifdef HEADER_SEEK
  	HEADER_SEEK (f);
  #endif
+ 	hdr_pos = ftell (f);
  	if (fread ((char *)&exec, sizeof exec, 1, f) != 1) {
  		fprintf (stderr, "%s: can not read header for %s\n",
  			 program_name, name);
***************
*** 207,215 ****
  	int x;
  
  #if defined (__GNU_EXEC_MACROS__) && !defined (__STRUCT_EXEC_OVERRIDE__)
! 	printf ("magic: 0x%x (%o)", N_MAGIC(*execp), N_MAGIC(*execp));
! 	printf ("machine type: %d", N_MACHTYPE(*execp));
! 	printf ("flags: 0x%x", N_FLAGS(*execp));
  #else /* non-gnu struct exec.  */
  	printf ("magic: 0x%x (%o) ", execp->a_magic, execp->a_magic);
  #endif /* non-gnu struct exec.  */
--- 208,216 ----
  	int x;
  
  #if defined (__GNU_EXEC_MACROS__) && !defined (__STRUCT_EXEC_OVERRIDE__)
! 	printf ("magic: 0x%x (%o) ", N_MAGIC(*execp), N_MAGIC(*execp));
! 	printf ("machine type: %d ", N_MACHTYPE(*execp));
! 	printf ("flags: 0x%x ", N_FLAGS(*execp));
  #else /* non-gnu struct exec.  */
  	printf ("magic: 0x%x (%o) ", execp->a_magic, execp->a_magic);
  #endif /* non-gnu struct exec.  */
***************
*** 269,279 ****
  	read_symbols (execp, f);
  	if (execp->a_trsize) {
  		printf ("text reloc\n");
! 		dump_reloc1 (execp, f, N_TRELOFF (*execp), execp->a_trsize);
  	}
  	if (execp->a_drsize) {
  		printf ("data reloc\n");
! 		dump_reloc1 (execp, f, N_DRELOFF (*execp), execp->a_drsize);
  	}
  }
  
--- 270,280 ----
  	read_symbols (execp, f);
  	if (execp->a_trsize) {
  		printf ("text reloc\n");
!         dump_reloc1 (execp, f, N_TRELOFF (*execp) + hdr_pos, execp->a_trsize);
  	}
  	if (execp->a_drsize) {
  		printf ("data reloc\n");
!         dump_reloc1 (execp, f, N_DRELOFF (*execp) + hdr_pos, execp->a_drsize);
  	}
  }
  
diff -c ./size.c d:./size.c
*** ./size.c	Tue Jun 12 02:56:50 1990
--- d:./size.c	Sun May 03 12:42:22 1992
***************
*** 1,3 ****
--- 1,5 ----
+ /* size.c -- changed for emx by Eberhard Mattes -- Jan 1992 */
+ 
  /* Size of rel file utility (`size') for GNU.
     Copyright (C) 1986 Free Software Foundation, Inc.
  
***************
*** 16,21 ****
--- 18,24 ----
     Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.  */
  
  #include <stdio.h>
+ #include <stdlib.h>
  #include <ar.h>
  #include <sys/types.h>
  #include <sys/file.h>
***************
*** 29,35 ****
  #include "a.out.encap.h"
  #else
  /* On native BSD systems, use the system's own a.out.h.  */
! #include <a.out.h>
  #endif
  #endif
  
--- 32,38 ----
  #include "a.out.encap.h"
  #else
  /* On native BSD systems, use the system's own a.out.h.  */
! #include <a_out.h>
  #endif
  #endif
  
***************
*** 61,67 ****
  
  int member_offset;
  
- char *malloc ();
  
  void do_one_file (), do_one_rel_file ();
  char *xmalloc ();
--- 64,69 ----
***************
*** 73,78 ****
--- 75,81 ----
  {
    int i;
  
+   _wildcard (&argc, &argv);
    number_of_files = argc - 1;
  
    printf ("text\tdata\tbss\tdec\thex\n");
***************
*** 106,113 ****
  {
    int len, desc;
    char armag[SARMAG];
  
!   desc = open (name, O_RDONLY, 0);
  
    if (desc < 0)
      {
--- 109,117 ----
  {
    int len, desc;
    char armag[SARMAG];
+   long hdr_pos;      /* emx */
  
!   desc = open (name, O_RDONLY | O_BINARY, 0);
  
    if (desc < 0)
      {
***************
*** 118,125 ****
    input_name = name;
    input_member = 0;
  
    if (SARMAG != read (desc, armag, SARMAG) || strncmp (armag, ARMAG, SARMAG))
!     do_one_rel_file (desc, 0L);
    else
      scan_library (desc);
  
--- 122,131 ----
    input_name = name;
    input_member = 0;
  
+   _seek_hdr (desc); hdr_pos = tell (desc);
+ 
    if (SARMAG != read (desc, armag, SARMAG) || strncmp (armag, ARMAG, SARMAG))
!     do_one_rel_file (desc, hdr_pos);
    else
      scan_library (desc);
  
***************
*** 345,352 ****
  perror_name (name)
       char *name;
  {
-   extern int errno, sys_nerr;
-   extern char *sys_errlist[];
    char *s;
  
    if (errno < sys_nerr)
--- 351,356 ----
diff -c ./strip.c d:./strip.c
*** ./strip.c	Mon Jun 11 21:40:00 1990
--- d:./strip.c	Sun May 03 12:42:24 1992
***************
*** 1,3 ****
--- 1,5 ----
+ /* strip.c -- changed for emx by Eberhard Mattes -- Jan 1992 */
+ 
  /* strip certain symbols from a rel file.
     Copyright (C) 1986 Free Software Foundation, Inc.
  
***************
*** 16,21 ****
--- 18,24 ----
     Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.  */
  
  #include <stdio.h>
+ #include <stdlib.h>
  #include <sys/types.h>
  #include <sys/file.h>
  #include <sys/stat.h>
***************
*** 38,44 ****
  #include "a.out.encap.h"
  #else
  /* On native BSD systems, use the system's own a.out.h.  */
! #include <a.out.h>
  #endif
  #endif
  
--- 41,47 ----
  #include "a.out.encap.h"
  #else
  /* On native BSD systems, use the system's own a.out.h.  */
! #include <a_out.h>
  #endif
  #endif
  
***************
*** 138,145 ****
  /* 1 => discard locals starting with L; 2 => discard all locals */
  int discard_locals;
  
- char *malloc ();
- 
  void strip_file ();
  int file_open ();
  void rewrite_file_symbols(), file_close();
--- 141,146 ----
***************
*** 169,174 ****
--- 170,176 ----
    struct file_entry *p;
    int i;
  
+   _wildcard (&argc, &argv);
    strip_symbols = 0;   /* default is to strip everything.  */
    discard_locals = 0;
  
***************
*** 224,239 ****
    exit (0);
  }
  
- int delayed_signal;
- 
- void
- delay_signal (signo)
-      int signo;
- {
-   delayed_signal = signo;
-   signal (signo, delay_signal);
- }
- 
  /* process one input file */
  
  void
--- 226,231 ----
***************
*** 262,275 ****
      }
  
    /* Effectively defer handling of asynchronous kill signals.  */
!   delayed_signal = 0;
!   if (signal (SIGINT, SIG_IGN) != SIG_IGN)
!     sigint_handled = 1, signal (SIGINT, delay_signal);
!   if (signal (SIGHUP, SIG_IGN) != SIG_IGN)
!     sighup_handled = 1, signal (SIGHUP, delay_signal);
!   if (signal (SIGTERM, SIG_IGN) != SIG_IGN)
!     sigterm_handled = 1, signal (SIGTERM, delay_signal);
! 
    /* Change the file.  */
  
    rewrite_file_symbols (entry);
--- 254,260 ----
      }
  
    /* Effectively defer handling of asynchronous kill signals.  */
!   /* -- deleted for emx */
    /* Change the file.  */
  
    rewrite_file_symbols (entry);
***************
*** 279,294 ****
    file_close ();
  
    /* Effectively undefer handling.  */
!   if (sigint_handled)
!     signal (SIGINT, SIG_DFL);
!   if (sighup_handled)
!     signal (SIGHUP, SIG_DFL);
!   if (sigterm_handled)
!     signal (SIGTERM, SIG_DFL);
! 
!   /* Handle any signal that came in while they were deferred.  */
!   if (delayed_signal)
!     kill (getpid (), delayed_signal);
  }
  
  /** Convenient functions for operating on one or all files being processed.  */
--- 264,270 ----
    file_close ();
  
    /* Effectively undefer handling.  */
!   /* -- deleted for emx */
  }
  
  /** Convenient functions for operating on one or all files being processed.  */
***************
*** 314,320 ****
    int desc;
    int len, magicnum;
  
!   desc = open (entry->filename, O_RDWR, 0);
  
    if (desc > 0)
      {
--- 290,296 ----
    int desc;
    int len, magicnum;
  
!   desc = open (entry->filename, O_RDWR | O_BINARY, 0);
  
    if (desc > 0)
      {
***************
*** 845,852 ****
  perror_name (name)
       char *name;
  {
-   extern int errno, sys_nerr;
-   extern char *sys_errlist[];
    char *s;
  
    if (errno < sys_nerr)
--- 821,826 ----
***************
*** 862,870 ****
  perror_file (entry)
       struct file_entry *entry;
  {
!   extern int errno, sys_nerr;
!   extern char *sys_errlist[];
!   char *s;
  
    if (errno < sys_nerr)
      s = sys_errlist[errno];
--- 836,842 ----
  perror_file (entry)
       struct file_entry *entry;
  {
!   const char *s;
  
    if (errno < sys_nerr)
      s = sys_errlist[errno];
***************
*** 876,882 ****
  /* Report an error.   STRING is printed, and the filename of ENTRY.  */
  
  error_with_file (string, entry, arg1, arg2)
!      char *string;
       struct file_entry *entry;
       int arg1, arg2;
  {
--- 848,854 ----
  /* Report an error.   STRING is printed, and the filename of ENTRY.  */
  
  error_with_file (string, entry, arg1, arg2)
!      const char *string;
       struct file_entry *entry;
       int arg1, arg2;
  {
