/* config.h -- changed for emx by Eberhard Mattes -- Dec 1992 */

/* Configuration for GNU C-compiler for Intel 80386.
   Copyright (C) 1988 Free Software Foundation, Inc.

This file is part of GNU CC.

GNU CC is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2, or (at your option)
any later version.

GNU CC is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with GNU CC; see the file COPYING.  If not, write to
the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.  */

#ifndef i386
#define i386
#endif

/* #defines that need visibility everywhere.  */
#define FALSE 0
#define TRUE 1

/* This describes the machine the compiler is hosted on.  */
#define HOST_BITS_PER_CHAR 8
#define HOST_BITS_PER_SHORT 16
#define HOST_BITS_PER_INT 32
#define HOST_BITS_PER_LONG 32
#define HOST_BITS_PER_LONGLONG 64

/* Arguments to use with `exit'.  */
#define SUCCESS_EXIT_CODE 0
#define FATAL_EXIT_CODE 33

/* If compiled with GNU C, use the built-in alloca */
#ifdef __GNUC__
#define alloca __builtin_alloca
#endif

#define YES_UNDERSCORES

/* target machine dependencies.
   tm.h is a symbolic link to the actual target specific file.   */

#include "tm.h"

#ifndef __EMX__
#define __EMX__
#endif
#define USG
#define GCC_INCLUDE_DIR            "/emx/include"
#define GPLUSPLUS_INCLUDE_DIR      "/emx/include.gpp"
#define LOCAL_INCLUDE_DIR          "/usr/local/include"
#define CROSS_INCLUDE_DIR          "/emx/include.sys"
#define STANDARD_EXEC_PREFIX       "/emx/bin/"
#define STANDARD_STARTFILE_PREFIX  "/emx/lib/"
#define DEFAULT_TARGET_MACHINE     "emx"
#define EXECUTABLE_SUFFIX          ".exe"
#define PATH_SEPARATOR             ';'
#define HANDLE_SYSV_PRAGMA
#undef PCC_BITFIELD_TYPE_MATTERS
#define PCC_BITFIELD_TYPE_MATTERS (maximum_field_alignment == 0)
#undef  SDB_DEBUGGING_INFO
#define DBX_DEBUGGING_INFO
#define MKTEMP_EACH_FILE
#define ASM_SPEC "%{Zwait:-w}"

#undef CPP_PREDEFINES
#define CPP_PREDEFINES "-D__32BIT__ -D__EMX__ -Di386"

#undef CPP_SPEC
#define CPP_SPEC "%{posix:-D_POSIX_SOURCE} %{Zmt:-D__MT__}"

#define ASM_FINAL_SPEC "%{Zomf:\n emxomf %{s} %{c:%W{o*}%{!o*:-o %w%b.obj}}\
                                         %{!c:-o %d%w%b.obj} %g.o}"

#define STARTFILE_SPEC \
  "%{Zomf:%{Zdll:dll0.obj%s}%{!Zdll:crt0.obj%s}}" \
  "%{!Zomf:%{Zdll:dll0.o%s}" \
          "%{!Zdll:%{pg:gcrt0.o%s}%{!pg:%{p:mcrt0.o%s}%{!p:crt0.o%s}}}}"

#undef SUBTARGET_SWITCHES
#define SUBTARGET_SWITCHES  \
    { "probe", 0400},				\
    { "no-probe", -0400},

/* Use a stack probe */
#define TARGET_PROBE (target_flags & 0400)

/* Original value, defined in config/unx386.h: 0301 */
#if 0                           /* -mno-probe is the default now */
#undef TARGET_DEFAULT
#define TARGET_DEFAULT 0701     /* add -mprobe */
#endif

#define PROBE_SIZE         0x1000
#define PROBE_MAX_INLINE   0x10000
