diff -c gcc-2.3/aux-outp.c d:gcc-2.3/aux-outp.c
*** gcc-2.3/aux-outp.c	Mon Dec 28 23:10:58 1992
--- d:gcc-2.3/aux-outp.c	Sun Dec 27 20:59:52 1992
***************
*** 1,3 ****
--- 1,5 ----
+ /* aux-outp.c -- changed for emx by Eberhard Mattes -- Dec 1992 */
+ 
  /* Subroutines for insn-output.c for Intel 80386.
     Copyright (C) 1988, 1992 Free Software Foundation, Inc.
  
***************
*** 651,657 ****
--- 653,663 ----
  {
    register int regno;
    int limit;
+ #ifdef __EMX__
+   rtx xops[5];
+ #else
    rtx xops[4];
+ #endif
    int pic_reg_used = flag_pic && (current_function_uses_pic_offset_table
  				  || current_function_uses_const_pool);
  
***************
*** 665,671 ****
--- 671,705 ----
      }
  
    if (size)
+ #ifdef __EMX__
+     {
+       if (TARGET_PROBE && size >= PROBE_SIZE)
+         {
+         if (size > PROBE_MAX_INLINE)
+           {
+             output_asm_insn (AS1 (push%L0,%2), xops);
+             output_asm_insn (AS1 (call,___probe), xops);
+           }
+         else
+           {
+             int i = size, j = 0;
+             xops[3] = const0_rtx;
+             while (i >= PROBE_SIZE)
+               {
+                 i -= PROBE_SIZE; j += PROBE_SIZE;
+                 xops[4] = gen_rtx (MEM, QImode,
+                             gen_rtx (PLUS, SImode,
+                               gen_rtx (REG, SImode, 7),
+                               gen_rtx (CONST_INT, VOIDmode, -j)));
+                 output_asm_insn (AS2 (movb,%3,%4), xops);
+               }
+           }
+         }
+       output_asm_insn (AS2 (sub%L0,%2,%0), xops);
+     }
+ #else
      output_asm_insn (AS2 (sub%L0,%2,%0), xops);
+ #endif
  
    /* Note If use enter it is NOT reversed args.
       This one is not reversed from intel!!
diff -c gcc-2.3/cccp.c d:gcc-2.3/cccp.c
*** gcc-2.3/cccp.c	Sun Dec 27 20:25:04 1992
--- d:gcc-2.3/cccp.c	Sun Dec 27 20:59:58 1992
***************
*** 1,3 ****
--- 1,5 ----
+ /* cccp.c -- changed for emx by Eberhard Mattes -- Dec 1992 */
+ 
  /* C Compatible Compiler Preprocessor (CCCP)
  Copyright (C) 1986, 1987, 1989, 1992 Free Software Foundation, Inc.
                      Written by Paul Rubin, June 1986
***************
*** 401,407 ****
--- 403,413 ----
  static int pcp_inside_if;
  
  /* Nonzero means never to include precompiled files. */
+ #ifdef __EMX__
+ static int no_precomp = 1;
+ #else
  static int no_precomp;
+ #endif
  
  /* Nonzero means give all the error messages the ANSI standard requires.  */
  
Common subdirectories: gcc-2.3/config and d:gcc-2.3/config
diff -c gcc-2.3/config.h d:gcc-2.3/config.h
*** gcc-2.3/config.h	Mon Dec 28 23:10:54 1992
--- d:gcc-2.3/config.h	Mon Dec 28 02:12:58 1992
***************
*** 1,3 ****
--- 1,5 ----
+ /* config.h -- changed for emx by Eberhard Mattes -- Dec 1992 */
+ 
  /* Configuration for GNU C-compiler for Intel 80386.
     Copyright (C) 1988 Free Software Foundation, Inc.
  
***************
*** 41,47 ****
--- 43,103 ----
  #define alloca __builtin_alloca
  #endif
  
+ #define YES_UNDERSCORES
+ 
  /* target machine dependencies.
     tm.h is a symbolic link to the actual target specific file.   */
  
  #include "tm.h"
+ 
+ #ifndef __EMX__
+ #define __EMX__
+ #endif
+ #define USG
+ #define GCC_INCLUDE_DIR            "/emx/include"
+ #define GPLUSPLUS_INCLUDE_DIR      "/emx/include.gpp"
+ #define LOCAL_INCLUDE_DIR          "/usr/local/include"
+ #define CROSS_INCLUDE_DIR          "/emx/include.sys"
+ #define STANDARD_EXEC_PREFIX       "/emx/bin/"
+ #define STANDARD_STARTFILE_PREFIX  "/emx/lib/"
+ #define DEFAULT_TARGET_MACHINE     "emx"
+ #define EXECUTABLE_SUFFIX          ".exe"
+ #define PATH_SEPARATOR             ';'
+ #define HANDLE_SYSV_PRAGMA
+ #undef PCC_BITFIELD_TYPE_MATTERS
+ #define PCC_BITFIELD_TYPE_MATTERS (maximum_field_alignment == 0)
+ #undef  SDB_DEBUGGING_INFO
+ #define DBX_DEBUGGING_INFO
+ #define MKTEMP_EACH_FILE
+ #define ASM_SPEC "%{Zwait:-w}"
+ 
+ #undef CPP_PREDEFINES
+ #define CPP_PREDEFINES "-D__32BIT__ -D__EMX__ -Di386"
+ 
+ #undef CPP_SPEC
+ #define CPP_SPEC "%{posix:-D_POSIX_SOURCE} %{Zmt:-D__MT__}"
+ 
+ #define ASM_FINAL_SPEC "%{Zomf:\n emxomf %{s} %{c:%W{o*}%{!o*:-o %w%b.obj}}\
+                                          %{!c:-o %d%w%b.obj} %g.o}"
+ 
+ #define STARTFILE_SPEC \
+   "%{Zomf:%{Zdll:dll0.obj%s}%{!Zdll:crt0.obj%s}}" \
+   "%{!Zomf:%{Zdll:dll0.o%s}" \
+           "%{!Zdll:%{pg:gcrt0.o%s}%{!pg:%{p:mcrt0.o%s}%{!p:crt0.o%s}}}}"
+ 
+ #undef SUBTARGET_SWITCHES
+ #define SUBTARGET_SWITCHES  \
+     { "probe", 0400},				\
+     { "no-probe", -0400},
+ 
+ /* Use a stack probe */
+ #define TARGET_PROBE (target_flags & 0400)
+ 
+ /* Original value, defined in config/unx386.h: 0301 */
+ #if 0                           /* -mno-probe is the default now */
+ #undef TARGET_DEFAULT
+ #define TARGET_DEFAULT 0701     /* add -mprobe */
+ #endif
+ 
+ #define PROBE_SIZE         0x1000
+ #define PROBE_MAX_INLINE   0x10000
diff -c gcc-2.3/cp-lex.c d:gcc-2.3/cp-lex.c
*** gcc-2.3/cp-lex.c	Fri Nov 13 01:51:56 1992
--- d:gcc-2.3/cp-lex.c	Sun Dec 27 21:00:26 1992
***************
*** 1,3 ****
--- 1,5 ----
+ /* cp-lex.c -- changed for emx by Eberhard Mattes -- Dec 1992 */
+ 
  /* Seperate lexical analyzer for GNU C++.
     Copyright (C) 1987, 1989, 1992 Free Software Foundation, Inc.
     Hacked by Michael Tiemann (tiemann@cygnus.com)
***************
*** 2045,2050 ****
--- 2047,2106 ----
  		      TREE_INT_CST_HIGH (fileinfo) = interface_unknown;
  		    }
  		}
+ #if defined (__EMX__)
+               else if (c == 'p'
+                        && getch () == 'a'
+                        && getch () == 'c'
+ 		       && getch () == 'k')
+                 {
+                   int align;
+                   extern int maximum_field_alignment;
+ 
+                   align = -1;
+                   do
+                     {
+                       nextchar = getch ();
+                     } while (nextchar == ' ' || nextchar == '\t');
+                   if (nextchar == '(')
+                     {
+                       do
+                         {
+                           nextchar = getch ();
+                         } while (nextchar == ' ' || nextchar == '\t');
+                       switch (nextchar)
+                         {
+                         case ')':
+                           align = 0;
+                           break;
+                         case '1':
+                         case '2':
+                         case '4':
+                           align = nextchar - '0';
+                           break;
+                         }
+                       if (nextchar != ')')
+                         do
+                           {
+                             nextchar = getch ();
+                           } while (nextchar == ' ' || nextchar == '\t');
+                       if (nextchar != ')')
+                         align = -1;
+                     }
+                   if (align < 0)
+                     {
+                       error ("invalid #pragma pack");
+                       goto skipline;
+                     }
+                   maximum_field_alignment = align * 8;
+                   do
+                     {
+                       nextchar = getch ();
+                     } while (nextchar == ' ' || nextchar == '\t');
+                   c = nextchar;
+ 		  if (c != '\n')
+ 		    warning ("trailing characters ignored");
+ 		}
+ #endif /* __EMX__ */
  	    }
  	  goto skipline;
  	}
diff -c gcc-2.3/explow.c d:gcc-2.3/explow.c
*** gcc-2.3/explow.c	Sat Oct 03 06:07:10 1992
--- d:gcc-2.3/explow.c	Sun Dec 27 21:00:32 1992
***************
*** 1,3 ****
--- 1,5 ----
+ /* explow.c -- changed for emx by Eberhard Mattes -- Dec 1992 */
+ 
  /* Subroutines for manipulating rtx's in semantically interesting ways.
     Copyright (C) 1987, 1991 Free Software Foundation, Inc.
  
***************
*** 638,643 ****
--- 640,680 ----
    if (adjust == const0_rtx)
      return;
  
+ #ifdef __EMX__
+   if (TARGET_PROBE &&
+           (GET_CODE (adjust) != CONST_INT || INTVAL (adjust) >= PROBE_SIZE))
+     {
+       int i, j;
+ 
+       if (GET_CODE (adjust) == CONST_INT && INTVAL (adjust) <= PROBE_MAX_INLINE)
+         {
+           i = INTVAL (adjust); j = 0;
+           while (i >= PROBE_SIZE)
+             {
+               i -= PROBE_SIZE; j += PROBE_SIZE;
+ /* (set (mem:QI (plus:SI (reg:SI 7) (const_int -j)) (const_int 0))) */
+               emit_insn (gen_rtx (SET, VOIDmode,
+                            gen_rtx (MEM, QImode,
+                              gen_rtx (PLUS, Pmode,
+                                gen_rtx (REG, Pmode, 7), /* esp */
+                                gen_rtx (CONST_INT, SImode, -j))),
+                            const0_rtx));
+             }
+         }
+       else
+         {
+           emit_push_insn (adjust, SImode, 0, 0, 0, 0, 0, 0, 0, 0);
+ /* (call (mem:QI (symbol_ref:SI ("__probe"))) (const_int 1)) */
+           emit_insn (gen_rtx (CALL, VOIDmode,
+                        gen_rtx (MEM, QImode,
+                          gen_rtx (SYMBOL_REF, Pmode, "__probe")),
+                        const1_rtx));
+           /*
+           emit_insn (gen_rtx (ASM_INPUT, VOIDmode, "call ___probe"));
+           */
+         }
+     }
+ #endif
    temp = expand_binop (Pmode,
  #ifdef STACK_GROWS_DOWNWARD
  		       sub_optab,
diff -c gcc-2.3/gcc.c d:gcc-2.3/gcc.c
*** gcc-2.3/gcc.c	Sun Dec 27 20:28:04 1992
--- d:gcc-2.3/gcc.c	Sun Dec 27 21:03:56 1992
***************
*** 1,3 ****
--- 1,5 ----
+ /* gcc.c -- changed for emx by Eberhard Mattes -- Dec 1992 */
+ 
  /* Compiler driver program that can handle many languages.
     Copyright (C) 1987, 1989, 1992 Free Software Foundation, Inc.
  
***************
*** 65,70 ****
--- 67,76 ----
  #define NULL_PTR ((GENERIC_PTR)0)
  #endif
  
+ #if defined (__EMX__)
+ #include <process.h>
+ #endif
+ 
  #ifdef USG
  #define vfork fork
  #endif /* USG */
***************
*** 294,299 ****
--- 300,316 ----
  treated as compiler output files, and passed to the linker in their
  proper position among the other output files.  */
  
+ #if defined (__EMX__)
+ 
+ #define EMX_ASM_SPEC_PATCH "%{Zomf:-o %d%g.o}%{!Zomf:\
+ 		            %{c:%W{o*}%{!o*:-o %w%b.o}}%{!c:-o %d%w%u.o}} "
+ 
+ #else
+ 
+ #define EMX_ASM_SPEC_PATCH "%{c:%W{o*}%{!o*:-o %w%b.o}}%{!c:-o %d%w%u.o} "
+ 
+ #endif
+ 
  /* Define the macros used for specs %a, %l, %L, %S, %c, %C, %1.  */
  
  /* config.h can define ASM_SPEC to provide extra args to the assembler
***************
*** 445,453 ****
  		   %{aux-info*}\
  		   %{pg:%{fomit-frame-pointer:%e-pg and -fomit-frame-pointer are incompatible}}\
  		   %{S:%W{o*}%{!o*:-o %b.s}}%{!S:-o %{|!pipe:%g.s}} |\n\
!               %{!S:as %{R} %{j} %{J} %{h} %{d2} %a %Y\
! 		      %{c:%W{o*}%{!o*:-o %w%b.o}}%{!c:-o %d%w%u.o}\
!                       %{!pipe:%g.s} %A\n }}}}"},
    {"-",
     "%{E:cpp -lang-c %{nostdinc*} %{C} %{v} %{A*} %{I*} %{P} %I\
  	%{C:%{!E:%eGNU C does not support -C without using -E}}\
--- 462,470 ----
  		   %{aux-info*}\
  		   %{pg:%{fomit-frame-pointer:%e-pg and -fomit-frame-pointer are incompatible}}\
  		   %{S:%W{o*}%{!o*:-o %b.s}}%{!S:-o %{|!pipe:%g.s}} |\n\
!               %{!S:as %{R} %{j} %{J} %{h} %{d2} %a %Y"
!                       EMX_ASM_SPEC_PATCH
!                       "%{!pipe:%g.s} %A\n }}}}"},
    {"-",
     "%{E:cpp -lang-c %{nostdinc*} %{C} %{v} %{A*} %{I*} %{P} %I\
  	%{C:%{!E:%eGNU C does not support -C without using -E}}\
***************
*** 478,486 ****
  		   %{aux-info*}\
  		   %{pg:%{fomit-frame-pointer:%e-pg and -fomit-frame-pointer are incompatible}}\
  		   %{S:%W{o*}%{!o*:-o %b.s}}%{!S:-o %{|!pipe:%g.s}} |\n\
!               %{!S:as %{R} %{j} %{J} %{h} %{d2} %a %Y\
! 		      %{c:%W{o*}%{!o*:-o %w%b.o}}%{!c:-o %d%w%u.o}\
!                       %{!pipe:%g.s} %A\n }}}}"},
    {".h", "@c-header"},
    {"@c-header",
     "%{!E:%eCompilation of header file requested} \
--- 495,503 ----
  		   %{aux-info*}\
  		   %{pg:%{fomit-frame-pointer:%e-pg and -fomit-frame-pointer are incompatible}}\
  		   %{S:%W{o*}%{!o*:-o %b.s}}%{!S:-o %{|!pipe:%g.s}} |\n\
!               %{!S:as %{R} %{j} %{J} %{h} %{d2} %a %Y"
! 		      EMX_ASM_SPEC_PATCH
!                       "%{!pipe:%g.s} %A\n }}}}"},
    {".h", "@c-header"},
    {"@c-header",
     "%{!E:%eCompilation of header file requested} \
***************
*** 513,521 ****
  		   %{aux-info*}\
  		   %{pg:%{fomit-frame-pointer:%e-pg and -fomit-frame-pointer are incompatible}}\
  		   %{S:%W{o*}%{!o*:-o %b.s}}%{!S:-o %{|!pipe:%g.s}} |\n\
!               %{!S:as %{R} %{j} %{J} %{h} %{d2} %a %Y\
! 		      %{c:%W{o*}%{!o*:-o %w%b.o}}%{!c:-o %d%w%u.o}\
!                       %{!pipe:%g.s} %A\n }}}}"},
    {".i", "@cpp-output"},
    {"@cpp-output",
     "cc1 %i %1 %{!Q:-quiet} %{d*} %{m*} %{a}\
--- 530,538 ----
  		   %{aux-info*}\
  		   %{pg:%{fomit-frame-pointer:%e-pg and -fomit-frame-pointer are incompatible}}\
  		   %{S:%W{o*}%{!o*:-o %b.s}}%{!S:-o %{|!pipe:%g.s}} |\n\
!               %{!S:as %{R} %{j} %{J} %{h} %{d2} %a %Y"
! 		      EMX_ASM_SPEC_PATCH
!                       "%{!pipe:%g.s} %A\n }}}}"},
    {".i", "@cpp-output"},
    {"@cpp-output",
     "cc1 %i %1 %{!Q:-quiet} %{d*} %{m*} %{a}\
***************
*** 524,531 ****
  	%{aux-info*}\
  	%{pg:%{fomit-frame-pointer:%e-pg and -fomit-frame-pointer are incompatible}}\
  	%{S:%W{o*}%{!o*:-o %b.s}}%{!S:-o %{|!pipe:%g.s}} |\n\
!     %{!S:as %{R} %{j} %{J} %{h} %{d2} %a %Y\
!             %{c:%W{o*}%{!o*:-o %w%b.o}}%{!c:-o %d%w%u.o} %{!pipe:%g.s} %A\n }"},
    {".ii", "@c++-cpp-output"},
    {"@c++-cpp-output",
     "cc1plus %i %1 %2 %{!Q:-quiet} %{d*} %{m*} %{a}\
--- 541,549 ----
  	%{aux-info*}\
  	%{pg:%{fomit-frame-pointer:%e-pg and -fomit-frame-pointer are incompatible}}\
  	%{S:%W{o*}%{!o*:-o %b.s}}%{!S:-o %{|!pipe:%g.s}} |\n\
!     %{!S:as %{R} %{j} %{J} %{h} %{d2} %a %Y"
!             EMX_ASM_SPEC_PATCH
!             "%{!pipe:%g.s} %A\n }"},
    {".ii", "@c++-cpp-output"},
    {"@c++-cpp-output",
     "cc1plus %i %1 %2 %{!Q:-quiet} %{d*} %{m*} %{a}\
***************
*** 534,546 ****
  	    %{aux-info*}\
  	    %{pg:%{fomit-frame-pointer:%e-pg and -fomit-frame-pointer are incompatible}}\
  	    %{S:%W{o*}%{!o*:-o %b.s}}%{!S:-o %{|!pipe:%g.s}} |\n\
!        %{!S:as %{R} %{j} %{J} %{h} %{d2} %a %Y\
! 	       %{c:%W{o*}%{!o*:-o %w%b.o}}%{!c:-o %d%w%u.o}\
! 	       %{!pipe:%g.s} %A\n }"},
    {".s", "@assembler"},
    {"@assembler",
!    "%{!S:as %{R} %{j} %{J} %{h} %{d2} %a %Y\
!             %{c:%W{o*}%{!o*:-o %w%b.o}}%{!c:-o %d%w%u.o} %i %A\n }"},
    {".S", "@assembler-with-cpp"},
    {"@assembler-with-cpp",
     "cpp -lang-asm %{nostdinc*} %{C} %{v} %{A*} %{I*} %{P} %I\
--- 552,563 ----
  	    %{aux-info*}\
  	    %{pg:%{fomit-frame-pointer:%e-pg and -fomit-frame-pointer are incompatible}}\
  	    %{S:%W{o*}%{!o*:-o %b.s}}%{!S:-o %{|!pipe:%g.s}} |\n\
!        %{!S:as %{R} %{j} %{J} %{h} %{d2} %a %Y"
! 	       EMX_ASM_SPEC_PATCH "%{!pipe:%g.s} %A\n }"},
    {".s", "@assembler"},
    {"@assembler",
!    "%{!S:as %{R} %{j} %{J} %{h} %{d2} %a %Y"
!             EMX_ASM_SPEC_PATCH "%i %A\n }"},
    {".S", "@assembler-with-cpp"},
    {"@assembler-with-cpp",
     "cpp -lang-asm %{nostdinc*} %{C} %{v} %{A*} %{I*} %{P} %I\
***************
*** 551,559 ****
          %{traditional-cpp:-traditional}\
  	%{g*} %{W*} %{w} %{pedantic*} %{H} %{d*} %C %{D*} %{U*} %{i*}\
          %i %{!M:%{!MM:%{!E:%{!pipe:%g.s}}}}%{E:%W{o*}}%{M:%W{o*}}%{MM:%W{o*}} |\n",
!    "%{!M:%{!MM:%{!E:%{!S:as %{R} %{j} %{J} %{h} %{d2} %a %Y\
!                     %{c:%W{o*}%{!o*:-o %w%b.o}}%{!c:-o %d%w%u.o}\
! 		    %{!pipe:%g.s} %A\n }}}}"},
    /* Mark end of table */
    {0, 0}
  };
--- 568,576 ----
          %{traditional-cpp:-traditional}\
  	%{g*} %{W*} %{w} %{pedantic*} %{H} %{d*} %C %{D*} %{U*} %{i*}\
          %i %{!M:%{!MM:%{!E:%{!pipe:%g.s}}}}%{E:%W{o*}}%{M:%W{o*}}%{MM:%W{o*}} |\n",
!    "%{!M:%{!MM:%{!E:%{!S:as %{R} %{j} %{J} %{h} %{d2} %a %Y"
!                     EMX_ASM_SPEC_PATCH
! 		    "%{!pipe:%g.s} %A\n }}}}"},
    /* Mark end of table */
    {0, 0}
  };
***************
*** 585,590 ****
--- 602,617 ----
  			%{L*} %o %{!nostdlib:libgcc.a%s %L libgcc.a%s %{!A:%E}}\n }}}}}";
  #else
  /* Use -L and have the linker do the search for -lgcc.  */
+ #if defined (__EMX__)
+ static char *link_command_spec = "\
+ %{!c:%{!M:%{!MM:%{!E:%{!S:%{Zomf:emxomf}ld %l %X %{o*} %{A} %{d} %{e*} %{m} %{N} %{n} \
+ 			%{r} %{s} %{T*} %{t} %{u*} %{x} %{z}\
+ 			%{!A:%{!nostdlib:%S}} \
+ 			%{L*} %D %o %{!nostdlib:%{Zmt:-lmt -los2 -lemx2} \
+                         %{!Zmt:-lgcc %L -lgcc \
+                         %{Zsys:-lsys -los2}%{!Zsys:-lemx1 -los2 -lemx2}} \
+                         %{!A:%E}}\n }}}}}";
+ #else
  static char *link_command_spec = "\
  %{!c:%{!M:%{!MM:%{!E:%{!S:ld %l %X %{o*} %{A} %{d} %{e*} %{m} %{N} %{n} \
  			%{r} %{s} %{T*} %{t} %{u*} %{x} %{z}\
***************
*** 592,597 ****
--- 619,625 ----
  			%{L*} %D %o %{!nostdlib:-lgcc %L -lgcc %{!A:%E}}\n }}}}}";
  #endif
  #endif
+ #endif
  
  /* A vector of options to give to the linker.
     These options are accumulated by -Xlinker and -Wl,
***************
*** 1126,1135 ****
--- 1154,1167 ----
  #endif
        if (base == (char *)0)
  	{
+ #if defined (__EMX__)
+ 	  base = "./";
+ #else
  	  if (access ("/usr/tmp", R_OK | W_OK) == 0)
  	    base = "/usr/tmp/";
  	  else
  	    base = "/tmp/";
+ #endif
  	}
      }
  
***************
*** 1136,1142 ****
--- 1168,1178 ----
    len = strlen (base);
    temp_filename = xmalloc (len + sizeof("/ccXXXXXX"));
    strcpy (temp_filename, base);
+ #if defined (__EMX__)
+   if (len > 0 && temp_filename[len-1] != '/' && temp_filename[len-1] != '\\')
+ #else
    if (len > 0 && temp_filename[len-1] != '/')
+ #endif
      temp_filename[len++] = '/';
    strcpy (temp_filename + len, "ccXXXXXX");
  
***************
*** 1524,1529 ****
--- 1560,1597 ----
  
  #else /* not __MSDOS__ */
  
+ #if defined (__EMX__)
+ 
+ static int
+ pexecute (search_flag, program, argv, not_last)
+      int search_flag;
+      char *program;
+      char *argv[];
+      int not_last;
+ {
+   int rc;
+   int input_desc = last_pipe_input;
+   int output_desc = STDOUT_FILE_NO;
+ 
+   /* If this isn't the last process, make a pipe for its output,
+      and record it as waiting to be the input to the next process.  */
+ 
+   if (not_last)
+     {
+       fprintf (stderr, "gcc: pipes not supported\n");
+       exit (250);
+     }
+   else
+     last_pipe_input = STDIN_FILE_NO;
+   rc = (search_flag ? spawnv : spawnvp) (P_WAIT, program,
+                                          (char const * const *)argv);
+   if (rc < 0)
+       pfatal_with_name (program);
+   return rc;
+ }
+ 
+ #else /* not __EMX__ */
+ 
  static int
  pexecute (search_flag, program, argv, not_last)
       int search_flag;
***************
*** 1612,1617 ****
--- 1680,1686 ----
      }
  }
  
+ #endif /* not __EMX__ */
  #endif /* not __MSDOS__ */
  #else /* not OS2 */
  
***************
*** 1636,1641 ****
--- 1705,1713 ----
  execute ()
  {
    int i;
+ #if defined (__EMX__)
+   int rc, ret_code;
+ #endif
    int n_commands;		/* # of command.  */
    char *string;
    struct command
***************
*** 1642,1648 ****
--- 1714,1722 ----
      {
        char *prog;		/* program name.  */
        char **argv;		/* vector of args.  */
+ #ifndef __EMX__
        int pid;			/* pid of process for this command.  */
+ #endif
      };
  
    struct command *commands;	/* each command buffer with above info.  */
***************
*** 1715,1734 ****
--- 1789,1824 ----
    /* Run each piped subprocess.  */
  
    last_pipe_input = STDIN_FILE_NO;
+ #if defined (__EMX__)
+   ret_code = 0;
+ #endif
    for (i = 0; i < n_commands; i++)
      {
        char *string = commands[i].argv[0];
  
+ #if defined (__EMX__)
+       rc = pexecute (string != commands[i].prog,
+                      string, commands[i].argv,
+                      i + 1 < n_commands);
+ #else
        commands[i].pid = pexecute (string != commands[i].prog,
  				  string, commands[i].argv,
  				  i + 1 < n_commands);
+ #endif
  
        if (string != commands[i].prog)
  	free (string);
+ #if defined (__EMX__)
+       if (rc >= MIN_FATAL_STATUS)
+         ret_code = -1;
+ #endif
      }
  
    execution_count++;
  
+ #if defined (__EMX__)
+   return ret_code;
+ #else
    /* Wait for all the subprocesses to finish.
       We don't care what order they finish in;
       we know that N_COMMANDS waits will get them all.  */
***************
*** 1769,1774 ****
--- 1859,1865 ----
        }
      return ret_code;
    }
+ #endif
  }
  
  /* Find all the switches given to us
***************
*** 3284,3289 ****
--- 3375,3384 ----
    char *explicit_link_files;
    char *specs_file;
  
+ #if defined (__EMX__)
+   _response (&argc, &argv);
+   _wildcard (&argc, &argv);
+ #endif
    programname = argv[0];
  
    if (signal (SIGINT, SIG_IGN) != SIG_IGN)
diff -c gcc-2.3/hconfig.h d:gcc-2.3/hconfig.h
*** gcc-2.3/hconfig.h	Mon Dec 28 23:10:54 1992
--- d:gcc-2.3/hconfig.h	Sun Dec 27 21:00:42 1992
***************
*** 1,3 ****
--- 1,5 ----
+ /* hconfig.h -- changed for emx by Eberhard Mattes -- Dec 1992 */
+ 
  /* Configuration for GNU C-compiler for Intel 80386.
     Copyright (C) 1988 Free Software Foundation, Inc.
  
***************
*** 41,47 ****
--- 43,99 ----
  #define alloca __builtin_alloca
  #endif
  
+ #define YES_UNDERSCORES
+ 
  /* target machine dependencies.
     tm.h is a symbolic link to the actual target specific file.   */
  
  #include "tm.h"
+ 
+ #ifndef __EMX__
+ #define __EMX__
+ #endif
+ #define USG
+ #define GCC_INCLUDE_DIR            "/emx/include"
+ #define GPLUSPLUS_INCLUDE_DIR      "/emx/include.gpp"
+ #define LOCAL_INCLUDE_DIR          "/usr/local/include"
+ #define CROSS_INCLUDE_DIR          "/emx/include.sys"
+ #define STANDARD_EXEC_PREFIX       "/emx/bin/"
+ #define STANDARD_STARTFILE_PREFIX  "/emx/lib/"
+ #define DEFAULT_TARGET_MACHINE     "emx"
+ #define EXECUTABLE_SUFFIX          ".exe"
+ #define PATH_SEPARATOR             ';'
+ #define HANDLE_SYSV_PRAGMA
+ #undef  SDB_DEBUGGING_INFO
+ #define DBX_DEBUGGING_INFO
+ 
+ #define ASM_SPEC "%{Zwait:-w}"
+ 
+ #undef CPP_PREDEFINES
+ #define CPP_PREDEFINES "-D__32BIT__ -D__EMX__ -Di386"
+ 
+ #undef CPP_SPEC
+ #define CPP_SPEC "%{posix:-D_POSIX_SOURCE} %{Zmt:-D__MT__}"
+ 
+ #define ASM_FINAL_SPEC "%{Zomf:\n emxomf %{s} %{c:%W{o*}%{!o*:-o %w%b.obj}}\
+                                          %{!c:-o %d%w%b.obj} %g.o}"
+ 
+ #define STARTFILE_SPEC \
+   "%{Zomf:%{Zdll:dll0.obj%s}%{!Zdll:crt0.obj%s}}" \
+   "%{!Zomf:%{Zdll:dll0.o%s}" \
+           "%{!Zdll:%{pg:gcrt0.o%s}%{!pg:%{p:mcrt0.o%s}%{!p:crt0.o%s}}}}"
+ 
+ #undef SUBTARGET_SWITCHES
+ #define SUBTARGET_SWITCHES  \
+     { "probe", 0400},				\
+     { "noprobe", -0400},
+ 
+ /* Use a stack probe */
+ #define TARGET_PROBE (target_flags & 0400)
+ 
+ /* Original value, defined in config/unx386.h: 0301 */
+ #undef TARGET_DEFAULT
+ #define TARGET_DEFAULT 0701     /* add -mprobe */
+ 
+ #define PROBE_SIZE         0x1000
+ #define PROBE_MAX_INLINE   0x10000
diff -c gcc-2.3/toplev.c d:gcc-2.3/toplev.c
*** gcc-2.3/toplev.c	Sun Nov 22 21:20:24 1992
--- d:gcc-2.3/toplev.c	Sun Dec 27 21:00:48 1992
***************
*** 1,3 ****
--- 1,5 ----
+ /* toplev.c -- changed for emx by Eberhard Mattes -- Dec 1992 */
+ 
  /* Top level of GNU C compiler
     Copyright (C) 1987, 1988, 1989, 1992 Free Software Foundation, Inc.
  
***************
*** 1491,1496 ****
--- 1493,1507 ----
    if (dump_base_name == 0)
      dump_base_name = name ? name : "gccdump";
    dump_base_name_length = strlen (dump_base_name);
+ #ifdef __EMX__
+   {
+     char *tmp = (char *) xmalloc (dump_base_name_length + 1);
+     strcpy (tmp, dump_base_name);
+     dump_base_name = tmp;
+     strip_off_ending (dump_base_name, dump_base_name_length);
+     dump_base_name_length = strlen (dump_base_name);
+   }
+ #endif
  
    parse_time = 0;
    varconst_time = 0;
***************
*** 1573,1579 ****
--- 1584,1594 ----
      {
        register char *dumpname = (char *) xmalloc (dump_base_name_length + 6);
        strcpy (dumpname, dump_base_name);
+ #ifdef __EMX__
+       strcat (dumpname, ".jp1");
+ #else
        strcat (dumpname, ".jump");
+ #endif
        jump_opt_dump_file = fopen (dumpname, "w");
        if (jump_opt_dump_file == 0)
  	pfatal_with_name (dumpname);
***************
*** 1584,1590 ****
--- 1599,1609 ----
      {
        register char *dumpname = (char *) xmalloc (dump_base_name_length + 6);
        strcpy (dumpname, dump_base_name);
+ #ifdef __EMX__
+       strcat (dumpname, ".cs1");
+ #else
        strcat (dumpname, ".cse");
+ #endif
        cse_dump_file = fopen (dumpname, "w");
        if (cse_dump_file == 0)
  	pfatal_with_name (dumpname);
***************
*** 1595,1601 ****
--- 1614,1624 ----
      {
        register char *dumpname = (char *) xmalloc (dump_base_name_length + 6);
        strcpy (dumpname, dump_base_name);
+ #ifdef __EMX__
+       strcat (dumpname, ".loo");
+ #else
        strcat (dumpname, ".loop");
+ #endif
        loop_dump_file = fopen (dumpname, "w");
        if (loop_dump_file == 0)
  	pfatal_with_name (dumpname);
***************
*** 1606,1612 ****
--- 1629,1639 ----
      {
        register char *dumpname = (char *) xmalloc (dump_base_name_length + 6);
        strcpy (dumpname, dump_base_name);
+ #ifdef __EMX__
+       strcat (dumpname, ".cs2");
+ #else
        strcat (dumpname, ".cse2");
+ #endif
        cse2_dump_file = fopen (dumpname, "w");
        if (cse2_dump_file == 0)
  	pfatal_with_name (dumpname);
***************
*** 1617,1623 ****
--- 1644,1654 ----
      {
        register char *dumpname = (char *) xmalloc (dump_base_name_length + 6);
        strcpy (dumpname, dump_base_name);
+ #ifdef __EMX__
+       strcat (dumpname, ".flo");
+ #else
        strcat (dumpname, ".flow");
+ #endif
        flow_dump_file = fopen (dumpname, "w");
        if (flow_dump_file == 0)
  	pfatal_with_name (dumpname);
***************
*** 1628,1634 ****
--- 1659,1669 ----
      {
        register char *dumpname = (char *) xmalloc (dump_base_name_length + 10);
        strcpy (dumpname, dump_base_name);
+ #ifdef __EMX__
+       strcat (dumpname, ".cmb");
+ #else
        strcat (dumpname, ".combine");
+ #endif
        combine_dump_file = fopen (dumpname, "w");
        if (combine_dump_file == 0)
  	pfatal_with_name (dumpname);
***************
*** 1639,1645 ****
--- 1674,1684 ----
      {
        register char *dumpname = (char *) xmalloc (dump_base_name_length + 7);
        strcpy (dumpname, dump_base_name);
+ #ifdef __EMX__
+       strcat (dumpname, ".sd1");
+ #else
        strcat (dumpname, ".sched");
+ #endif
        sched_dump_file = fopen (dumpname, "w");
        if (sched_dump_file == 0)
  	pfatal_with_name (dumpname);
***************
*** 1650,1656 ****
--- 1689,1699 ----
      {
        register char *dumpname = (char *) xmalloc (dump_base_name_length + 6);
        strcpy (dumpname, dump_base_name);
+ #ifdef __EMX__
+       strcat (dumpname, ".lre");
+ #else
        strcat (dumpname, ".lreg");
+ #endif
        local_reg_dump_file = fopen (dumpname, "w");
        if (local_reg_dump_file == 0)
  	pfatal_with_name (dumpname);
***************
*** 1661,1667 ****
--- 1704,1714 ----
      {
        register char *dumpname = (char *) xmalloc (dump_base_name_length + 6);
        strcpy (dumpname, dump_base_name);
+ #ifdef __EMX__
+       strcat (dumpname, ".gre");
+ #else
        strcat (dumpname, ".greg");
+ #endif
        global_reg_dump_file = fopen (dumpname, "w");
        if (global_reg_dump_file == 0)
  	pfatal_with_name (dumpname);
***************
*** 1672,1678 ****
--- 1719,1729 ----
      {
        register char *dumpname = (char *) xmalloc (dump_base_name_length + 8);
        strcpy (dumpname, dump_base_name);
+ #ifdef __EMX__
+       strcat (dumpname, ".sd2");
+ #else
        strcat (dumpname, ".sched2");
+ #endif
        sched2_dump_file = fopen (dumpname, "w");
        if (sched2_dump_file == 0)
  	pfatal_with_name (dumpname);
***************
*** 1683,1689 ****
--- 1734,1744 ----
      {
        register char *dumpname = (char *) xmalloc (dump_base_name_length + 7);
        strcpy (dumpname, dump_base_name);
+ #ifdef __EMX__
+       strcat (dumpname, ".jp2");
+ #else
        strcat (dumpname, ".jump2");
+ #endif
        jump2_opt_dump_file = fopen (dumpname, "w");
        if (jump2_opt_dump_file == 0)
  	pfatal_with_name (dumpname);
***************
*** 1707,1713 ****
--- 1762,1772 ----
      {
        register char *dumpname = (char *) xmalloc (dump_base_name_length + 10);
        strcpy (dumpname, dump_base_name);
+ #ifdef __EMX__
+       strcat (dumpname, ".stk");
+ #else
        strcat (dumpname, ".stack");
+ #endif
        stack_reg_dump_file = fopen (dumpname, "w");
        if (stack_reg_dump_file == 0)
  	pfatal_with_name (dumpname);
***************
*** 3294,3304 ****
--- 3353,3365 ----
  	       lim - (char *) &environ);
        fflush (stderr);
  
+ #ifndef __EMX__
  #ifdef USG
        system ("ps -l 1>&2");
  #else /* not USG */
        system ("ps v");
  #endif /* not USG */
+ #endif /* not __EMX__ */
      }
  #endif /* not VMS */
  #endif /* not OS2 */
diff -c gcc-2.3/varasm.c d:gcc-2.3/varasm.c
*** gcc-2.3/varasm.c	Sun Dec 27 20:29:18 1992
--- d:gcc-2.3/varasm.c	Sun Dec 27 21:00:52 1992
***************
*** 1,3 ****
--- 1,5 ----
+ /* varasm.c -- changed for emx by Eberhard Mattes -- Dec 1992 */
+ 
  /* Output variables, constants and external declarations, for GNU compiler.
     Copyright (C) 1987, 1988, 1989, 1992 Free Software Foundation, Inc.
  
***************
*** 520,526 ****
--- 522,530 ----
       tree decl;
       char *fnname;
  {
+ #ifndef __EMX__
    int align;
+ #endif
  
    /* The following code does not need preprocessing in the assembler.  */
  
***************
*** 532,540 ****
--- 536,548 ----
  
  
    /* Tell assembler to move to target machine's alignment for functions.  */
+ #ifdef __EMX__
+   ASM_OUTPUT_ALIGN_CODE (asm_out_file);
+ #else
    align = floor_log2 (FUNCTION_BOUNDARY / BITS_PER_UNIT);
    if (align > 0)
      ASM_OUTPUT_ALIGN (asm_out_file, align);
+ #endif
  
  #ifdef ASM_OUTPUT_FUNCTION_PREFIX
    ASM_OUTPUT_FUNCTION_PREFIX (asm_out_file, fnname);
***************
*** 1069,1075 ****
--- 1077,1085 ----
  {
    char label[256];
    char *name;
+ #ifndef __EMX__
    int align;
+ #endif
  
    /* By default, put trampoline templates in read-only data section.  */
  
***************
*** 1080,1088 ****
--- 1090,1102 ----
  #endif
  
    /* Write the assembler code to define one.  */
+ #ifdef __EMX__
+   ASM_OUTPUT_ALIGN_CODE (asm_out_file);
+ #else
    align = floor_log2 (FUNCTION_BOUNDARY / BITS_PER_UNIT);
    if (align > 0)
      ASM_OUTPUT_ALIGN (asm_out_file, align);
+ #endif
  
    ASM_OUTPUT_INTERNAL_LABEL (asm_out_file, "LTRAMP", 0);
    TRAMPOLINE_TEMPLATE (asm_out_file);
