diff -c -r gdb-4.7/command.c d:gdb-4.7/command.c
*** gdb-4.7/command.c	Fri Oct 16 12:16:44 1992
--- d:gdb-4.7/command.c	Sat Nov 21 13:20:30 1992
***************
*** 1,3 ****
--- 1,5 ----
+ /* command.c -- changed for emx by Eberhard Mattes -- Nov 1992 */
+ 
  /* Handle lists of commands, their decoding and documentation, for GDB.
     Copyright 1986, 1989, 1990, 1991 Free Software Foundation, Inc.
  
***************
*** 1142,1147 ****
--- 1144,1153 ----
       char *arg;
       int from_tty;
  {
+ #if defined (__EMX__)
+   if (system ((arg == NULL ? "" : arg)) < 0)
+       error ("system() failed");
+ #else
    int rc, status, pid;
    char *p, *user_shell;
  
***************
*** 1170,1175 ****
--- 1176,1182 ----
        ;
    else
      error ("Fork failed");
+ #endif /* !defined (__EMX__) */
  }
  
  static void
diff -c -r gdb-4.7/corelow.c d:gdb-4.7/corelow.c
*** gdb-4.7/corelow.c	Wed Oct 07 17:30:18 1992
--- d:gdb-4.7/corelow.c	Sat Nov 21 13:50:24 1992
***************
*** 1,3 ****
--- 1,5 ----
+ /* corelow.c -- changed for emx by Eberhard Mattes -- Nov 1992 */
+ 
  /* Core dump and executable file functions below target vector, for GDB.
     Copyright 1986, 1987, 1989, 1991, 1992 Free Software Foundation, Inc.
  
***************
*** 102,116 ****
--- 104,135 ----
      }
  
    filename = tilde_expand (filename);
+ #if defined (__EMX__)
+     {
+       char tmp[512];
+       if (_fullpath (tmp, filename, sizeof (tmp)) == 0)
+         {
+           strlwr (tmp);
+           filename = strsave (tmp);
+         }
+       else
+         filename = strsave (filename);
+     }
+ #else
    if (filename[0] != '/') {
      temp = concat (current_directory, "/", filename, NULL);
      free (filename);
      filename = temp;
    }
+ #endif
  
    old_chain = make_cleanup (free, filename);
  
+ #if defined (__EMX__)
+   scratch_chan = open (filename, (write_files? O_RDWR: O_RDONLY) | O_BINARY, 0);
+ #else
    scratch_chan = open (filename, write_files? O_RDWR: O_RDONLY, 0);
+ #endif
    if (scratch_chan < 0)
      perror_with_name (filename);
  
diff -c -r gdb-4.7/dbxread.c d:gdb-4.7/dbxread.c
*** gdb-4.7/dbxread.c	Fri Oct 16 12:16:46 1992
--- d:gdb-4.7/dbxread.c	Sat Nov 21 13:20:36 1992
***************
*** 1,3 ****
--- 1,5 ----
+ /* dbxread.c -- changed for emx by Eberhard Mattes -- Nov 1992 */
+ 
  /* Read dbx symbol tables and convert to internal format, for GDB.
     Copyright 1986, 1987, 1988, 1989, 1990, 1991 Free Software Foundation, Inc.
  
***************
*** 1101,1107 ****
--- 1103,1111 ----
       for this source file out of the ELF symbol table, to compensate for
       Sun brain death.  This replaces the section_offsets in this psymtab,
       if successful.  */
+ #if !defined (__EMX__)
    elfstab_offset_sections (objfile, result);
+ #endif
  
    return result;
  }
diff -c -r gdb-4.7/i386v-na.c d:gdb-4.7/i386v-na.c
*** gdb-4.7/i386v-na.c	Wed Oct 21 19:26:02 1992
--- d:gdb-4.7/i386v-na.c	Sun Nov 22 22:27:12 1992
***************
*** 1,3 ****
--- 1,5 ----
+ /* i386v-na.c -- changed for emx by Eberhard Mattes -- Nov 1992 */
+ 
  /* Intel 386 native support.
     Copyright (C) 1988, 1989, 1991, 1992 Free Software Foundation, Inc.
  
***************
*** 82,88 ****
    
  }
  
! #if 0
  /* using FLOAT_INFO as is would be a problem.  FLOAT_INFO is called
     via a command xxx and eventually calls ptrace without ever having
     traversed the target vector.  This would be terribly impolite
--- 84,182 ----
    
  }
  
! 
! #if defined (__EMX__)
! 
! /* Taken from i386-xdep.c of GDB 4.6 */
! /* and modified by Eberhard Mattes */
! 
! struct env387 
! {
!   unsigned short control;
!   unsigned short r0;
!   unsigned short status;
!   unsigned short r1;
!   unsigned short tag;
!   unsigned short r2;
!   unsigned long eip;
!   unsigned short code_seg;
!   unsigned short opcode;
!   unsigned long operand;
!   unsigned short operand_seg;
!   unsigned short r3;
!   unsigned char regs[8][10];
! };
! 
! static
! print_387_status (status, ep)
!      unsigned short status;
!      struct env387 *ep;
! {
!   int i;
!   int bothstatus;
!   int top;
!   int fpreg;
!   unsigned char *p;
!   
!   bothstatus = ((status != 0) && (ep->status != 0));
!   if (status != 0) 
!     {
!       if (bothstatus)
! 	printf ("u: ");
!       print_387_status_word (status);
!     }
!   
!   if (ep->status != 0) 
!     {
!       if (bothstatus)
! 	printf ("e: ");
!       print_387_status_word (ep->status);
!     }
!   
!   print_387_control_word (ep->control);
!   printf ("last exception: ");
!   printf ("opcode %s; ", local_hex_string(ep->opcode));
!   printf ("pc %s:", local_hex_string(ep->code_seg));
!   printf ("%s; ", local_hex_string(ep->eip));
!   printf ("operand %s", local_hex_string(ep->operand_seg));
!   printf (":%s\n", local_hex_string(ep->operand));
!   
!   top = (ep->status >> 11) & 7;
!   
!   printf ("reg    tag   msb              lsb  value\n");
!   for (fpreg = 7; fpreg >= 0; fpreg--) 
!     {
!       double val;
! 
!       printf ("st(%d): ", fpreg);
!       
!       switch ((ep->tag >> (((top + fpreg) & 7) * 2)) & 3)
! 	{
! 	case 0: printf ("valid "); break;
! 	case 1: printf ("zero  "); break;
! 	case 2: printf ("trap  "); break;
! 	case 3: printf ("empty "); break;
! 	}
!       for (i = 9; i >= 0; i--)
! 	printf ("%02x", ep->regs[fpreg][i]);
!       
!       ieee_extended_to_double (&ext_format_i387, (char *)ep->regs[fpreg],
! 			       &val);
!       printf ("  %g\n", val);
!     }
!   if (ep->r0)
!     warning ("reserved0 is %s\n", local_hex_string(ep->r0));
!   if (ep->r1)
!     warning ("reserved1 is %s\n", local_hex_string(ep->r1));
!   if (ep->r2)
!     warning ("reserved2 is %s\n", local_hex_string(ep->r2));
!   if (ep->r3)
!     warning ("reserved3 is %s\n", local_hex_string(ep->r3));
! }
! 
! #define U_FPSTATE(u) u.u_fpstate
! 
! /* __EMX__ #if 0 */
  /* using FLOAT_INFO as is would be a problem.  FLOAT_INFO is called
     via a command xxx and eventually calls ptrace without ever having
     traversed the target vector.  This would be terribly impolite
***************
*** 101,107 ****
--- 195,203 ----
    char fpvalid = 0;
    unsigned int rounded_addr;
    unsigned int rounded_size;
+ #if !defined (__EMX__)
    extern int corechan;
+ #endif
    int skip;
    
    uaddr = (char *)&u.u_fpvalid - (char *)&u;
diff -c -r gdb-4.7/inflow.c d:gdb-4.7/inflow.c
*** gdb-4.7/inflow.c	Mon Sep 28 22:22:38 1992
--- d:gdb-4.7/inflow.c	Sat Nov 21 13:20:44 1992
***************
*** 1,3 ****
--- 1,5 ----
+ /* inflow.c -- changed for emx by Eberhard Mattes -- Nov 1992 */
+ 
  /* Low level interface to ptrace, for GDB when running under Unix.
     Copyright 1986, 1987, 1989, 1991, 1992 Free Software Foundation, Inc.
  
***************
*** 24,29 ****
--- 26,34 ----
  #include "signals.h"
  #include "terminal.h"
  #include "target.h"
+ #if defined (__EMX__)
+ #include "gdbcmd.h"
+ #endif
  
  #ifdef USG
  #include <sys/types.h>
***************
*** 50,55 ****
--- 55,64 ----
  
  /* Record terminal status separately for debugger and inferior.  */
  
+ #if defined (__EMX__)
+ int switch_sessions = 1;
+ #endif
+ 
  /* Does GDB have a terminal (on stdin)?  */
  int gdb_has_a_terminal;
  #if !defined(__GO32__)
***************
*** 155,160 ****
--- 164,173 ----
  
    if (gdb_has_a_terminal && terminal_is_ours && inferior_thisrun_terminal == 0)
      {
+ #if defined (__EMX__)
+       if (switch_sessions)
+           ptrace (10, inferior_pid, 0, 2);
+ #else
        result = fcntl (0, F_SETFL, tflags_inferior);
        result = fcntl (0, F_SETFL, tflags_inferior);
        OOPSY ("fcntl F_SETFL");
***************
*** 189,194 ****
--- 202,208 ----
        sigint_ours = (void (*) ()) signal (SIGINT, SIG_IGN);
        sigquit_ours = (void (*) ()) signal (SIGQUIT, SIG_IGN);
  #endif /* TIOCGPGRP */
+ #endif /* defined (__EMX__) */
      }
  #endif
    terminal_is_ours = 0;
***************
*** 240,245 ****
--- 254,263 ----
      {
        terminal_is_ours = 1;
  
+ #if defined (__EMX__)
+       if (switch_sessions)
+           ptrace (10, inferior_pid, 0, 0);
+ #else
  #ifdef TIOCGPGRP
        osigttou = (void (*) ()) signal (SIGTTOU, SIG_IGN);
  
***************
*** 265,272 ****
--- 283,292 ----
        result = ioctl (0, TIOCLGET, &lmode_inferior);
        lmode_inferior_valid = (result == 0);
  #endif
+ #endif /* !defined (__EMX__) */
      }
  
+ #if !defined (__EMX__)
  #ifdef HAVE_TERMIO
    sg_ours.c_lflag |= ICANON;
    if (output_only && !(sg_inferior.c_lflag & ICANON))
***************
*** 302,307 ****
--- 322,328 ----
  
    result = result;	/* lint */
  #endif
+ #endif /* !defined (__EMX__) */
  }
  
  /* ARGSUSED */
***************
*** 550,555 ****
--- 571,585 ----
    add_com ("kill", class_run, kill_command,
  	   "Kill execution of program being debugged.");
  
+ #if defined (__EMX__)
+   add_show_from_set
+     (add_set_cmd ("switch", class_run, var_boolean,
+                   (char *)&switch_sessions,
+                   "Set whether to switch to the child session when running "
+                   "the inferior.",
+                   &setlist),
+       &showlist);
+ #endif
    inferior_pid = 0;
  
    /* Get all the current tty settings (including whether we have a tty at
***************
*** 556,562 ****
--- 586,594 ----
       all!).  */
  
  #if !defined(__GO32__)
+ #if !defined (__EMX__)
    tflags_ours = fcntl (0, F_GETFL, 0);
+ #endif
  
    result = ioctl (0, TIOCGETP, &sg_ours);
    if (result == 0) {
diff -c -r gdb-4.7/infptrac.c d:gdb-4.7/infptrac.c
*** gdb-4.7/infptrac.c	Thu Oct 22 01:06:42 1992
--- d:gdb-4.7/infptrac.c	Sat Nov 21 13:20:12 1992
***************
*** 1,3 ****
--- 1,5 ----
+ /* infptrac.c -- changed for emx by Eberhard Mattes -- Nov 1992 */
+ 
  /* Low level Unix child interface to ptrace, for GDB when running under Unix.
     Copyright 1988, 1989, 1990, 1991, 1992 Free Software Foundation, Inc.
  
***************
*** 424,434 ****
--- 426,444 ----
  	  buffer[i] = ptrace (PT_READ_I, inferior_pid,
  			      (PTRACE_ARG3_TYPE) addr, 0);
  	  if (errno)
+ #if defined (__EMX__)
+             break;
+ #else
  	    return 0;
+ #endif
  	  QUIT;
  	}
  
        /* Copy appropriate bytes out of the buffer.  */
+ #if defined (__EMX__)
+       if (i < count)
+         len = i * sizeof (int);
+ #endif
        memcpy (myaddr, (char *) buffer + (memaddr & (sizeof (int) - 1)), len);
      }
    return len;
diff -c -r gdb-4.7/infrun.c d:gdb-4.7/infrun.c
*** gdb-4.7/infrun.c	Fri Oct 16 12:16:50 1992
--- d:gdb-4.7/infrun.c	Sat Nov 14 13:57:26 1992
***************
*** 1,3 ****
--- 1,5 ----
+ /* infrun.c -- changed for emx by Eberhard Mattes -- Nov 1992 */
+ 
  /* Target-struct-independent code to start (run) and stop an inferior process.
     Copyright 1986, 1987, 1988, 1989, 1991, 1992 Free Software Foundation, Inc.
  
***************
*** 122,127 ****
--- 124,135 ----
  #include <sys/file.h>
  #endif
  
+ #if defined (__EMX__)
+ #include "gdbcmd.h"
+ 
+ int close_sessions = 0;
+ #endif
+ 
  /* Prototypes for local functions */
  
  static void
***************
*** 1675,1680 ****
--- 1683,1696 ----
    register int i;
    register int numsigs;
  
+ #if defined (__EMX__)
+   add_show_from_set
+     (add_set_cmd ("close", class_run, var_boolean,
+                   (char *)&close_sessions,
+                   "Set whether to automatically close the next child session.",
+                   &setlist),
+       &showlist);
+ #endif
    add_info ("signals", signals_info,
  	    "What debugger does when program gets various signals.\n\
  Specify a signal number as argument to print info on that signal only.");
diff -c -r gdb-4.7/inftarg.c d:gdb-4.7/inftarg.c
*** gdb-4.7/inftarg.c	Wed Oct 07 17:30:42 1992
--- d:gdb-4.7/inftarg.c	Sat Nov 21 13:17:36 1992
***************
*** 1,3 ****
--- 1,5 ----
+ /* inftarg.c -- changed for emx by Eberhard Mattes -- Nov 1992 */
+ 
  /* Target-vector operations for controlling Unix child processes, for GDB.
     Copyright 1990, 1991, 1992 Free Software Foundation, Inc.
     Contributed by Cygnus Support.
***************
*** 194,200 ****
--- 196,206 ----
       char *arg;
       int from_tty;
  {
+ #if defined (__EMX__)
+   error ("Use the \"run\" command to start an emx child process.");
+ #else
    error ("Use the \"run\" command to start a Unix child process.");
+ #endif
  }
  
  /* Stub function which causes the inferior that runs it, to be ptrace-able
***************
*** 249,256 ****
--- 255,267 ----
  
  struct target_ops child_ops = {
    "child",			/* to_shortname */
+ #if defined (__EMX__)
+   "emx child process",		/* to_longname */
+   "emx child process (started by the \"run\" command).",	/* to_doc */
+ #else
    "Unix child process",		/* to_longname */
    "Unix child process (started by the \"run\" command).",	/* to_doc */
+ #endif
    child_open,			/* to_open */
    0,				/* to_close */
    child_attach,			/* to_attach */
diff -c -r gdb-4.7/main.c d:gdb-4.7/main.c
*** gdb-4.7/main.c	Wed Oct 07 17:30:48 1992
--- d:gdb-4.7/main.c	Sat Nov 21 13:20:04 1992
***************
*** 1,3 ****
--- 1,5 ----
+ /* main.c -- changed for emx by Eberhard Mattes -- Nov 1992 */
+ 
  /* Top level `main' program for GDB, the GNU debugger.
     Copyright 1986, 1987, 1988, 1989, 1990, 1991, 1992
     Free Software Foundation, Inc.
***************
*** 60,65 ****
--- 62,71 ----
  int original_stack_limit;
  #endif
  
+ #if defined (__EMX__)
+ #include <sys/ioctl.h>
+ #endif
+ 
  /* Prototypes for local functions */
  
  static char *
***************
*** 470,475 ****
--- 476,485 ----
      alloca (4 - i);
  #endif
  
+ #if defined (__EMX__)
+   (void)setvbuf (stdout, NULL, _IOLBF, BUFSIZ);
+ #endif
+ 
    /* If error() is called from initialization code, just exit */
    if (setjmp (to_top_level)) {
      exit(1);
***************
*** 488,493 ****
--- 498,506 ----
    instream = stdin;
  
    getcwd (dirbuf, sizeof (dirbuf));
+ #if defined (__EMX__)
+   strlwr (dirbuf);
+ #endif
    current_directory = dirbuf;
  
  #ifdef SET_STACK_LIMIT_HUGE
***************
*** 1959,1964 ****
--- 1972,1980 ----
  {
    if (args) error ("The \"pwd\" command does not take an argument: %s", args);
    getcwd (dirbuf, sizeof (dirbuf));
+ #if defined (__EMX__)
+   strlwr (dirbuf);
+ #endif
  
    if (strcmp (dirbuf, current_directory))
      printf ("Working directory %s\n (canonically %s).\n",
***************
*** 1989,1994 ****
--- 2005,2013 ----
      perror_with_name (dir);
  
    len = strlen (dir);
+ #if defined (__EMX__)
+   dir = current_directory = absfname (".");
+ #else
    dir = savestring (dir, len - (len > 1 && dir[len-1] == '/'));
    if (dir[0] == '/')
      current_directory = dir;
***************
*** 2026,2031 ****
--- 2045,2051 ----
  	  else p++;
  	}
      }
+ #endif
  
    forget_cached_source_info ();
  
***************
*** 2254,2260 ****
--- 2274,2286 ----
  int
  batch_mode ()
  {
+ #if defined (__EMX__)
+   int ht;
+   return !(instream == stdin && ioctl (fileno (stdin), FGETHTYPE, &ht) >= 0
+ 	   && ht != HT_FILE);
+ #else
    return !(instream == stdin && ISATTY (stdin));
+ #endif
  }
  
  
***************
*** 2310,2316 ****
--- 2336,2346 ----
      /* We include the current directory so that if the user changes
         directories the file written will be the same as the one
         that was read.  */
+ #if defined (__EMX__)
+     history_filename = absfname ("!gdb_history");
+ #else
      history_filename = concat (current_directory, "/.gdb_history", NULL);
+ #endif
    }
    read_history (history_filename);
  }
diff -c -r gdb-4.7/source.c d:gdb-4.7/source.c
*** gdb-4.7/source.c	Mon Oct 05 17:41:50 1992
--- d:gdb-4.7/source.c	Sat Nov 21 13:21:02 1992
***************
*** 1,3 ****
--- 1,5 ----
+ /* source.c -- changed for emx by Eberhard Mattes -- Nov 1992 */
+ 
  /* List lines of source files for GDB, the GNU debugger.
     Copyright (C) 1986, 1987, 1988, 1989, 1991 Free Software Foundation, Inc.
  
***************
*** 235,241 ****
--- 237,247 ----
  void
  init_source_path ()
  {
+ #if defined (__EMX__)
+   source_path = savestring ("$cdir;$cwd", /* strlen of it */ 10);
+ #else
    source_path = savestring ("$cdir:$cwd", /* strlen of it */ 10);
+ #endif
    forget_cached_source_info ();
  }
  
***************
*** 286,292 ****
--- 292,302 ----
        struct stat st;
  
        {
+ #if defined (__EMX__)
+ 	char *colon = strchr (name, ';');
+ #else
  	char *colon = strchr (name, ':');
+ #endif
  	char *space = strchr (name, ' ');
  	char *tab = strchr (name, '\t');
  	if (colon == 0 && space == 0 && tab ==  0)
***************
*** 301,312 ****
--- 311,330 ----
  	    if (tab != 0 && (p == 0 || tab < p))
  	      p = tab;
  	    dirname = p + 1;
+ #if defined (__EMX__)
+ 	    while (*dirname == ';' || *dirname == ' ' || *dirname == '\t')
+ #else
  	    while (*dirname == ':' || *dirname == ' ' || *dirname == '\t')
+ #endif
  	      ++dirname;
  	  }
        }
  
+ #if defined (__EMX__)
+       if (PATHSEP (p[-1]))
+ #else
        if (p[-1] == '/')
+ #endif
  	/* Sigh. "foo/" => "foo" */
  	--p;
        *p = '\0';
***************
*** 319,325 ****
--- 337,347 ----
  	      name = current_directory;
  	      goto append;
  	    }
+ #if defined (__EMX__)
+ 	  else if (PATHSEP (p[-2]))
+ #else
  	  else if (p[-2] == '/')
+ #endif
  	    {
  	      if (p - name == 2)
  		{
***************
*** 341,348 ****
--- 363,375 ----
  
        if (name[0] == '~')
  	name = tilde_expand (name);
+ #if defined (__EMX__)
+       else if (name[0] != '$')
+         name = absfname (name);
+ #else
        else if (name[0] != '/' && name[0] != '$')
  	name = concat (current_directory, "/", name, NULL);
+ #endif
        else
  	name = savestring (name, p - name);
        make_cleanup (free, name);
***************
*** 363,369 ****
--- 390,400 ----
  	while (1)
  	  {
  	    if (!strncmp (p, name, len)
+ #if defined (__EMX__)
+ 		&& (p[len] == '\0' || p[len] == ';'))
+ #else
  		&& (p[len] == '\0' || p[len] == ':'))
+ #endif
  	      {
  		/* Found it in the search path, remove old copy */
  		if (p > *which_path)
***************
*** 372,378 ****
--- 403,413 ----
  		  goto skip_dup;	/* Same dir twice in one cmd */
  		strcpy (p, &p[len+1]);	/* Copy from next \0 or  : */
  	      }
+ #if defined (__EMX_)
+ 	    p = strchr (p, ';');
+ #else
  	    p = strchr (p, ':');
+ #endif
  	    if (p != 0)
  	      ++p;
  	    else
***************
*** 387,393 ****
--- 422,432 ----
  
  		c = old[prefix];
  		old[prefix] = '\0';
+ #if defined (__EMX__)
+ 		temp = concat (old, ";", name, NULL);
+ #else
  		temp = concat (old, ":", name, NULL);
+ #endif
  		old[prefix] = c;
  		*which_path = concat (temp, "", &old[prefix], NULL);
  		prefix = strlen (temp);
***************
*** 395,401 ****
--- 434,444 ----
  	      }
  	    else
  	      {
+ #if defined (__EMX__)
+ 		*which_path = concat (name, (old[0]? ";" : old), old, NULL);
+ #else
  		*which_path = concat (name, (old[0]? ":" : old), old, NULL);
+ #endif
  		prefix = strlen (name);
  	      }
  	    free (old);
***************
*** 482,488 ****
--- 525,535 ----
    fd = -1;
    for (p = path; p; p = p1 ? p1 + 1 : 0)
      {
+ #if defined (__EMX__)
+       p1 = (char *) strchr (p, ';');
+ #else
        p1 = (char *) strchr (p, ':');
+ #endif
        if (p1)
  	len = p1 - p;
        else
***************
*** 508,514 ****
--- 555,565 ----
        }
  
        /* Remove trailing slashes */
+ #if defined (__EMX__)
+       while (len > 1 && PATHSEP (filename[len-1]))
+ #else
        while (len > 0 && filename[len-1] == '/')
+ #endif
         filename[--len] = 0;
  
        strcat (filename+len, "/");
***************
*** 522,530 ****
--- 573,588 ----
    if (filename_opened)
      if (fd < 0)
        *filename_opened = (char *) 0;
+ #if defined (__EMX__)
+     else if (ABSPATH (filename))
+ #else
      else if (filename[0] == '/')
+ #endif
        *filename_opened = savestring (filename, strlen (filename));
      else
+ #if defined (__EMX__)
+       *filename_opened = absfname (filename);
+ #else
        {
  	/* Beware the // my son, the Emacs barfs, the botch that catch... */
  	   
***************
*** 532,537 ****
--- 590,596 ----
  	   '/' == current_directory[strlen(current_directory)-1]? "": "/",
  				   filename, NULL);
        }
+ #endif
  
    return fd;
  }
***************
*** 551,557 ****
--- 610,620 ----
    /* Quick way out if we already know its full name */
    if (s->fullname) 
      {
+ #if defined (__EMX__)
+       result = open (s->fullname, O_RDONLY | O_BINARY);
+ #else
        result = open (s->fullname, O_RDONLY);
+ #endif
        if (result >= 0)
          return result;
        /* Didn't work -- free old one, try again. */
***************
*** 566,573 ****
--- 629,641 ----
        /* We cast strstr's result in case an ANSIhole has made it const,
  	 which produces a "required warning" when assigned to a nonconst. */
        p = (char *)strstr (source_path, "$cdir");
+ #if defined (__EMX_)
+       if (p && (p == path || p[-1] == ';')
+ 	    && (p[cdir_len] == ';' || p[cdir_len] == '\0')) {
+ #else
        if (p && (p == path || p[-1] == ':')
  	    && (p[cdir_len] == ':' || p[cdir_len] == '\0')) {
+ #endif
  	int len;
  
  	path = (char *)
***************
*** 579,591 ****
--- 647,667 ----
        }
      }
  
+ #if defined (__EMX__)
+   result = openp (path, 0, s->filename, O_RDONLY | O_BINARY, 0, &s->fullname);
+ #else
    result = openp (path, 0, s->filename, O_RDONLY, 0, &s->fullname);
+ #endif
    if (result < 0)
      {
        /* Didn't work.  Try using just the basename. */
        p = basename (s->filename);
        if (p != s->filename)
+ #if defined (__EMX__)
+ 	result = openp(path, 0, p, O_RDONLY|O_BINARY,0, &s->fullname);
+ #else
  	result = openp(path, 0, p, O_RDONLY,0, &s->fullname);
+ #endif
      }
    if (result >= 0)
      {
***************
*** 777,783 ****
--- 853,863 ----
      get_filename_and_charpos (s, (char **)NULL);
    if (s->fullname == 0)
      return 0;
+ #if defined (__EMX__)
+   printf ("\032\032%s;%d;%d;%s;0x%x\n", s->fullname,
+ #else
    printf ("\032\032%s:%d:%d:%s:0x%x\n", s->fullname,
+ #endif
  	  line, s->line_charpos[line - 1],
  	  mid_statement ? "middle" : "beg",
  	  get_frame_pc (get_current_frame()));
***************
*** 834,840 ****
--- 914,924 ----
        perror_with_name (s->filename);
      }
  
+ #if defined (__EMX__)
+   stream = fdopen (desc, "rb");
+ #else
    stream = fdopen (desc, "r");
+ #endif
    clearerr (stream);
  
    while (nlines-- > 0)
***************
*** 845,850 ****
--- 929,938 ----
        printf_filtered ("%d\t", current_source_line++);
        do
  	{
+ #if defined (__EMX__)
+           if (c == '\r')
+             ; else
+ #endif
  	  if (c < 040 && c != '\t' && c != '\n' && c != '\r')
  	      printf_filtered ("^%c", c + 0100);
  	  else if (c == 0177)
***************
*** 1152,1158 ****
--- 1240,1250 ----
        perror_with_name (current_source_symtab->filename);
      }
  
+ #if defined (__EMX__)
+   stream = fdopen (desc, "rb");
+ #else
    stream = fdopen (desc, "r");
+ #endif
    clearerr (stream);
    while (1) {
  /* FIXME!!!  We walk right off the end of buf if we get a long line!!! */
***************
*** 1163,1168 ****
--- 1255,1263 ----
      if (c == EOF)
        break;
      do {
+ #if defined (__EMX__)
+      if (c != '\r')
+ #endif
        *p++ = c;
      } while (c != '\n' && (c = getc (stream)) >= 0);
  
***************
*** 1224,1230 ****
--- 1319,1329 ----
        perror_with_name (current_source_symtab->filename);
      }
  
+ #if defined (__EMX__)
+   stream = fdopen (desc, "rb");
+ #else
    stream = fdopen (desc, "r");
+ #endif
    clearerr (stream);
    while (line > 1)
      {
***************
*** 1236,1241 ****
--- 1335,1343 ----
        if (c == EOF)
  	break;
        do {
+ #if defined (__EMX__)
+         if (c != '\r')
+ #endif
  	*p++ = c;
        } while (c != '\n' && (c = getc (stream)) >= 0);
  
diff -c -r gdb-4.7/stabsrea.c d:gdb-4.7/stabsrea.c
*** gdb-4.7/stabsrea.c	Wed Oct 07 17:31:18 1992
--- d:gdb-4.7/stabsrea.c	Fri Nov 20 11:13:00 1992
***************
*** 1,3 ****
--- 1,5 ----
+ /* stabsrea.c -- changed for emx by Eberhard Mattes -- Nov 1992 */
+ 
  /* Support routines for decoding "stabs" debugging information format.
     Copyright 1986, 1987, 1988, 1989, 1990, 1991, 1992
               Free Software Foundation, Inc.
***************
*** 1078,1087 ****
--- 1080,1091 ----
  	return type;
        }
  
+ #if !defined (__EMX__)
      case '-':				/* RS/6000 built-in type */
        (*pp)--;
        type = builtin_type (pp);		/* (in xcoffread.c) */
        goto after_digits;
+ #endif
  
      case '0':
      case '1':
diff -c -r gdb-4.7/symfile.c d:gdb-4.7/symfile.c
*** gdb-4.7/symfile.c	Wed Oct 07 17:31:20 1992
--- d:gdb-4.7/symfile.c	Sat Nov 21 13:21:12 1992
***************
*** 1,3 ****
--- 1,5 ----
+ /* symfile.c -- changed for emx by Eberhard Mattes -- Nov 1992 */
+ 
  /* Generic symbol file reading for the GNU debugger, GDB.
     Copyright 1990, 1991, 1992 Free Software Foundation, Inc.
     Contributed by Cygnus Support, using pieces from other GDB modules.
***************
*** 740,746 ****
--- 742,752 ----
    name = tilde_expand (name);	/* Returns 1st new malloc'd copy */
  
    /* Look down path for it, allocate 2nd new malloc'd copy.  */
+ #if defined (__EMX__)
+   desc = openp (getenv ("PATH"), 1, name, O_RDONLY | O_BINARY, 0, &absolute_name);
+ #else
    desc = openp (getenv ("PATH"), 1, name, O_RDONLY, 0, &absolute_name);
+ #endif
    if (desc < 0)
      {
        make_cleanup (free, name);
diff -c -r gdb-4.7/terminal.h d:gdb-4.7/terminal.h
*** gdb-4.7/terminal.h	Tue May 12 18:12:06 1992
--- d:gdb-4.7/terminal.h	Sat Nov 21 13:21:34 1992
***************
*** 1,3 ****
--- 1,5 ----
+ /* terminal.h -- changed for emx by Eberhard Mattes -- Nov 1992 */
+ 
  /* Terminal interface definitions for GDB, the GNU Debugger.
     Copyright 1986, 1989, 1991, 1992 Free Software Foundation, Inc.
  
***************
*** 32,38 ****
--- 34,44 ----
  #undef TIOCSETN
  #define TIOCSETN TCSETA
  #undef TIOCSETP
+ #if defined (__EMX__)
+ #define TIOCSETP TCSETA
+ #else
  #define TIOCSETP TCSETAF
+ #endif
  #define TERMINAL struct termio
  
  #ifdef NO_JOB_CONTROL
diff -c -r gdb-4.7/utils.c d:gdb-4.7/utils.c
*** gdb-4.7/utils.c	Mon Sep 28 22:22:46 1992
--- d:gdb-4.7/utils.c	Sat Nov 14 13:53:38 1992
***************
*** 1,3 ****
--- 1,5 ----
+ /* utils.c -- changed for emx by Eberhard Mattes -- Nov 1992 */
+ 
  /* General utility routines for GDB, the GNU debugger.
     Copyright 1986, 1989, 1990, 1991, 1992 Free Software Foundation, Inc.
  
***************
*** 422,427 ****
--- 424,432 ----
  {
    quit_flag = 1;
  
+ #if defined (__EMX__)
+   signal (SIGINT, SIG_ACK);
+ #endif
  #ifdef USG
    /* Restore the signal handler.  */
    signal (signo, request_quit);
***************
*** 907,912 ****
--- 912,920 ----
  prompt_for_continue ()
  {
    char *ignore;
+ #if defined (__EMX__)
+   int old_quit;
+ #endif
  
    /* We must do this *before* we call gdb_readline, else it will eventually
       call us -- thinking that we're trying to print beyond the end of the 
***************
*** 913,923 ****
--- 921,939 ----
       screen.  */
    reinitialize_more_filter ();
  
+ #if defined (__EMX__)
+   old_quit = immediate_quit; immediate_quit = 0;
+ #else
    immediate_quit++;
+ #endif
    ignore = gdb_readline ("---Type <return> to continue---");
    if (ignore)
      free (ignore);
+ #if defined (__EMX__)
+   immediate_quit = old_quit;
+ #else
    immediate_quit--;
+ #endif
  
    /* Now we have to do this again, so that GDB will know that it doesn't
       need to save the ---Type <return>--- line at the top of the screen.  */
***************
*** 1538,1543 ****
--- 1554,1584 ----
  		  &setprintlist),
       &showprintlist);
  }
+ 
+ #if defined (__EMX__)
+ 
+ char *
+ absfname (filename)
+      char *filename;
+   {
+     char tmp[512];
+ 
+     if (_fullpath (tmp, filename, sizeof (tmp)) == 0)
+       {
+         strlwr (tmp);
+         filename = tmp;
+       }
+     return strsave (filename);
+   }
+ 
+ char *
+ tilde_expand (filename)
+      char *filename;
+   {
+     return (strsave (filename));
+   }
+ 
+ #endif
  
  /* Machine specific function to handle SIGWINCH signal. */
  
diff -c -r bfd/emx-aout.c d:bfd/emx-aout.c
*** bfd/emx-aout.c	Fri Oct 09 09:43:50 1992
--- d:bfd/emx-aout.c	Sat Nov 14 14:30:22 1992
***************
*** 1,4 ****
! /* BFD back-end for i386 a.out binaries.
     Copyright 1990, 1991, 1992 Free Software Foundation, Inc.
  
  This file is part of BFD, the Binary File Descriptor library.
--- 1,4 ----
! /* BFD back-end for emx a.out binaries, derived from i386aout.c and aout-target.h
     Copyright 1990, 1991, 1992 Free Software Foundation, Inc.
  
  This file is part of BFD, the Binary File Descriptor library.
***************
*** 28,56 ****
  #define BYTES_IN_WORD 4
  #define ARCH 32
  
! #define N_TXTOFF(x) 0x20
! #define N_TXTADDR(x) (N_MAGIC(x)==ZMAGIC ? 0x1020 : 0)
  
! #define N_TXTSIZE(x) ((x).a_text)
! #if 0
! #define N_DATADDR(x) (N_MAGIC(x)==OMAGIC? (N_TXTADDR(x)+(x).a_text) : (SEGMENT_SIZE + ((0x1020+(x).a_text-1) & ~(SEGMENT_SIZE-1))))
! #define NOSUBEXECB
! 
! #endif
! #define PAGE_SIZE 4096
! #define SEGMENT_SIZE 0x400000
! #define DEFAULT_ARCH bfd_arch_i386
! 
! #define MY(OP) CAT(i386aout_,OP)
! #define TARGETNAME "a.out-i386"
  #define NO_WRITE_HEADER_KLUDGE 1
  
  #include "bfd.h"
  #include "sysdep.h"
  #include "libbfd.h"
  #include "libaout.h"
! static boolean MY(set_sizes)();
  #define MY_backend_data &MY(backend_data)
  static CONST struct aout_backend_data MY(backend_data) = {
    0,				/* zmagic contiguous */
    1,				/* text incl header */
--- 28,57 ----
  #define BYTES_IN_WORD 4
  #define ARCH 32
  
! #define PAGE_SIZE       0x1000
! #define SEGMENT_SIZE    0x10000
! #define TEXT_START_ADDR 0x10000
! #define DEFAULT_ARCH    bfd_arch_i386
  
! #define MY(OP) CAT(emx_aout_,OP)
! #define TARGETNAME "a.out-emx"
  #define NO_WRITE_HEADER_KLUDGE 1
  
+ #define MY_object_p MY(object_p)
+ 
  #include "bfd.h"
+ 
+ static PROTO (bfd_target *, MY(callback), (bfd *abfd));
+ static PROTO (bfd_target *, MY(object_p), (bfd *abfd));
+ 
  #include "sysdep.h"
  #include "libbfd.h"
  #include "libaout.h"
! 
  #define MY_backend_data &MY(backend_data)
+ static boolean MY(set_sizes)();
+ 
+ 
  static CONST struct aout_backend_data MY(backend_data) = {
    0,				/* zmagic contiguous */
    1,				/* text incl header */
***************
*** 60,62 ****
--- 61,93 ----
  };
  
  #include "aout-target.h"
+ 
+ /* Finish up the reading of an a.out file header */
+ 
+ static bfd_target *
+ DEFUN(MY(object_p),(abfd),
+      bfd *abfd)
+ {
+   struct external_exec exec_bytes;	/* Raw exec header from file */
+   struct internal_exec exec;		/* Cleaned-up exec header */
+   bfd_target *target;
+   long org_pos, add;
+ 
+   org_pos = bfd_tell (abfd);
+   (void)_fseek_hdr(bfd_cache_lookup(abfd));
+   add = bfd_tell (abfd) - org_pos;
+   if (bfd_read ((PTR) &exec_bytes, 1, EXEC_BYTES_SIZE, abfd)
+       != EXEC_BYTES_SIZE) {
+     bfd_error = wrong_format;
+     return 0;
+   }
+ 
+   exec.a_info = bfd_h_get_32 (abfd, exec_bytes.e_info);
+ 
+   if (N_BADMAG (exec)) return 0;
+ 
+   NAME(aout,swap_exec_header_in)(abfd, &exec_bytes, &exec);
+   exec.emx_add = add;
+   target = NAME(aout,some_aout_object_p) (abfd, &exec, MY(callback));
+   return target;
+ }
diff -c -r bfd/libaout.h d:bfd/libaout.h
*** bfd/libaout.h	Fri Oct 16 12:16:06 1992
--- d:bfd/libaout.h	Mon Nov 23 17:05:40 1992
***************
*** 1,3 ****
--- 1,5 ----
+ /* libaout.h -- changed for emx by Eberhard Mattes -- Nov 1992 */
+ 
  /* BFD back-end data structures for a.out (and similar) files.
     Copyright 1990, 1991, 1992 Free Software Foundation, Inc.
     Written by Cygnus Support.
***************
*** 92,97 ****
--- 94,102 ----
  struct internal_exec
  {
      long a_info;		/* Magic number and flags, packed */
+ #if defined (__EMX__)
+     long emx_add;
+ #endif
      bfd_vma a_text;		/* length of text, in bytes  */
      bfd_vma a_data;		/* length of data, in bytes  */
      bfd_vma a_bss;		/* length of uninitialized data area in mem */
diff -c -r bfd/trad-cor.c d:bfd/trad-cor.c
*** bfd/trad-cor.c	Thu Oct 08 13:18:08 1992
--- d:bfd/trad-cor.c	Sat Nov 14 14:07:10 1992
***************
*** 1,3 ****
--- 1,5 ----
+ /* trad-core.c -- changed for emx by Eberhard Mattes -- Nov 1992 */
+ 
  /* BFD back end for traditional Unix core files (U-area and raw sections)
     Copyright (C) 1988, 1989, 1991 Free Software Foundation, Inc.
     Written by John Gilmore of Cygnus Support.
***************
*** 45,50 ****
--- 47,55 ----
    struct trad_core_struct 
      {
        asection *data_section;
+ #if defined (__EMX__)
+       asection *heap_section;
+ #endif
        asection *stack_section;
        asection *reg_section;
  
***************
*** 54,59 ****
--- 59,67 ----
  
  #define core_upage(bfd) (&((bfd)->tdata.trad_core_data->u))
  #define core_datasec(bfd) ((bfd)->tdata.trad_core_data->data_section)
+ #if defined (__EMX__)
+ #define core_heapsec(bfd) ((bfd)->tdata.trad_core_data->heap_section)
+ #endif
  #define core_stacksec(bfd) ((bfd)->tdata.trad_core_data->stack_section)
  #define core_regsec(bfd) ((bfd)->tdata.trad_core_data->reg_section)
  
***************
*** 76,86 ****
--- 84,99 ----
      return 0;			/* Too small to be a core file */
  
    /* Sanity check perhaps??? */
+ #if defined (__EMX__)
+   if (u.u_magic != UMAGIC)
+     return 0;
+ #else
    if (u.u_dsize > 0x1000000)	/* Remember, it's in pages... */
      return 0;
    if (u.u_ssize > 0x1000000)
      return 0;
    /* Check that the size claimed is no greater than the file size. FIXME. */
+ #endif
  
    /* OK, we believe you.  You're a core file (sure, sure).  */
  
***************
*** 114,137 ****
--- 127,178 ----
    }
    core_regsec (abfd) = (asection *) zalloc (sizeof (asection));
    if (core_regsec (abfd) == NULL) {
+ #if defined (__EMX__)
+   loser2:
+ #endif
      free ((void *)core_datasec (abfd));
      goto loser1;
    }
+ #if defined (__EMX__)
+   core_heapsec (abfd) = (asection *) zalloc (sizeof (asection));
+   if (core_heapsec (abfd) == NULL) {
+     free ((void *)core_regsec (abfd));
+     goto loser2;
+   }
+ #endif
  
    core_stacksec (abfd)->name = ".stack";
    core_datasec (abfd)->name = ".data";
+ #if defined (__EMX__)
+   core_heapsec (abfd)->name = ".heap";
+ #endif
    core_regsec (abfd)->name = ".reg";
  
    core_stacksec (abfd)->flags = SEC_ALLOC + SEC_LOAD + SEC_HAS_CONTENTS;
    core_datasec (abfd)->flags = SEC_ALLOC + SEC_LOAD + SEC_HAS_CONTENTS;
+ #if defined (__EMX__)
+   core_heapsec (abfd)->flags = SEC_ALLOC + SEC_LOAD + SEC_HAS_CONTENTS;
+ #endif
    core_regsec (abfd)->flags = SEC_ALLOC + SEC_HAS_CONTENTS;
  
+ #if defined (__EMX__)
+   core_datasec (abfd)->_raw_size =  u.u_data_end - u.u_data_base;
+   core_heapsec (abfd)->_raw_size = u.u_heap_brk - u.u_heap_base;
+   core_stacksec (abfd)->_raw_size = u.u_stack_end - u.u_stack_low;
+   core_regsec (abfd)->_raw_size = sizeof (struct user);
+ #else
    core_datasec (abfd)->_raw_size =  NBPG * u.u_dsize;
    core_stacksec (abfd)->_raw_size = NBPG * u.u_ssize;
    core_regsec (abfd)->_raw_size = NBPG * UPAGES; /* Larger than sizeof struct u */
+ #endif
  
    /* What a hack... we'd like to steal it from the exec file,
       since the upage does not seem to provide it.  FIXME.  */
+ #if defined (__EMX__)
+   core_datasec (abfd)->vma = u.u_data_base;
+   core_heapsec (abfd)->vma = u.u_heap_base;
+   core_stacksec (abfd)->vma = u.u_stack_low;
+ #else
  #ifdef HOST_DATA_START_ADDR
    core_datasec (abfd)->vma = HOST_DATA_START_ADDR;
  #else
***************
*** 138,143 ****
--- 179,185 ----
    core_datasec (abfd)->vma = HOST_TEXT_START_ADDR + (NBPG * u.u_tsize);
  #endif
    core_stacksec (abfd)->vma = HOST_STACK_END_ADDR - (NBPG * u.u_ssize);
+ #endif
    /* This is tricky.  As the "register section", we give them the entire
       upage and stack.  u.u_ar0 points to where "register 0" is stored.
       There are two tricks with this, though.  One is that the rest of the
***************
*** 154,172 ****
--- 196,228 ----
       using minor trickery to get around the offset-or-absolute-addr problem. */
    core_regsec (abfd)->vma = 0 - (int) u.u_ar0;
  
+ #if defined (__EMX__)
+   core_datasec (abfd)->filepos = u.u_data_off;
+   core_heapsec (abfd)->filepos = u.u_heap_off;
+   core_stacksec (abfd)->filepos = u.u_stack_off;
+ #else
    core_datasec (abfd)->filepos = NBPG * UPAGES;
    core_stacksec (abfd)->filepos = (NBPG * UPAGES) + NBPG * u.u_dsize;
+ #endif
    core_regsec (abfd)->filepos = 0; /* Register segment is the upage */
  
    /* Align to word at least */
    core_stacksec (abfd)->alignment_power = 2;
    core_datasec (abfd)->alignment_power = 2;
+ #if defined (__EMX__)
+   core_heapsec (abfd)->alignment_power = 2;
+ #endif
    core_regsec (abfd)->alignment_power = 2;
  
    abfd->sections = core_stacksec (abfd);
    core_stacksec (abfd)->next = core_datasec (abfd);
    core_datasec (abfd)->next = core_regsec (abfd);
+ #if defined (__EMX__)
+   core_regsec (abfd)->next = core_heapsec (abfd);
+   abfd->section_count = 4;
+ #else
    abfd->section_count = 3;
+ #endif
  
    return abfd->xvec;
  }
diff -c -r libibert/argv.c d:libibert/argv.c
*** libibert/argv.c	Mon Oct 05 17:42:42 1992
--- d:libibert/argv.c	Mon Nov 23 17:06:26 1992
***************
*** 1,3 ****
--- 1,5 ----
+ /* argv.c -- changed for emx by Eberhard Mattes -- Nov 1992 */
+ 
  /* Create and destroy argument vectors (argv's)
     Copyright (C) 1992 Free Software Foundation, Inc.
     Written by Fred Fish @ Cygnus Support
***************
*** 40,46 ****
--- 42,50 ----
  
  #define isspace(ch) ((ch) == ' ' || (ch) == '\t')
  
+ #if !defined (__EMX__)
  #include "alloca-conf.h"
+ #endif
  
  /*  Routines imported from standard C runtime libraries. */
  
diff -c -r libibert/strsigna.c d:libibert/strsigna.c
*** libibert/strsigna.c	Fri Oct 16 12:17:48 1992
--- d:libibert/strsigna.c	Mon Nov 23 17:07:36 1992
***************
*** 1,3 ****
--- 1,5 ----
+ /* strsigna.c -- changed for emx by Eberhard Mattes -- Nov 1992 */
+ 
  /* Extended support for using signal values.
     Copyright (C) 1992 Free Software Foundation, Inc.
     Written by Fred Fish.  fnf@cygnus.com
***************
*** 18,24 ****
--- 20,28 ----
  not, write to the Free Software Foundation, Inc., 675 Mass Ave,
  Cambridge, MA 02139, USA.  */
  
+ #if !defined (__EMX__)
  #include "config.h"
+ #endif
  
  #include <stdio.h>
  #include <signal.h>
***************
*** 186,191 ****
--- 190,200 ----
  #endif
  #if defined (SIGLWP)
    SIGLWP, "SIGLWP", "Signal LWP",
+ #endif
+ #if defined (__EMX__)
+ #if defined (SIGBREAK)
+   SIGBREAK, "BREAK", "Break",
+ #endif
  #endif
    0, NULL, NULL
  };
diff -c -r readline/emacs_ke.c d:readline/emacs_ke.c
*** readline/emacs_ke.c	Thu Nov 21 14:43:02 1991
--- d:readline/emacs_ke.c	Mon Nov 23 17:08:02 1992
***************
*** 1,3 ****
--- 1,5 ----
+ /* emacs_ke.c -- changed for emx by Eberhard Mattes -- Nov 1992 */
+ 
  /* emacs_keymap.c -- the keymap for emacs_mode in readline (). */
  
  /* Copyright (C) 1988, 1989, 1991 Free Software Foundation, Inc.
***************
*** 26,32 ****
--- 28,38 ----
  KEYMAP_ENTRY_ARRAY emacs_standard_keymap = {
  
    /* Control keys. */
+ #if defined (__EMX__)
+   { ISKMAP, (Function *)emacs_emx_keymap }, /* Control-@ */
+ #else
    { ISFUNC, (Function *)0x0 },		/* Control-@ */
+ #endif
    { ISFUNC, rl_beg_of_line },		/* Control-a */
    { ISFUNC, rl_backward },		/* Control-b */
    { ISFUNC, (Function *)0x0 },		/* Control-c */
***************
*** 464,466 ****
--- 470,607 ----
    { ISFUNC, (Function *)0x0 },		/* ~ */
    { ISFUNC, rl_backward_kill_line }	/* RUBOUT */
  };
+ 
+ #if defined (__EMX__)
+ 
+ KEYMAP_ENTRY_ARRAY emacs_emx_keymap = {
+   { ISFUNC, (Function *)0x0 },      /*   0 */
+   { ISFUNC, (Function *)0x0 },      /*   1 */
+   { ISFUNC, (Function *)0x0 },      /*   2 */
+   { ISFUNC, (Function *)0x0 },      /*   3 */
+   { ISFUNC, (Function *)0x0 },      /*   4 */
+   { ISFUNC, (Function *)0x0 },      /*   5 */
+   { ISFUNC, (Function *)0x0 },      /*   6 */
+   { ISFUNC, (Function *)0x0 },      /*   7 */
+   { ISFUNC, (Function *)0x0 },      /*   8 */
+   { ISFUNC, (Function *)0x0 },      /*   9 */
+   { ISFUNC, (Function *)0x0 },      /*  10 */
+   { ISFUNC, (Function *)0x0 },      /*  11 */
+   { ISFUNC, (Function *)0x0 },      /*  12 */
+   { ISFUNC, (Function *)0x0 },      /*  13 */
+   { ISFUNC, (Function *)0x0 },      /*  14 */
+   { ISFUNC, (Function *)0x0 },      /*  15 */
+   { ISFUNC, (Function *)0x0 },      /*  16 */
+   { ISFUNC, (Function *)0x0 },      /*  17 */
+   { ISFUNC, (Function *)0x0 },      /*  18 */
+   { ISFUNC, (Function *)0x0 },      /*  19 */
+   { ISFUNC, (Function *)0x0 },      /*  20 */
+   { ISFUNC, (Function *)0x0 },      /*  21 */
+   { ISFUNC, (Function *)0x0 },      /*  22 */
+   { ISFUNC, (Function *)0x0 },      /*  23 */
+   { ISFUNC, (Function *)0x0 },      /*  24 */
+   { ISFUNC, (Function *)0x0 },      /*  25 */
+   { ISFUNC, (Function *)0x0 },      /*  26 */
+   { ISFUNC, (Function *)0x0 },      /*  27 */
+   { ISFUNC, (Function *)0x0 },      /*  28 */
+   { ISFUNC, (Function *)0x0 },      /*  29 */
+   { ISFUNC, (Function *)0x0 },      /*  30 */
+   { ISFUNC, (Function *)0x0 },      /*  31 */
+   { ISFUNC, (Function *)0x0 },      /*  32 */
+   { ISFUNC, (Function *)0x0 },      /*  33 */
+   { ISFUNC, (Function *)0x0 },      /*  34 */
+   { ISFUNC, (Function *)0x0 },      /*  35 */
+   { ISFUNC, (Function *)0x0 },      /*  36 */
+   { ISFUNC, (Function *)0x0 },      /*  37 */
+   { ISFUNC, (Function *)0x0 },      /*  38 */
+   { ISFUNC, (Function *)0x0 },      /*  39 */
+   { ISFUNC, (Function *)0x0 },      /*  40 */
+   { ISFUNC, (Function *)0x0 },      /*  41 */
+   { ISFUNC, (Function *)0x0 },      /*  42 */
+   { ISFUNC, (Function *)0x0 },      /*  43 */
+   { ISFUNC, (Function *)0x0 },      /*  44 */
+   { ISFUNC, (Function *)0x0 },      /*  45 */
+   { ISFUNC, (Function *)0x0 },      /*  46 */
+   { ISFUNC, (Function *)0x0 },      /*  47 */
+   { ISFUNC, (Function *)0x0 },      /*  48 */
+   { ISFUNC, (Function *)0x0 },      /*  49 */
+   { ISFUNC, (Function *)0x0 },      /*  50 */
+   { ISFUNC, (Function *)0x0 },      /*  51 */
+   { ISFUNC, (Function *)0x0 },      /*  52 */
+   { ISFUNC, (Function *)0x0 },      /*  53 */
+   { ISFUNC, (Function *)0x0 },      /*  54 */
+   { ISFUNC, (Function *)0x0 },      /*  55 */
+   { ISFUNC, (Function *)0x0 },      /*  56 */
+   { ISFUNC, (Function *)0x0 },      /*  57 */
+   { ISFUNC, (Function *)0x0 },      /*  58 */
+   { ISFUNC, (Function *)0x0 },      /*  59 */
+   { ISFUNC, (Function *)0x0 },      /*  60 */
+   { ISFUNC, (Function *)0x0 },      /*  61 */
+   { ISFUNC, (Function *)0x0 },      /*  62 */
+   { ISFUNC, (Function *)0x0 },      /*  63 */
+   { ISFUNC, (Function *)0x0 },      /*  64 */
+   { ISFUNC, (Function *)0x0 },      /*  65 */
+   { ISFUNC, (Function *)0x0 },      /*  66 */
+   { ISFUNC, (Function *)0x0 },      /*  67 */
+   { ISFUNC, (Function *)0x0 },      /*  68 */
+   { ISFUNC, (Function *)0x0 },      /*  69 */
+   { ISFUNC, (Function *)0x0 },      /*  70 */
+   { ISFUNC, rl_beg_of_line },       /*  71: home */
+   { ISFUNC, rl_get_previous_history }, /*  72: cursor up */
+   { ISFUNC, rl_beginning_of_history }, /*  73: page up */
+   { ISFUNC, (Function *)0x0 },      /*  74 */
+   { ISFUNC, rl_backward },          /*  75: cursor left */
+   { ISFUNC, (Function *)0x0 },      /*  76: center cursor */
+   { ISFUNC, rl_forward },           /*  77: cursor right */
+   { ISFUNC, (Function *)0x0 },      /*  78 */
+   { ISFUNC, rl_end_of_line },       /*  79: end */
+   { ISFUNC, rl_get_next_history },  /*  80: cursor down */
+   { ISFUNC, rl_end_of_history },    /*  81: page down */
+   { ISFUNC, (Function *)0x0 },      /*  82: ins */
+   { ISFUNC, rl_delete },            /*  83: del */
+   { ISFUNC, (Function *)0x0 },      /*  84 */
+   { ISFUNC, (Function *)0x0 },      /*  85 */
+   { ISFUNC, (Function *)0x0 },      /*  86 */
+   { ISFUNC, (Function *)0x0 },      /*  87 */
+   { ISFUNC, (Function *)0x0 },      /*  88 */
+   { ISFUNC, (Function *)0x0 },      /*  89 */
+   { ISFUNC, (Function *)0x0 },      /*  90 */
+   { ISFUNC, (Function *)0x0 },      /*  91 */
+   { ISFUNC, (Function *)0x0 },      /*  92 */
+   { ISFUNC, (Function *)0x0 },      /*  93 */
+   { ISFUNC, (Function *)0x0 },      /*  94 */
+   { ISFUNC, (Function *)0x0 },      /*  95 */
+   { ISFUNC, (Function *)0x0 },      /*  96 */
+   { ISFUNC, (Function *)0x0 },      /*  97 */
+   { ISFUNC, (Function *)0x0 },      /*  98 */
+   { ISFUNC, (Function *)0x0 },      /*  99 */
+   { ISFUNC, (Function *)0x0 },      /* 100 */
+   { ISFUNC, (Function *)0x0 },      /* 101 */
+   { ISFUNC, (Function *)0x0 },      /* 102 */
+   { ISFUNC, (Function *)0x0 },      /* 103 */
+   { ISFUNC, (Function *)0x0 },      /* 104 */
+   { ISFUNC, (Function *)0x0 },      /* 105 */
+   { ISFUNC, (Function *)0x0 },      /* 106 */
+   { ISFUNC, (Function *)0x0 },      /* 107 */
+   { ISFUNC, (Function *)0x0 },      /* 108 */
+   { ISFUNC, (Function *)0x0 },      /* 109 */
+   { ISFUNC, (Function *)0x0 },      /* 110 */
+   { ISFUNC, (Function *)0x0 },      /* 111 */
+   { ISFUNC, (Function *)0x0 },      /* 112 */
+   { ISFUNC, (Function *)0x0 },      /* 113 */
+   { ISFUNC, (Function *)0x0 },      /* 114 */
+   { ISFUNC, rl_backward_word },     /* 115: ctrl cursor left */
+   { ISFUNC, rl_forward_word },      /* 116: ctrl cursor right */
+   { ISFUNC, rl_kill_line },         /* 117: ctrl end */
+   { ISFUNC, (Function *)0x0 },      /* 118: ctrl page down */
+   { ISFUNC, rl_backward_kill_line },/* 119: ctrl home */
+   { ISFUNC, (Function *)0x0 },      /* 120: alt 1 */
+   { ISFUNC, (Function *)0x0 },      /* 121 */
+   { ISFUNC, (Function *)0x0 },      /* 122 */
+   { ISFUNC, (Function *)0x0 },      /* 123 */
+   { ISFUNC, (Function *)0x0 },      /* 124 */
+   { ISFUNC, (Function *)0x0 },      /* 125 */
+   { ISFUNC, (Function *)0x0 },      /* 126 */
+   { ISFUNC, (Function *)0x0 },      /* 127 */
+ };
+ 
+ #endif
diff -c -r readline/history.c d:readline/history.c
*** readline/history.c	Wed Mar 25 10:47:06 1992
--- d:readline/history.c	Mon Nov 23 17:08:22 1992
***************
*** 1,3 ****
--- 1,5 ----
+ /* history.c -- changed for emx by Eberhard Mattes -- Nov 1992 */
+ 
  /* History.c -- standalone history library */
  
  /* Copyright (C) 1989, 1991 Free Software Foundation, Inc.
***************
*** 421,428 ****
--- 423,435 ----
      {
        char *home = (char *)getenv ("HOME");
        if (!home) home = ".";
+ #if defined (__EMX__)
+       return_val = (char *)xmalloc (2 + strlen (home) + strlen ("!history"));
+       sprintf (return_val, "%s/!history", home);
+ #else
        return_val = (char *)xmalloc (2 + strlen (home) + strlen (".history"));
        sprintf (return_val, "%s/.history", home);
+ #endif
      }
    return (return_val);
  }
diff -c -r readline/keymaps.h d:readline/keymaps.h
*** readline/keymaps.h	Mon Nov 18 21:59:10 1991
--- d:readline/keymaps.h	Mon Nov 23 17:08:36 1992
***************
*** 1,3 ****
--- 1,5 ----
+ /* keymaps.h -- changed for emx by Eberhard Mattes -- Nov 1992 */
+ 
  /* keymaps.h -- Manipulation of readline keymaps. */
  
  #ifndef _KEYMAPS_H_
***************
*** 34,39 ****
--- 36,44 ----
  #define ISMACR 2
  
  extern KEYMAP_ENTRY_ARRAY emacs_standard_keymap, emacs_meta_keymap, emacs_ctlx_keymap;
+ #if defined (__EMX__)
+ extern KEYMAP_ENTRY_ARRAY emacs_emx_keymap;
+ #endif
  extern KEYMAP_ENTRY_ARRAY vi_insertion_keymap, vi_movement_keymap;
  
  /* Return a new, empty keymap.
diff -c -r readline/readline.c d:readline/readline.c
*** readline/readline.c	Wed Oct 14 15:51:22 1992
--- d:readline/readline.c	Mon Nov 23 17:09:00 1992
***************
*** 1,3 ****
--- 1,5 ----
+ /* readline.c -- changed for emx by Eberhard Mattes -- Nov 1992 */
+ 
  /* readline.c -- a general facility for reading lines of input
     with emacs style editing and completion.  */
  
***************
*** 23,33 ****
--- 25,39 ----
  
  /* Remove these declarations when we have a complete libgnu.a. */
  /* #define STATIC_MALLOC */
+ #if defined (TEST)
+ char *xmalloc(), *xrealloc();
+ #else
  #if !defined (STATIC_MALLOC)
  extern char *xmalloc (), *xrealloc ();
  #else
  static char *xmalloc (), *xrealloc ();
  #endif /* STATIC_MALLOC */
+ #endif
  
  #include "sysdep.h"
  #include <sys/types.h>
***************
*** 42,49 ****
--- 48,61 ----
  #  include <unistd.h>
  #endif
  
+ #if defined (__EMX__)
+ #include <termio.h>
+ #else
  #define NEW_TTY_DRIVER
+ #endif
+ #if !defined (__EMX__)
  #define HAVE_BSD_SIGNALS
+ #endif
  /* #define USE_XON_XOFF */
  
  #ifdef __MSDOS__
***************
*** 604,610 ****
        rl_deprep_terminal ();
        rl_clear_signals ();
        rl_pending_input = 0;
! 
        kill (getpid (), sig);
  
        SIGNALS_UNBLOCK;
--- 616,624 ----
        rl_deprep_terminal ();
        rl_clear_signals ();
        rl_pending_input = 0;
! #if defined (__EMX__)
!       signal (sig, SIG_ACK);
! #endif
        kill (getpid (), sig);
  
        SIGNALS_UNBLOCK;
***************
*** 2464,2469 ****
--- 2478,2484 ----
  static void
  rl_deprep_terminal ()
  {
+ #if !defined (__EMX__)
  #ifndef __GO32__
    int tty = fileno (rl_instream);
    SIGNALS_DECLARE_SAVED (saved_signals);
***************
*** 2492,2497 ****
--- 2507,2513 ----
  
    SIGNALS_RESTORE (saved_signals);
  #endif /* !__GO32 */
+ #endif
  }
  
  #else  /* !defined (NEW_TTY_DRIVER) */
***************
*** 2542,2547 ****
--- 2558,2566 ----
  
    readline_echoing_p = (tio.c_lflag & ECHO);
  
+ #if defined (__EMX__)
+   tio.c_lflag &= ~IDEFAULT;
+ #endif
    tio.c_lflag &= ~(ICANON|ECHO);
  
    if (otio.c_cc[VEOF] != _POSIX_VDISABLE)
***************
*** 2592,2598 ****
--- 2611,2619 ----
    tcflow (tty, TCOON);		/* Simulate a ^Q. */
  #else
    ioctl (tty, TCSETAW, &tio);
+ #if !defined (__EMX__)
    ioctl (tty, TCXONC, 1);	/* Simulate a ^Q. */
+ #endif
  #endif /* !TERMIOS_TTY_DRIVER */
  
    terminal_prepped = 1;
***************
*** 2621,2627 ****
--- 2642,2650 ----
    tcflow (tty, TCOON);		/* Simulate a ^Q. */
  #else /* TERMIOS_TTY_DRIVER */
    ioctl (tty, TCSETAW, &otio);
+ #if !defined (__EMX__)
    ioctl (tty, TCXONC, 1);	/* Simulate a ^Q. */
+ #endif
  #endif /* !TERMIOS_TTY_DRIVER */
  
    terminal_prepped = 0;
***************
*** 6541,6547 ****
      }
  }
  
! #if defined (STATIC_MALLOC)
  
  /* **************************************************************** */
  /*								    */
--- 6564,6570 ----
      }
  }
  
! #if defined (STATIC_MALLOC) || defined (TEST)
  
  /* **************************************************************** */
  /*								    */
***************
*** 6551,6557 ****
  
  static void memory_error_and_abort ();
  
! static char *
  xmalloc (bytes)
       int bytes;
  {
--- 6574,6583 ----
  
  static void memory_error_and_abort ();
  
! #if defined (STATIC_MALLOC)
! static
! #endif
! char *
  xmalloc (bytes)
       int bytes;
  {
***************
*** 6562,6568 ****
    return (temp);
  }
  
! static char *
  xrealloc (pointer, bytes)
       char *pointer;
       int bytes;
--- 6588,6597 ----
    return (temp);
  }
  
! #if defined (STATIC_MALLOC)
! static
! #endif
! char *
  xrealloc (pointer, bytes)
       char *pointer;
       int bytes;
***************
*** 6586,6592 ****
    fprintf (stderr, "readline: Out of virtual memory!\n");
    abort ();
  }
! #endif /* STATIC_MALLOC */
  
  
  /* **************************************************************** */
--- 6615,6621 ----
    fprintf (stderr, "readline: Out of virtual memory!\n");
    abort ();
  }
! #endif /* STATIC_MALLOC || TEST*/
  
  
  /* **************************************************************** */
diff -c -r readline/sysdep.h d:readline/sysdep.h
*** readline/sysdep.h	Tue Jun 23 22:00:24 1992
--- d:readline/sysdep.h	Mon Nov 23 17:09:38 1992
***************
*** 1,3 ****
--- 1,5 ----
+ /* sysdep.h -- changed for emx by Eberhard Mattes -- Nov 1992 */
+ 
  /* System-dependent stuff, for ``normal'' systems */
  
  #ifdef __GNUC__
***************
*** 22,27 ****
--- 24,36 ----
  
  #include <dirent.h>
  typedef struct dirent dirent;
+ 
+ #include <sys/ioctl.h>
+ 
+ #if !defined (__EMX__)
+ #define __EMX__
+ #endif
+ #define _POSIX_VDISABLE 0
  
  /* SVR4 systems should use <termios.h> rather than <termio.h>. */
  
