diff -c ./info.c \emx\gnu\texinfo/info.c
*** ./info.c	Sun Jun 07 20:31:36 1992
--- /emx/gnu/texinfo/info.c	Tue Aug 11 16:59:36 1992
***************
*** 1,3 ****
--- 1,6 ----
+ /* info.c -- changed for emx by Galen C. Hunt & Eberhard Mattes -- Aug 1992 */
+ /* (the changes include some bug fixes) */
+ 
  /* info -- a stand-alone Info program.
  
     Copyright (C) 1987, 1991 Free Software Foundation, Inc.
***************
*** 64,69 ****
--- 67,76 ----
  #  include <strings.h>
  #endif /* USG */
  
+ #if defined (__EMX__)
+ #include <sys/kbdscan.h>
+ #endif
+ 
  #if !defined (DEFAULT_INFOPATH)
  #  define DEFAULT_INFOPATH \
  	".:/usr/gnu/info:/usr/local/emacs/info:/usr/local/lib/emacs/info"
***************
*** 95,101 ****
--- 102,113 ----
  #define control_character_threshold 0x020 /* smaller than this is control */
  #define meta_character_threshold 0x07f	/* larger than this is Meta. */
  #define control_character_bit 0x40	/* 0x000000, must be off. */
+ #if defined (__EMX__)
+ #define meta_character_bit 0x100	/* x00000000, must be on. */
+ #define ext_character_bit  0x200
+ #else
  #define meta_character_bit 0x080	/* x0000000, must be on. */
+ #endif
  
  #define info_separator_char '\037'
  #define start_of_node_string "\037"
***************
*** 106,111 ****
--- 118,126 ----
  
  #define CTRL(c) ((c) & (~control_character_bit))
  #define META(c) ((c) | meta_character_bit)
+ #if defined (__EMX__)
+ #define EXT(c) ((c) | ext_character_bit)
+ #endif
  
  #define UNMETA(c) ((c) & (~meta_character_bit))
  #define UNCTRL(c) to_upper(((c)|control_character_bit))
***************
*** 116,122 ****
--- 131,142 ----
  #endif
  
  #define CTRL_P(c) ((unsigned char) (c) < control_character_threshold)
+ #if defined (__EMX__)
+ #define META_P(c) ((c) & meta_character_bit)
+ #define EXT_P(c) ((c) & ext_character_bit)
+ #else
  #define META_P(c) ((unsigned char) (c) > meta_character_threshold)
+ #endif
  
  #define NEWLINE '\n'
  #define RETURN CTRL('M')
***************
*** 140,145 ****
--- 160,171 ----
  #define whitespace(c) ((c) == ' ' || (c) == '\t')
  #define cr_whitespace(c) ((c) == ' ' || (c) == '\t' || (c) == '\n')
  
+ #if defined (__EMX__)
+ /* Reverse Video */
+ char *terminal_inverse_begin;	/* {tc_char,"mr" */
+ char *terminal_end_attributes;	/* {tc_char,"me" */
+ #endif
+ 
  /* All right, some windows stuff. */
  
  typedef struct {
***************
*** 212,220 ****
--- 238,252 ----
  /* Offset in the buffer of the last displayed character. */
  int pagebot = 0;
  
+ #if defined (__EMX__)
+ /* If non-NULL, this is a semicolon separated list of directories to search
+    for a specific info file.  The user places this variable into his or
+    her environment. */
+ #else
  /* If non-NULL, this is a colon separated list of directories to search
     for a specific info file.  The user places this variable into his or
     her environment. */
+ #endif
  char *infopath = NULL;
  
  /* If filled, the name of a file to write to. */
***************
*** 340,346 ****
--- 372,382 ----
  
        temp = (char *) xmalloc (2 + strlen (filename) + strlen (infopath));
        strncpy (temp, filename, ptr - filename);
+ #if defined (__EMX__)
+       sprintf (temp + (ptr - filename), ";%s", infopath);
+ #else
        sprintf (temp + (ptr - filename), ":%s", infopath);
+ #endif
        free (infopath);
        infopath = temp;
      }
***************
*** 621,626 ****
--- 657,665 ----
  {
    char *identifier;
    char *data;
+ #if defined (__EMX__)
+   int	position;
+ #endif
    struct completion_entry *next;
  }                COMP_ENTRY;
  
***************
*** 672,679 ****
--- 711,722 ----
     have associated with the identifier, but I'm too stupid for that, so
     it must be a string as well.  This allocates the space for the strings
     so you don't necessarily have to. */
+ #if defined (__EMX__)
+ add_completion (char *identifier, char *data, int position)
+ #else
  add_completion (identifier, data)
       char *identifier, *data;
+ #endif
  {
    COMP_ENTRY *temp = (COMP_ENTRY *) xmalloc (sizeof (COMP_ENTRY));
  
***************
*** 683,688 ****
--- 726,734 ----
    temp->data = (char *) xmalloc (strlen (data) + 1);
    strcpy (temp->data, data);
  
+ #if defined (__EMX__)
+   temp->position = position;
+ #endif
    temp->next = completion_list;
    completion_list = temp;
  }
***************
*** 705,710 ****
--- 751,759 ----
    int current_len = strlen (line);
    int just_completed = 0;		/* Have we just done a completion? */
    int meta_flag = 0;
+ #if defined (__EMX__)
+   int ext_flag = 0;
+ #endif
  
    new_echo_area ();
  
***************
*** 727,732 ****
--- 776,788 ----
  	just_completed--;
  
        character = blink_cursor ();
+ #if defined (__EMX__)
+       if (ext_flag)
+ 	{
+ 	  character = EXT (character);
+ 	  ext_flag = 0;
+ 	}
+ #endif
        if (meta_flag)
  	{
  	  character = META (character);
***************
*** 738,743 ****
--- 794,804 ----
  
        switch (character)
  	{
+ #if defined (__EMX__)
+         case 0:
+ 	  ext_flag++;
+ 	  break;
+ #endif
  	case EOF:
  	  character = '\n';
  
***************
*** 764,769 ****
--- 825,833 ----
  
  	case '\b':
  	case 0x07f:
+ #if defined (__EMX__)
+ 	case EXT (K_LEFT):
+ #endif
  	  if (current_len)
  	    current_len--;
  	  else
***************
*** 855,860 ****
--- 919,927 ----
  	default:
  	  if (!CTRL_P (character) &&
  	      !META_P (character) &&
+ #if defined (__EMX__)
+ 	      !EXT_P (character) &&
+ #endif
  	      current_len < maxchars)
  	    line[current_len++] = character;
  	  else
***************
*** 1169,1175 ****
    register int filename_len, directory_len;
    char *result;
  
!   if (filename[0] == '/')
      return (savestring (filename));
  
    filename_len = strlen (filename);
--- 1236,1246 ----
    register int filename_len, directory_len;
    char *result;
  
! #if defined (__EMX__)
!   if (_fnisabs (filename))
! #else
!  if (filename[0] == '/')
! #endif
      return (savestring (filename));
  
    filename_len = strlen (filename);
***************
*** 1241,1247 ****
--- 1312,1322 ----
    /* Read the contents of the file into a new buffer. */
  
    info_file = (char *) xmalloc (info_buffer_len = file_info.st_size);
+ #if defined (__EMX__)
+   info_buffer_len = fread (info_file, 1, info_buffer_len, input_stream);
+ #else
    fread (info_file, 1, info_buffer_len, input_stream);
+ #endif
    fclose (input_stream);
    strcpy (last_loaded_info_file, tempname);
    if (remember_name)
***************
*** 1409,1414 ****
--- 1484,1492 ----
  	      temp++;
  	    }
  	  filename[temp - 1] = '\0';
+ #if defined (__EMX__)
+           if (nodename[temp])
+ #endif
  	  temp++;			/* skip the closing ')' */
  
  	  /* We have the filename now.  The nodename follows. */
***************
*** 1790,1795 ****
--- 1868,1889 ----
  
  static int search_start = 0;
  
+ #if defined (__EMX__)
+ void bash_window_to (int position)
+ {
+   int pointer;
+ 
+   pointer = back_lines ((the_window.bottom - the_window.top) / 2,
+ 			forward_lines (1, position));
+ 
+   if (pointer < nodetop)
+     pointer = nodetop;
+ 
+   pagetop = pointer;
+   window_bashed = 1;
+ }
+ #endif
+ 
  /* The default prompt string for the Follow Reference command. */
  char *visible_footnote = (char *)NULL;
  toploop ()
***************
*** 1798,1803 ****
--- 1892,1903 ----
    int command, last_command;
    int last_pointer, count, new_ypos, last_pagetop;
    char nodename[NODENAME_LEN];
+ #if defined (__EMX__)
+   int new_node = 1;
+   int menu_item = -1;
+   int ext_flag = 0;
+   char menuname[NODENAME_LEN] = {'\0'};
+ #endif
  
    done = inhibit_display = 0;
    command = last_command = 0;
***************
*** 1809,1819 ****
--- 1909,1960 ----
  	  (window_bashed || (pagetop != last_pagetop)))
  	display_page ();
  
+ #if defined (__EMX__)
+       if (new_node)
+ 	{
+ 	  build_menu ();
+ 	  menu_item = -1;
+ 	  menuname[0] = '\0';
+ 	  new_node = 0;
+ 	}
+       if (menu_item < 0 || new_ypos < pagetop || new_ypos >= pagebot)
+ 	{
+ 	  COMP_ENTRY *mp = completion_list;
+ 
+ 	  new_ypos = -1;
+ 	  menu_item = 0;
+ 	  menuname[0] = '\0';
+ 	  for (menu_item = 0; mp; menu_item++, mp = mp->next)
+ 	    if (mp->position >= pagetop && mp->position < pagebot)
+ 	      {
+ 		new_ypos = mp->position;
+ 		strcpy (menuname, mp->identifier);
+ 		break;
+ 	      }
+ 	  if (new_ypos == -1)
+ 	    menu_item = -1;
+ 	}
+ #endif
        inhibit_display = window_bashed = 0;
        last_pagetop = pagetop;
  
        nodename[0] = '\0';	/* Don't display old text in input line. */
  
+ #if defined (__EMX__)
+       if (new_ypos >= 0)
+ 	{
+ 	  if (cursor_to (new_ypos) && menu_item >= 0)
+ 	    {
+ 	      if (terminal_inverse_begin)
+ 		do_term (terminal_inverse_begin);
+ 	      print_string ("%s", menuname);
+ 	      if (terminal_inverse_begin)
+ 		do_term (terminal_end_attributes);
+ 	      fflush(stdout);
+ 	    }
+ 	}
+ #endif
+ 
        last_command = command;
  
        if (last_command == 'S')
***************
*** 1829,1843 ****
--- 1970,2088 ----
  	  done = 1;
  	  continue;
  	}
+ #if defined (__EMX__)
+       if (ext_flag)
+ 	{
+ 	  command = EXT (command);
+ 	  ext_flag = 0;
+ 	}
+       else
+ #endif
        command = to_upper (command);
  
        switch (command)
  	{
+ #if defined (__EMX__)
+ 	case 0:
+ 	  ext_flag++;
+ 	  break;
+ 	case EXT (K_UP):
+ 	case EXT (K_BACKTAB):
+ 	  inhibit_display = 1;
+ 	  if (menu_item >= 0 && cursor_to (new_ypos))
+ 	    {
+ 	      print_string ("%s", menuname);
+ 	      cursor_to (new_ypos);
+ 	    }
+ 	  if (the_menu_size)
+ 	    {
+ 	      COMP_ENTRY *mp = completion_list;
+ 	      int i;
+ 
+ 	      if (--menu_item < 0)
+ 		menu_item = 0;
+ 	      for (i = 0; mp; i++, mp = mp->next)
+ 		if (i == menu_item)
+ 		  {
+ 		    new_ypos = mp->position;
+ 		    strcpy (menuname, mp->identifier);
+ 		    break;
+ 		  }
+ 	      if (new_ypos < pagetop)
+ 		{
+ 		  bash_window_to (new_ypos);
+ 		  inhibit_display = 0;
+ 		}
+ 	    }
+ 	  break;
+ 	case EXT (K_DOWN):
+ 	case TAB:
+ 	  inhibit_display = 1;
+ 	  if (menu_item >= 0 && cursor_to(new_ypos))
+ 	    {
+ 	      print_string ("%s", menuname);
+ 	      cursor_to (new_ypos);
+ 	    }
+ 	  if (the_menu_size)
+ 	    {
+ 	      COMP_ENTRY *mp = completion_list;
+ 	      int i;
+ 
+ 	      if (++menu_item >= the_menu_size)
+ 		menu_item = the_menu_size - 1;
+ 	      for (i = 0; mp; i++, mp = mp->next)
+ 		if (i == menu_item)
+ 		  {
+ 		    new_ypos = mp->position;
+ 		    strcpy (menuname, mp->identifier);
+ 		    break;
+ 		  }
+ 	      if (new_ypos >= pagebot)
+ 		{
+ 		  bash_window_to (new_ypos);
+ 		  inhibit_display = 0;
+ 		}
+ 	    }
+ 	  break;
+ 	case '\n':
+ 	case '\r':
+ 	  {
+ 	    COMP_ENTRY *mp = completion_list;
+ 
+ 	    for (; mp; mp = mp->next)
+ 	      if (mp->position == new_ypos)
+ 		{
+ 		  if (get_node ((char *) NULL, mp->data, 0))
+ 		    {
+ 		      clear_echo_area ();
+ 		      new_node = 1;
+ 		    }
+ 		  break;
+ 		}
+ 	    if (!mp)
+ 	      {
+ 		inhibit_display =1;
+ 		display_error ("No menu items are available!");
+ 	      }
+ 	    break;
+ 	  }
+ 	case EXT (K_END):	/* Move to end of node */
+ 	  if (!end_page())
+ 	    inhibit_display = 1;
+ 	  break;
+ #endif
  	case 'D':
+ #if defined (__EMX__)
+ 	case EXT (K_CTRL_HOME):
+ 	  new_node = 1;
+ #endif
  	  get_node ((char *) NULL, "(dir)Top", 0);
  	  break;
  
  	case 'H':
+ #if defined (__EMX__)
+ 	  new_node = 1;
+ #endif
  	  if ((the_window.bottom - the_window.top) < 24)
  	    get_node ((char *) NULL, "(info)Help-Small-Screen", 0);
  	  else
***************
*** 1845,1866 ****
--- 2090,2128 ----
  	  break;
  
  	case 'N':
+ #if defined (__EMX__)
+ 	case EXT (K_RIGHT):
+ #endif
  	  if (!next_node ())
  	    {
  	      display_error ("No NEXT for this node!");
  	      inhibit_display = 1;
  	    }
+ #if defined (__EMX__)
+ 	  else
+ 	    new_node = 1;
+ #endif
  	  break;
  
  	case 'P':
+ #if defined (__EMX__)
+ 	case EXT (K_LEFT):
+ #endif
  	  if (!prev_node ())
  	    {
  	      display_error ("No PREV for this node!");
  	      inhibit_display = 1;
  	    }
+ #if defined (__EMX__)
+ 	  else
+ 	    new_node = 1;
+ #endif
  	  break;
  
  	case 'U':
+ #if defined (__EMX__)
+ 	case EXT (K_CTRL_UP):
+ #endif
  	  {
  	    int savetop = pagetop;
  
***************
*** 1870,1880 ****
--- 2132,2150 ----
  		inhibit_display = 1;
  		pagetop = savetop;
  	      }
+ #if defined (__EMX__)
+ 	  else
+ 	    new_node = 1;
+ #endif
  	    break;
  	  }
  
  	case 'M':
+ #if defined (__EMX__)
+           if (!the_menu_size)
+ #else
  	  if (!build_menu ())
+ #endif
  	    {
  	      display_error ("No menu in this node!");
  	      inhibit_display = 1;
***************
*** 1897,1906 ****
--- 2167,2186 ----
  	    }
  
  	  if (get_node ((char *) NULL, nodename, 0))
+ #if defined (__EMX__)
+ 	    {
+ 	      clear_echo_area ();
+ 	      new_node = 1;
+ 	    }
+ #else
  	    clear_echo_area ();
+ #endif
  	  break;
  
  	case 'F':
+ #if defined (__EMX__)
+ 	case EXT (K_CTRL_DOWN):
+ #endif
  	  {
  	    char footnote[NODENAME_LEN];
  
***************
*** 1915,1920 ****
--- 2195,2203 ----
  	    if (!readline ("Follow reference: ", footnote, NODENAME_LEN, 1))
  	      {
  		inhibit_display = 1;
+ #if defined (__EMX__)
+                 build_menu ();
+ #endif
  		break;
  	      }
  
***************
*** 1928,1934 ****
--- 2211,2224 ----
  	      }
  
  	    if (get_node ((char *)NULL, nodename, 0))
+ #if defined (__EMX__)
+ 	      {
+ 		clear_echo_area ();
+ 		new_node = 1;
+ 	      }
+ #else
  	      clear_echo_area ();
+ #endif
  	    break;
  	  }
  
***************
*** 1940,1945 ****
--- 2230,2238 ----
  		get_node (filename, nodename, 1))
  	      {
  		pagetop = ptop;
+ #if defined (__EMX__)
+ 		new_node = 1;
+ #endif
  	      }
  	    else
  	      inhibit_display = 1;
***************
*** 1948,1953 ****
--- 2241,2249 ----
  
  	case SPACE:
  	case CTRL ('V'):
+ #if defined (__EMX__)
+ 	case EXT (K_PAGEDOWN):
+ #endif
  	  if (!next_page ())
  	    {
  	      display_error ("At last page of this node now!");
***************
*** 1957,1962 ****
--- 2253,2261 ----
  
  	case META ('V'):
  	case DELETE:
+ #if defined (__EMX__)
+ 	case EXT (K_PAGEUP):
+ #endif
  	  if (!prev_page ())
  	    {
  	      display_error ("At first page of this node now!");
***************
*** 1965,1970 ****
--- 2264,2272 ----
  	  break;
  
  	case 'B':
+ #if defined (__EMX__)
+ 	case EXT (K_HOME):
+ #endif
  	  if (pagetop == nodetop)
  	    {
  	      display_error ("Already at beginning of this node!");
***************
*** 1984,1991 ****
  	case '5':
  	  {
  	    int item = command - '0';
! 
  	    if (!build_menu ())
  	      {
  		display_error ("No menu in this node!");
  		inhibit_display = 1;
--- 2286,2296 ----
  	case '5':
  	  {
  	    int item = command - '0';
! #if defined (__EMX__)
!             if (!the_menu_size)
! #else
  	    if (!build_menu ())
+ #endif
  	      {
  		display_error ("No menu in this node!");
  		inhibit_display = 1;
***************
*** 2002,2007 ****
--- 2307,2316 ----
  
  	    if (!get_menu (item))
  	      inhibit_display = 1;
+ #if defined (__EMX__)
+             else
+               new_node = 1;
+ #endif
  	  }
  	  break;
  
***************
*** 2013,2019 ****
--- 2322,2335 ----
  	    }
  
  	  if (get_node ((char *) NULL, nodename, 0))
+ #if defined (__EMX__)
+ 	    {
+ 	      clear_echo_area ();
+ 	      new_node = 1;
+ 	    }
+ #else
  	    clear_echo_area ();
+ #endif
  	  break;
  
  	  /* Search from the starting position forward for a string.
***************
*** 2030,2035 ****
--- 2346,2358 ----
  	    static int starting_pagetop = 0;
  	    static int wrap_search = 0;
  
+ #if defined (__EMX__)
+ 	    if (menu_item >= 0 && cursor_to (new_ypos))
+ 	      {
+ 		print_string ("%s", menuname);
+ 		cursor_to (new_ypos);
+ 	      }
+ #endif
   	    sprintf (prompt, "Search for string [%s]: ", search_string);
  
   	    if (!readline (prompt , nodename, NODENAME_LEN, 0))
***************
*** 2172,2177 ****
--- 2495,2503 ----
  		    ("There doesn't appear to be a nodename for this node.");
  		  get_node ((char *)NULL, "*", 0);
  		  pagetop = pointer;
+ #if defined (__EMX__)
+ 		  new_node = 1;
+ #endif
  		  break;
  		}
   		
***************
*** 2183,2189 ****
--- 2509,2522 ----
  		  starting_nodename = savestring (nodename);
  
  		  if (get_node ((char *) NULL, nodename, 0))
+ #if defined (__EMX__)
+ 		    {
+ 		      clear_echo_area ();
+ 		      new_node = 1;
+ 		    }
+ #else
  		    clear_echo_area ();
+ #endif
  		}
   		
  	      /* Reset the top of page if necessary. */
***************
*** 2191,2196 ****
--- 2524,2532 ----
  		if ((strcmp (last_loaded_info_file, starting_filename) != 0) ||
  		    (starting_pagetop != pagetop) ||
  		    (search_start > pagebot))
+ #if defined (__EMX__)
+                   bash_window_to (search_start);
+ #else
  		  {
  		    pointer =
  		      back_lines ((the_window.bottom - the_window.top) / 2,
***************
*** 2202,2207 ****
--- 2538,2544 ----
  		    pagetop = pointer;
  		    window_bashed = 1;
  		  }
+ #endif
  		else
  		  inhibit_display = 1;
  	      }
***************
*** 2211,2216 ****
--- 2548,2556 ----
  
  	case CTRL ('H'):
  	case '?':
+ #if defined (__EMX__)
+ 	case EXT (K_F1):
+ #endif
  	  help_use_info ();
  	  last_pagetop = -1;
  	  break;
***************
*** 2388,2393 ****
--- 2728,2736 ----
    while (1)
      {
        int idx;
+ #if defined (__EMX__)
+       int menu_pointer;
+ #endif
  
        pointer = search_forward (MENU_ID, pointer);
        if (pointer < 0)
***************
*** 2394,2399 ****
--- 2737,2745 ----
  	break;			/* No more menus in this node. */
  
        pointer = (skip_whitespace (pointer + strlen (MENU_ID)));
+ #if defined (__EMX__)
+       menu_pointer = pointer;
+ #endif
  
        idx = 0;
        while ((menuname[idx] = info_file[pointer]) && menuname[idx] != ':')
***************
*** 2428,2434 ****
--- 2774,2784 ----
  	    }
  	  nodename[idx] = '\0';
  	}
+ #if defined (__EMX__)
+       add_completion (menuname, nodename, menu_pointer);
+ #else
        add_completion (menuname, nodename);
+ #endif
        the_menu_size++;
      }
    if (the_menu_size)
***************
*** 2476,2482 ****
--- 2826,2836 ----
  
    while (temp)
      {
+ #if defined (__EMX__)           /* bug fix */
+       if (strnicmp (string, temp->identifier, strlen (string)) == 0)
+ #else
        if (stricmp (string, temp->identifier, strlen (string)) == 0)
+ #endif
  	{
  	  strcpy (nodename, temp->data);
  	  return (1);
***************
*** 2552,2557 ****
--- 2906,2914 ----
    while (1)
      {
        int idx;
+ #if defined (__EMX__)
+       int menu_pointer;
+ #endif
  
        pointer = find_footnote_ref (pointer);
        if (pointer < 0)
***************
*** 2558,2563 ****
--- 2915,2923 ----
  	break;			/* no more footnotes in this node. */
  
        pointer = skip_whitespace_and_cr (pointer);
+ #if defined (__EMX__)
+       menu_pointer = pointer;
+ #endif
        idx = 0;
  
        while ((notename[idx] = info_file[pointer]) && notename[idx] != ':')
***************
*** 2596,2602 ****
--- 2956,2966 ----
  	  clean_up (nodename);
  	}
        /* Add the notename/nodename to the list. */
+ #if defined (__EMX__)
+       add_completion (notename, nodename, menu_pointer);
+ #else
        add_completion (notename, nodename);
+ #endif
        the_menu_size++;
  
        /* Remember this identifier as the default if it is the first one in the
***************
*** 2783,2788 ****
--- 3147,3168 ----
    return (1);
  }
  
+ #if defined (__EMX__)
+ 
+ /* Move to the end of this node.  Return 0 if we are already there */
+ int end_page ()
+ {
+   int pointer;
+   
+   pointer = back_lines (the_window.bottom - the_window.top - 2, nodebot);
+   if (pointer <= pagetop)
+     return (0);
+   pagetop = pointer;
+   return (1);
+ }
+ 
+ #endif
+ 
  
  /* **************************************************************** */
  /*								    */
***************
*** 3178,3183 ****
--- 3558,3565 ----
      }
  }
  
+ #if !defined (__EMX__)
+ 
  /* Whoops, Unix doesn't have strnicmp. */
  
  /* Compare at most COUNT characters from string1 to string2.  Case
***************
*** 3221,3226 ****
--- 3603,3610 ----
      }
  }
  
+ #endif
+ 
  /* Make the user type "Y" or "N". */
  int 
  get_y_or_n_p ()
***************
*** 3394,3402 ****
--- 3778,3788 ----
  char *terminal_standout_begin;	/* {tc_char,"so" */
  char *terminal_standout_end;	/* {tc_char,"se" */
  
+ #if !defined (__EMX__)
  /* Reverse Video */
  char *terminal_inverse_begin;	/* {tc_char,"mr" */
  char *terminal_end_attributes;	/* {tc_char,"me" */
+ #endif
  
  /* Ding! */
  
***************
*** 3496,3501 ****
--- 3882,3890 ----
  {
    char temp_string_buffer[256];
    int result;
+ #if defined (__EMX__)           /* bug fix */
+   char *p;
+ #endif
  
    char *terminal_name = getenv ("TERM");
  
***************
*** 3505,3511 ****
--- 3894,3907 ----
        terminal_name = temp_string_buffer;
        printf ("\nTerminal Type:");
        fflush (stdout);
+ #if defined (__EMX__)           /* bug fix */
+       restore_io ();
+ #endif
        fgets (terminal_name, 256, stdin);
+ #if defined (__EMX__)           /* bug fix */
+       p = strchr (terminal_name, '\n');
+       if (p) *p = '\0';
+ #endif
        if (!(*terminal_name))
  	return (NO_TERMINAL_DESCRIPTOR);
      }
***************
*** 3639,3644 ****
--- 4035,4046 ----
  int
  get_terminal_rows ()
  {
+ #if defined (__EMX__)
+   int s[2];
+ 
+   _scrsize (s);
+   return (s[1]);
+ #else
    int rows = 0;
  
  #if defined (TIOCGWINSZ)
***************
*** 3660,3665 ****
--- 4062,4068 ----
      rows = 24;
  
    return (rows);
+ #endif
  }
  
  /* Return the number of columns this terminal has. */
***************
*** 3667,3672 ****
--- 4070,4081 ----
  {
    int columns = 0;
  
+ #if defined (__EMX__)
+   int s[2];
+ 
+   _scrsize (s);
+   return (s[0]);
+ #else
  #if defined (TIOCGWINSZ)
    {
      int tty;
***************
*** 3686,3691 ****
--- 4095,4101 ----
      columns = 80;
  
    return (columns);
+ #endif
  }
  
  /* #define TERMINAL_INFO_PRINTING */
***************
*** 3769,3774 ****
--- 4179,4187 ----
  {
    if (!terminal_inited_p)
      {
+ #if defined (__EMX__)
+     setvbuf (stdout, NULL, _IOFBF, BUFSIZ);
+ #endif
        opsys_init_terminal ();
        terminal_rows = get_terminal_rows ();
        terminal_columns = get_terminal_columns ();
***************
*** 4154,4159 ****
--- 4567,4576 ----
    ttybuff.c_iflag &= (~ISTRIP & ~INLCR & ~IGNCR & ~ICRNL &~IXON);
    ttybuff.c_oflag &= (~ONLCR & ~OCRNL);
    ttybuff.c_lflag &= (~ICANON & ~ECHO);
+ #if defined (__EMX__)
+   ttybuff.c_iflag |= IDELETE;
+   ttybuff.c_lflag &= ~IDEFAULT;
+ #endif
  
    ttybuff.c_cc[VMIN] = 1;
    ttybuff.c_cc[VTIME] = 0;
***************
*** 4286,4291 ****
--- 4703,4711 ----
  char *info_suffixes[] = {
    "",
    ".info",
+ #if defined (__EMX__)
+   ".inf",
+ #endif
    "-info",
    (char *)NULL
  };
***************
*** 4533,4539 ****
--- 4953,4963 ----
    if ((i >= strlen (string)) || !string)
      return ((char *) NULL);
  
+ #if defined (__EMX__)
+   while (string[i] && string[i] != ';')
+ #else
    while (string[i] && string[i] != ':')
+ #endif
      i++;
    if (i == start)
      {
diff -c ./makeinfo.c \emx\gnu\texinfo/makeinfo.c
*** ./makeinfo.c	Sun Jun 07 20:31:38 1992
--- /emx/gnu/texinfo/makeinfo.c	Tue Aug 11 17:11:36 1992
***************
*** 1,3 ****
--- 1,5 ----
+ /* Changed for emx by Galen C. Hunt & Eberhard Mattes -- Aug 1992 */
+ 
  /* Makeinfo -- convert texinfo format files into info files.
  
     Copyright (C) 1987, 1991 Free Software Foundation, Inc.
***************
*** 118,123 ****
--- 120,129 ----
     any attention to close_paragraph () calls. */
  int must_start_paragraph = 0;
  
+ #if defined (__EMX__)
+ int current_file_size = 0;
+ #endif
+ 
  /* Some systems don't declare this function in pwd.h. */
  struct passwd *getpwnam ();
  
***************
*** 1045,1051 ****
--- 1051,1062 ----
    if (n == -1)
  #else /* !VMS */
      count = fileinfo.st_size;
+ #if defined (__EMX__)
+   size_of_input_text = read (file, result, count);
+   if (size_of_input_text == -1)
+ #else
      if (read (file, result, fileinfo.st_size) != fileinfo.st_size)
+ #endif
  #endif /* !VMS */
    error_exit:
      {
***************
*** 1064,1070 ****
--- 1075,1083 ----
  
    /* Set the globals to the new file. */
    input_text = result;
+ #if !defined (__EMX__)
    size_of_input_text = fileinfo.st_size;
+ #endif
    input_filename = savestring (fullpath);
    node_filename = savestring (fullpath);
    input_text_offset = 0;
***************
*** 1630,1635 ****
--- 1643,1651 ----
    ".texinfo",
    ".texi",
    ".txinfo",
+ #if defined (__EMX__)
+   ".tex", ".txi",
+ #endif
    (char *)NULL
  };
  
***************
*** 1717,1722 ****
--- 1733,1741 ----
  	real_output_filename = expand_filename (output_filename, name);
  
        output_stream = fopen (real_output_filename, "w");
+ #if defined (__EMX__)
+       current_file_size = 0;
+ #endif
      }
  
    if (output_stream == NULL)
***************
*** 2400,2405 ****
--- 2419,2427 ----
  	output_paragraph[i] &= 0x7f;
      }
  
+ #if defined (__EMX__)
+   current_file_size +=
+ #endif
    fwrite (output_paragraph, 1, output_paragraph_offset, output_stream);
  
    output_position += output_paragraph_offset;
***************
*** 2634,2639 ****
--- 2656,2663 ----
    return (-1);
  }
  
+ #if !defined (__EMX__)
+ 
  /* Whoops, Unix doesn't have stricmp, or strnicmp. */
  
  /* Case independent string compare. */
***************
*** 2676,2681 ****
--- 2700,2707 ----
    return (count);
  }
  
+ #endif
+ 
  enum insertion_type { menu, quotation, lisp, smalllisp, example,
    smallexample, display, itemize, format, enumerate, cartouche, table,
    ftable, vtable, group, ifinfo, flushleft, flushright, ifset, ifclear, deffn,
***************
*** 4257,4262 ****
--- 4283,4295 ----
    if (size == 0)
      size = DEFAULT_SPLIT_SIZE;
  
+ #if defined (__EMX__)
+   if (output_stream)
+     {  
+       fclose (output_stream);
+       output_stream = NULL;
+     }
+ #endif
    if ((stat (filename, &fileinfo) != 0) ||
        (fileinfo.st_size < SPLIT_SIZE_THRESHOLD))
      return;
***************
*** 4301,4307 ****
--- 4334,4344 ----
  	    int i = tags->position + 1;
  	    char last_char = the_file[i];
  
+ #if defined (__EMX)
+ 	    while (i < current_file_size)
+ #else
  	    while (i < fileinfo.st_size)
+ #endif
  	      {
  		if ((the_file[i] == '\037') &&
  		    ((last_char == '\n') ||
***************
*** 4327,4333 ****
--- 4364,4374 ----
  		int i = tags->position + 1;
  		char last_char = the_file[i];
  
+ #if defined (__EMX)
+                 while (i < current_file_size)
+ #else
  		while (i < fileinfo.st_size)
+ #endif
  		  {
  		    if ((the_file[i] == '\037') &&
  			((last_char == '\n') ||
***************
*** 4366,4373 ****
--- 4407,4425 ----
  		    xmalloc (10
  			     + strlen (root_pathname)
  			     + strlen (root_filename));
+ #if defined (__EMX__)
+                   {
+                     char tmp[20];
+                     sprintf (tmp, ".i%02d", which_file);
+                     strcpy (split_file, root_pathname);
+                     strcat (split_file, root_filename);
+                     _remext (split_file);
+                     strcat (split_file, tmp);
+                   }
+ #else
  		  sprintf (split_file,
  		       "%s%s-%d", root_pathname, root_filename, which_file);
+ #endif
  
  		  if (((fd = open (split_file, O_WRONLY | O_TRUNC | O_CREAT, 0666)) < 0)
  		      || (write (fd, the_header, header_size) != header_size)
***************
*** 4387,4394 ****
--- 4439,4456 ----
  		      indirect_info += strlen (indirect_info);
  		    }
  
+ #if defined (__EMX__)
+                   {
+                     char tmp[30];
+                     sprintf (tmp, ".i%02d: %d\n", which_file, file_top);
+                     strcpy (indirect_info, root_filename);
+                     _remext (indirect_info);
+                     strcat (indirect_info, tmp);
+                   }
+ #else
  		  sprintf (indirect_info, "%s-%d: %d\n",
  			   root_filename, which_file, file_top);
+ #endif
  
  		  free (split_file);
  		  indirect_info += strlen (indirect_info);
***************
*** 4403,4408 ****
--- 4465,4473 ----
         original again.  We must use `output_stream', or
         write_tag_table_indirect () won't know where to place the output. */
      output_stream = fopen (filename, "w");
+ #if defined (__EMX__)
+     current_file_size = 0;
+ #endif
      if (!output_stream)
        {
  	perror (filename);
diff -c ./texindex.c \emx\gnu\texinfo/texindex.c
*** ./texindex.c	Sat Feb 22 23:45:00 1992
--- /emx/gnu/texinfo/texindex.c	Wed Aug 05 20:44:36 1992
***************
*** 1,3 ****
--- 1,5 ----
+ /* texindex.c -- changed for emx by Eberhard Mattes -- Aug 1992 */
+ 
  /* Prepare TeX index dribble output into an actual index.
  
     Version 1.45
***************
*** 60,67 ****
--- 62,71 ----
  
  #else /* !VMS */
  
+ #if !defined (__EMX__)
  extern int sys_nerr;
  extern char *sys_errlist[];
+ #endif
  
  #  if defined (USG)
  #    include <sys/types.h>
