# Makefile for GNU C++ class library (libg++) for OS/2 2.0 with emx+gcc

AR = ar
AR_FLAGS = rc
RANLIB = ar s
MAKEINFO = makeinfo

CC = gcc -O

XTRAFLAGS =
#XTRAFLAGS = -DNO_LIBGXX_MALLOC
#XTRAFLAGS = -DMALLOC_STATS

LIBGPP_DIST_VERSION = 2.0
TARGETLIB = libgpp.a

SUBDIRS	=  src iostream # genclass tests

.PHONY: all
all: $(TARGETLIB) # rest-in-parallel

.PHONY: rest-in-parallel
rest-in-parallel: .stmp-tests .stmp-genclass .stmp-etc .stmp-gperf .stmp-utils

$(TARGETLIB): .stmp-src .stmp-io
	-del $(TARGETLIB)
	(cd src & $(MAKE) "CC=$(CC)" "XTRAFLAGS=$(XTRAFLAGS)" \
		"AR=$(AR)" "RANLIB=$(RANLIB)" library)
	(cd iostream & $(MAKE) "CC=$(CC)" "XTRAFLAGS=$(XTRAFLAGS)" \
		"AR=$(AR)" "RANLIB=$(RANLIB)" library)
	$(RANLIB) $(TARGETLIB)

.stmp-src:
	(cd src & \
		$(MAKE) "CC=$(CC)" "XTRAFLAGS=$(XTRAFLAGS)" \
		"AR=$(AR)" "RANLIB=$(RANLIB)")
#	touch $@

.stmp-io:
	(cd iostream & \
		$(MAKE) "CC=$(CC)" "XTRAFLAGS=$(XTRAFLAGS)" \
		"AR=$(AR)" "RANLIB=$(RANLIB)")
#	touch $@

.stmp-genclass: $(TARGETLIB)
	(cd genclass & $(MAKE) "CC=$(CC)" "XTRAFLAGS=$(XTRAFLAGS)")
	touch $@

.stmp-tests: $(TARGETLIB)
	(cd tests & $(MAKE) "CC=$(CC)" "XTRAFLAGS=$(XTRAFLAGS)")
	touch $@

.stmp-etc: $(TARGETLIB)
	(cd etc & $(MAKE) "CC=$(CC)" "XTRAFLAGS=$(XTRAFLAGS)")
	touch $@

.stmp-gperf: $(TARGETLIB)
	(cd gperf & $(MAKE) "CC=$(CC)" "XTRAFLAGS=$(XTRAFLAGS)")
	touch $@

.stmp-utils: $(TARGETLIB)
	(cd utils & $(MAKE) "CC=$(CC)" "XTRAFLAGS=$(XTRAFLAGS)")
	touch $@

.PHONY: info
info: libgpp
	$(MAKE) subdir_do DO=info "DODIRS=$(SUBDIRS)"

libgpp: libgpp.texinfo
	$(MAKEINFO) -o libgpp libgpp.texinfo

.PHONY: clean-info
clean-info:
	-del *.info*

.PHONY: clean
clean:
	-del *.o *~ \#* core .stmp-*
	$(MAKE) subdir_do DO=clean "DODIRS=$(SUBDIRS)"

force:
	@rem force

.PHONY: $(SUBDIRS) dist

subdir_do: force
	for i in $(DODIRS); do \
		if [ -d ./$$i ] ; then \
			if (cd $$i & $(MAKE) \
				"AR=$(AR)" \
				"AR_FLAGS=$(AR_FLAGS)" \
				"CC=$(CC)" \
				"RANLIB=$(RANLIB)" \
				"MAKEINFO=$(MAKEINFO)" \
				$(DO)) ; then true ; else exit 1 ; fi ; \
		else true ; fi ; \
	done
