# Makefile for GNU C++ class library (libg++) for OS/2 2.0 with emx+gcc

AR = ar
AR_FLAGS = rc
RANLIB = ar s
MAKEINFO = makeinfo

CC = gcc -g
CFLAGS = -I. -I../src
XTRAFLAGS =

TARGETLIB = ../libgpp.a

SUBDIRS=stdio test

IOSTREAM_OBS= streambuf.o stdstrbufs.o iostream.o stdstreams.o strstream.o \
  indstream.o PlotFile.o SFile.o fstream.o parsestream.o stream.o makebuf.o \
  editbuf.o filebuf.o sgetline.o igetline.o igetsb.o procbuf.o \
  sbufvform.o sbufvscan.o dtoa.o outfloat.o

# The following include files are merely to provide partial
# compatibilty with the old stream library from libg++.

COMPAT_INCLUDES = istream.h ostream.h stream.h

# The following include files are publicly visible, and
# should be installed where user programs can find them.

USER_INCLUDES = editbuf.h fstream.h iomanip.h iostream.h indstream.h \
  parsestream.h streambuf.h strstream.h PlotFile.h SFile.h $(COMPAT_INCLUDES)

# The following include files are private to the implementation.

INTERNAL_INCLUDES = ioprivate.h ioconfig.h floatio.h

.SUFFIXES: .o .cc

.cc.o:
	$(CC) $(CFLAGS) $(XTRAFLAGS) -c $<

.PHONY: all
all: do-iostreams do-stdio

.PHONY: do-iostreams
do-iostreams: $(IOSTREAM_OBS)

do-stdio:
	(cd stdio & $(MAKE) "CC=$(CC)" "XTRAFLAGS=$(XTRAFLAGS)" \
		"AR=$(AR)" "RANLIB=$(RANLIB)")

library: $(IOSTREAM_OBS)
	$(AR) $(AR_FLAGS) $(TARGETLIB) $(IOSTREAM_OBS)
	(cd stdio & $(MAKE) "CC=$(CC)" "XTRAFLAGS=$(XTRAFLAGS)" \
		"AR=$(AR)" "RANLIB=$(RANLIB)" library)

.PHONY: check
check:

.PHONY: info
info:

.PHONY: clean-info
clean-info:

.PHONY: clean
clean:
	-del *.o *~
	$(MAKE) subdir_do "DODIRS=$(SUBDIRS)" DO=clean

.PHONY: subdir_do
subdir_do: force
	for i in $(DODIRS); do \
		if [ -d ./$$i ] ; then \
			if (cd $$i ; $(MAKE) \
				"AR=$(AR)" \
				"AR_FLAGS=$(AR_FLAGS)" \
				"CC=$(CC)" \
				"RANLIB=$(RANLIB)" \
				"LOADLIBES=$(LOADLIBES)" \
				"LDFLAGS=$(LDFLAGS)" \
				"MAKEINFO=$(MAKEINFO)" \
				$(DO)) ; then true ; else exit 1 ; fi ; \
		else true ; fi ; \
	done

# .PHONY: force
force:
	@rem force
