# A makefile for the stuff now in libg++/etc/ADT-examples

AR = ar
AR_FLAGS = cr
RANLIB = ar s
MAKEINFO = makeinfo
CC = gcc -O -s
CFLAGS = 
XTRAFLAGS = 
LIBS = -lgpp

PROGRAMS = generic-q.exe search.exe keyhash.exe tsort.exe tsortinp.exe \
	 genkey.exe patricia.exe kmp.exe

.SUFFIXES: .o .cc

.cc.o:
	$(CC) $(CFLAGS) $(NOSTDINC) -I. -I../../iostream -I../../src \
	-I../../g++-include $(XTRAFLAGS) -c $<

check:	$(PROGRAMS)
	-generic-q < $(srcdir)/generic-q.cc
	-tsortinp 20 | ./tsort
	-keyhash < $(srcdir)/keyhash.cc
	-search 1000
	-genkey 1000 200 > input
	-patricia ./input ./input | grep -v "is found"

generic-q.exe: generic-q.o
	$(CC) generic-q.o -o $@ $(LIBS)

tsort.exe: tsortinp.exe tsort.o
	$(CC) tsort.o -o $@ $(LIBS)

tsortinp.exe: tsortinp.o
	$(CC) tsortinp.o -o $@ $(LIBS)

keyhash.exe: keyhash.o
	$(CC) keyhash.o -o $@ $(LIBS)

search.exe: search.o
	$(CC) search.o -o $@ $(LIBS)

genkey.exe: genPatkey.o
	$(CC) genPatkey.o -o $@ $(LIBS)

Patricia.o: Patricia.h
Patmain.o: Patricia.h

patricia.exe: Patmain.o Patricia.o
	$(CC) Patmain.o Patricia.o -o $@ $(LIBS)

kmp.exe: kmp.o
	$(CC) kmp.o -o $@ $(LIBS)
