# This file is part of GNU TRIE-GEN.

AR = ar
AR_FLAGS = cr
RANLIB = ar s
MAKEINFO = makeinfo
CC = gcc -O -s
CFLAGS = 
XTRAFLAGS = 

LIBS = -lgpp

.SUFFIXES: .o .cc

.cc.o:
	$(CC) $(CFLAGS) $(NOSTDINC) -I. -I../../iostream -I../../src \
	-I../../g++-include $(XTRAFLAGS) -c $<

OBJS  = trie.o compact.o main.o version.o options.o

trie-gen.exe: $(OBJS)
	$(CC) -o $@ $(OBJS) $(LIBS)

check: trie-gen.exe
	@echo Generating a compacted minimal-prefix trie for files in .
	ls -1 | trie-gen -c > out.cc
	$(CC) -c out.cc test.cc
	$(CC) -o a_out.exe out.o test.o $(LIBS)
	ls -1 | a_out -v

# DO NOT DELETE THIS LINE -- g++dep uses it.
# DO NOT PUT ANYTHING AFTER THIS LINE, IT WILL GO AWAY.

compact.o : compact.cc compact.h
main.o :    main.cc options.h trie.h compact.h
options.o : options.cc options.h
trie.o :    trie.cc trie.h compact.h
version.o : version.cc

# IF YOU PUT ANYTHING HERE IT WILL GO AWAY
