# Makefile for GNU C++ class library (libg++) for OS/2 2.0 with emx+gcc

AR = ar
AR_FLAGS = rc
RANLIB = ar s
MAKEINFO = makeinfo

CC = gcc -g
CFLAGS = -I. -I.. -I../stdio
LIBS = -lgpp # ../../libgpp.a
LIBSTDIO = -lstdio # ../../libstdio.a
XTRAFLAGS =

.SUFFIXES: .o .cc

.cc.o:
	$(CC) $(CFLAGS) $(XTRAFLAGS) -c $<

.PHONY: all
all: tst.exe tgetl.exe tFile.exe tfseek.exe twrseek.exe trdseek.exe tpopen.exe \
	hounddog.exe putbackdog.exe

tst.exe: tst.o
	$(CC) -o $@ tst.o $(LIBSTDIO) $(LIBS)

tgetl.exe: tgetl.o
	$(CC) -o $@ tgetl.o $(LIBS)

tFile.exe: tFile.o
	$(CC) -o $@ tFile.o $(LIBS)

check-tFile: tFile.exe
	tFile <tFile.inp >tFile.out 2>&1
	diff -c tFile.out expected.out

tfseek.exe: tfseek.o
	$(CC) -o $@ tfseek.o $(LIBSTDIO) $(LIBS)

twrseek.exe: twrseek.o
	$(CC) -o $@ twrseek.o $(LIBSTDIO) $(LIBS)

trdseek.exe: trdseek.o
	$(CC) -o $@ trdseek.o $(LIBSTDIO) $(LIBS)

tpopen.exe: tpopen.o
	$(CC) -o $@ tpopen.o $(LIBSTDIO) $(LIBS)

hounddog.exe: hounddog.o
	$(CC) -o $@ hounddog.o $(LIBSTDIO) $(LIBS)

putbackdog.exe: putbackdog.o
	$(CC) -o $@ putbackdog.o $(LIBSTDIO) $(LIBS)

.PHONY: clean
clean:
	-del *.o *~ \#* core tst tgetl tFile tFile.out ffile streamfile
