diff -crb libg++/etc/lf/directory.cc \emx\gnu\libg++/etc/lf/directory.cc
*** libg++/etc/lf/directory.cc	Fri May 29 19:43:18 1992
--- /emx/gnu/libg++/etc/lf/directory.cc	Fri Aug 28 18:39:32 1992
***************
*** 1,6 ****
  #include <stdio.h>
  #include <std.h>
! #include "Dirent.h"
  #include "option.h"
  #include "entry.h"
  #include "directory.h"
--- 1,6 ----
  #include <stdio.h>
  #include <std.h>
! #include "Direntr.h"
  #include "option.h"
  #include "entry.h"
  #include "directory.h"
diff -crb libg++/etc/lf/Direntr.cc \emx\gnu\libg++/etc/lf/Direntr.cc
*** libg++/etc/lf/direntr.cc	Fri May 29 19:43:16 1992
--- /emx/gnu/libg++/etc/lf/direntr.cc	Fri Aug 28 18:39:32 1992
***************
*** 5,11 ****
     library by Douglas C. Schmidt (schmidt@ics.uci.edu). */
  
  #include <std.h>
! #include "Dirent.h"
  
  // error handlers
  
--- 5,11 ----
     library by Douglas C. Schmidt (schmidt@ics.uci.edu). */
  
  #include <std.h>
! #include "Direntr.h"
  
  // error handlers
  
diff -crb libg++/iostream/filebuf.cc \emx\gnu\libg++/iostream/filebuf.cc
*** libg++/iostream/filebuf.cc	Thu Jun 18 02:44:08 1992
--- /emx/gnu/libg++/iostream/filebuf.cc	Tue Nov 24 16:14:08 1992
***************
*** 19,24 ****
--- 19,25 ----
  #include <sys/types.h>
  #include <sys/file.h>
  #include <sys/stat.h>
+ #include <io.h>
  #include <fcntl.h>
  #include <errno.h>
  
diff -crb libg++/iostream/igetline.cc \emx\gnu\libg++/iostream/igetline.cc
*** libg++/iostream/igetline.cc	Fri Jun 05 00:41:46 1992
--- /emx/gnu/libg++/iostream/igetline.cc	Fri Aug 28 18:39:36 1992
***************
*** 80,88 ****
      long old_total = total;
      total += count;
      if (ch != EOF && ch != terminator) {
  	ptr = _sb_readline(sb, total, terminator);
! 	if (ptr)
  	    memcpy(ptr + old_total, buf, count);
  	return ptr;
      }
      
--- 80,91 ----
      long old_total = total;
      total += count;
      if (ch != EOF && ch != terminator) {
+ 	total++; // Include ch in total.
  	ptr = _sb_readline(sb, total, terminator);
! 	if (ptr) {
  	    memcpy(ptr + old_total, buf, count);
+ 	    ptr[old_total+count] = ch;
+ 	}
  	return ptr;
      }
      
diff -crb libg++/iostream/iostream.cc \emx\gnu\libg++/iostream/iostream.cc
*** libg++/iostream/iostream.cc	Sat Jun 20 06:39:34 1992
--- /emx/gnu/libg++/iostream/iostream.cc	Tue Dec 29 03:08:52 1992
***************
*** 693,699 ****
  	_strbuf->vscan(format, ap, &_state);
  	va_end(ap);
      }
!     return *this;
  }
  
  // NOTE: extension for compatibility with old libg++.
--- 693,699 ----
  	_strbuf->vscan(format, ap, &_state);
  	va_end(ap);
      }
!     return *(istream*)this;
  }
  
  // NOTE: extension for compatibility with old libg++.
diff -crb libg++/iostream/iostream.texi \emx\gnu\libg++/iostream/iostream.texi
*** libg++/iostream/iostream.texi	Thu Jun 18 02:44:12 1992
--- /emx/gnu/libg++/iostream/iostream.texi	Fri Aug 28 18:39:38 1992
***************
*** 1,7 ****
  \input texinfo  @c -*-texinfo-*-
  
  @settitle Reference manual to the GNU C++ Iostream Facility
! @setfilename iostream.info
  
  @ifinfo
  @format
--- 1,7 ----
  \input texinfo  @c -*-texinfo-*-
  
  @settitle Reference manual to the GNU C++ Iostream Facility
! @setfilename iostream
  
  @ifinfo
  @format
diff -crb libg++/iostream/makebuf.cc \emx\gnu\libg++/iostream/makebuf.cc
*** libg++/iostream/makebuf.cc	Thu May 14 20:34:08 1992
--- /emx/gnu/libg++/iostream/makebuf.cc	Tue Nov 24 16:14:44 1992
***************
*** 23,28 ****
--- 23,29 ----
  
  #include "ioprivate.h"
  #include "fstream.h"
+ #include <io.h>
  #include <sys/types.h>
  #include <sys/stat.h>
  
diff -crb libg++/iostream/procbuf.cc \emx\gnu\libg++/iostream/procbuf.cc
*** libg++/iostream/procbuf.cc	Sat Jun 20 06:39:38 1992
--- /emx/gnu/libg++/iostream/procbuf.cc	Tue Nov 24 16:15:48 1992
***************
*** 19,24 ****
--- 19,29 ----
  #include "procbuf.h"
  #include <signal.h>
  #include <unistd.h>
+ #if defined (__EMX__)
+ #include <io.h>
+ #include <process.h>
+ #define FORK fork
+ #endif
  #include <sys/wait.h>
  
  
diff -crb libg++/iostream/test/tFile.cc \emx\gnu\libg++/iostream/test/tFile.cc
*** libg++/iostream/test/tfile.cc	Sat May 09 20:50:50 1992
--- /emx/gnu/libg++/iostream/test/tfile.cc	Tue Nov 24 16:17:48 1992
***************
*** 15,20 ****
--- 15,21 ----
  
  #include <stdlib.h>
  #include <string.h>
+ #include <io.h>
  #include <assert.h>
  
  class record
diff -crb libg++/iostream/test/tpopen.cc \emx\gnu\libg++/iostream/test/tpopen.cc
*** libg++/iostream/test/tpopen.cc	Fri May 29 22:16:18 1992
--- /emx/gnu/libg++/iostream/test/tpopen.cc	Fri Aug 28 18:40:58 1992
***************
*** 1,12 ****
  /* From jrs@world.std.com (Rick Sladkey) */
  #include <stdio.h>
! main(argc, argv)
! int argc;
! char **argv;
  {
      FILE *fp;
      char s[128];
!     fp = popen("echo hello; echo goodbye", "r");
      if (fp == NULL) {
  	printf("popen failed\n");
  	exit(1);
--- 1,10 ----
  /* From jrs@world.std.com (Rick Sladkey) */
  #include <stdio.h>
! main(int argc, char **argv)
  {
      FILE *fp;
      char s[128];
!     fp = popen("echo hello & echo goodbye", "r");
      if (fp == NULL) {
  	printf("popen failed\n");
  	exit(1);
***************
*** 14,20 ****
      while (fgets(s, 128, fp) != NULL)
  	printf("s = %s", s);
      pclose(fp);
!     fp = popen("tr '[a-z]' '[A-Z]'", "w");
      if (fp == NULL) {
  	printf("popen (w) failed\n");
  	exit(1);
--- 12,18 ----
      while (fgets(s, 128, fp) != NULL)
  	printf("s = %s", s);
      pclose(fp);
!     fp = popen("tr [a-z] [A-Z]", "w");
      if (fp == NULL) {
  	printf("popen (w) failed\n");
  	exit(1);
diff -crb libg++/libg++.texinfo \emx\gnu\libg++/libg++.texinfo
*** libg++/libg++.texinfo	Thu Jun 18 03:03:12 1992
--- /emx/gnu/libg++/libg++.texinfo	Fri Aug 28 18:41:06 1992
***************
*** 1,7 ****
  \input texinfo  @c -*-texinfo-*-
  
  @settitle User's Guide to the GNU C++ Class Library
! @setfilename libg++.info
  
  @ifinfo
  @format
--- 1,7 ----
  \input texinfo  @c -*-texinfo-*-
  
  @settitle User's Guide to the GNU C++ Class Library
! @setfilename libgpp
  
  @ifinfo
  @format
diff -crb libg++/old-stream/istream.h \emx\gnu\libg++/old-stream/istream.h
*** libg++/old-stream/istream.h	Fri Jan 17 22:11:02 1992
--- /emx/gnu/libg++/old-stream/istream.h	Fri Aug 28 18:41:06 1992
***************
*** 30,36 ****
  #include <File.h>
  #include <streambuf.h>
  #include <filebuf.h>
! #include <Filebuf.h>
  
  class whitespace                // a class used only to input and
  {                               // discard white space characters
--- 30,36 ----
  #include <File.h>
  #include <streambuf.h>
  #include <filebuf.h>
! #include <Filebuff.h>
  
  class whitespace                // a class used only to input and
  {                               // discard white space characters
diff -crb libg++/old-stream/ostream.h \emx\gnu\libg++/old-stream/ostream.h
*** libg++/old-stream/ostream.h	Fri Jan 17 22:11:08 1992
--- /emx/gnu/libg++/old-stream/ostream.h	Fri Aug 28 18:41:08 1992
***************
*** 33,39 ****
  #include <File.h>
  #include <streambuf.h>
  #include <filebuf.h>
! #include <Filebuf.h>
  
  class istream;
  
--- 33,39 ----
  #include <File.h>
  #include <streambuf.h>
  #include <filebuf.h>
! #include <Filebuff.h>
  
  class istream;
  
diff -crb libg++/src/complex.h \emx\gnu\libg++/src/complex.h
*** libg++/src/complex.h	Fri Apr 17 23:51:04 1992
--- /emx/gnu/libg++/src/complex.h	Fri Aug 28 18:49:12 1992
***************
*** 1,6 ****
  #ifndef _complex_h
  #define _complex_h
  #define __ATT_complex__
! #include <Complex.h>
  typedef class Complex complex;
  #endif
--- 1,6 ----
  #ifndef _complex_h
  #define _complex_h
  #define __ATT_complex__
! #include <Complx.h>
  typedef class Complex complex;
  #endif
diff -crb libg++/src/Complx.cc \emx\gnu\libg++/src/Complx.cc
*** libg++/src/complx.cc	Fri Mar 06 07:57:28 1992
--- /emx/gnu/libg++/src/complx.cc	Fri Aug 28 18:41:08 1992
***************
*** 18,24 ****
  #ifdef __GNUG__
  #pragma implementation
  #endif
! #include <Complex.h>
  #include <std.h>
  #include <builtin.h>
  
--- 18,24 ----
  #ifdef __GNUG__
  #pragma implementation
  #endif
! #include <Complx.h>
  #include <std.h>
  #include <builtin.h>
  
diff -crb libg++/src/CursesW.h \emx\gnu\libg++/src/CursesW.h
*** libg++/src/cursesw.h	Fri Jun 26 18:32:50 1992
--- /emx/gnu/libg++/src/cursesw.h	Wed Nov 25 22:24:42 1992
***************
*** 120,130 ****
  #endif
  #endif
  #ifdef standend
! inline int (standend)()  { return standend(); }
  #undef standend
  #endif
  #ifdef standout
! inline int (standout)()  { return standout(); }
  #undef standout
  #endif
  #ifdef winch
--- 120,130 ----
  #endif
  #endif
  #ifdef standend
! inline int (standend)()  { return (int) standend(); }
  #undef standend
  #endif
  #ifdef standout
! inline int (standout)()  { return (int) standout(); }
  #undef standout
  #endif
  #ifdef winch
***************
*** 525,536 ****
  
  inline int CursesWindow::standout()                   
  {
!   return ::wstandout(w); 
  }
  
  inline int CursesWindow::standend()                   
  {
!   return ::wstandend(w); 
  }
  
  inline int CursesWindow::lines()                      
--- 525,536 ----
  
  inline int CursesWindow::standout()
  {
!   return (int) ::wstandout(w);
  }
  
  inline int CursesWindow::standend()
  {
!   return (int) :: wstandend(w);
  }
  
  inline int CursesWindow::lines()
diff -crb libg++/src/Integer.cc \emx\gnu\libg++/src/Integer.cc
*** libg++/src/integer.cc	Fri Jun 26 18:32:52 1992
--- /emx/gnu/libg++/src/integer.cc	Fri Aug 28 18:41:12 1992
***************
*** 460,466 ****
    divide(num, den, q, r);
    double d1 = double(q);
   
!   if (d1 == HUGE || d1 == -HUGE || sign(r) == 0)
      return d1;
    else      // use as much precision as available for fractional part
    {
--- 460,466 ----
    divide(num, den, q, r);
    double d1 = double(q);
   
!   if (/*d1 == HUGE || d1 == -HUGE ||*/ sign(r) == 0)
      return d1;
    else      // use as much precision as available for fractional part
    {
diff -crb libg++/src/malloc.c \emx\gnu\libg++/src/malloc.c
*** libg++/src/malloc.c	Fri May 29 19:22:38 1992
--- /emx/gnu/libg++/src/malloc.c	Fri Aug 28 18:41:14 1992
***************
*** 235,253 ****
  
  #include <stddef.h>   /* for size_t */
  
  #ifdef __cplusplus
  #include <stdio.h>
  #else
! #include "//usr/include/stdio.h"  /* needed for error reporting */
  #endif
  
  #ifdef __cplusplus
  extern "C" {
  #endif
  
  #ifdef _G_SYSV
! extern void*     memset(void*, int, int);
! extern void*     memcpy(void*,  const void*, int);
  inline void      bzero(void* s, int l) { memset(s, 0, l); }
  #else
  extern void      bzero(void*, size_t      );
--- 235,257 ----
  
  #include <stddef.h>   /* for size_t */
  
+ #define unlink hidden_unlink
+ 
  #ifdef __cplusplus
  #include <stdio.h>
  #else
! #include "stdio.h"  /* needed for error reporting */
  #endif
  
+ #undef unlink
+ 
  #ifdef __cplusplus
  extern "C" {
  #endif
  
  #ifdef _G_SYSV
! extern void*     memset(void*, int, size_t);
! extern void*     memcpy(void*,  const void*, size_t);
  inline void      bzero(void* s, int l) { memset(s, 0, l); }
  #else
  extern void      bzero(void*, size_t      );
***************
*** 1149,1155 ****
--- 1153,1161 ----
  }
  
  #ifndef sun
+ #ifndef __EMX__
  #include <getpagesize.h>
+ #endif
  #endif
  
  static size_t       malloc_pagesize = 0;
diff -crb libg++/src/Regx.cc \emx\gnu\libg++/src/Regx.cc
*** libg++/src/regx.cc	Thu Jun 04 00:15:52 1992
--- /emx/gnu/libg++/src/regx.cc	Fri Aug 28 18:41:14 1992
***************
*** 32,38 ****
  #include <regex.h>
  // }
  
! #include <Regex.h>
  
  Regex::~Regex()
  {
--- 32,38 ----
  #include <regex.h>
  // }
  
! #include <Regx.h>
  
  Regex::~Regex()
  {
diff -crb libg++/src/std.h \emx\gnu\libg++/src/std.h
*** libg++/src/std.h	Fri Jun 26 18:33:04 1992
--- /emx/gnu/libg++/src/std.h	Wed Nov 25 22:21:38 1992
***************
*** 23,29 ****
  #include <_G_config.h>
  #include <stddef.h>
  #include <stdlib.h>
! #include <string.h>
  #include <memory.h>
  #include <unistd.h>
  #include <stdio.h> 
--- 23,29 ----
  #include <_G_config.h>
  #include <stddef.h>
  #include <stdlib.h>
! #include <strings.h>
  #include <memory.h>
  #include <unistd.h>
  #include <stdio.h>
diff -crb libg++/src/strclass.h \emx\gnu\libg++/src/strclass.h
*** libg++/src/strclass.h	Fri Apr 17 23:51:26 1992
--- /emx/gnu/libg++/src/strclass.h	Fri Aug 28 18:41:16 1992
***************
*** 1,5 ****
  #ifndef _strclass_h
  #define _strclass_h
! #include <String.h>
  typedef class String string;
  #endif
--- 1,5 ----
  #ifndef _strclass_h
  #define _strclass_h
! #include <Strng.h>
  typedef class String string;
  #endif
diff -crb libg++/src/Strng.cc \emx\gnu\libg++/src/Strng.cc
*** libg++/src/strng.cc	Thu Jun 18 01:39:48 1992
--- /emx/gnu/libg++/src/strng.cc	Fri Aug 28 18:41:18 1992
***************
*** 22,28 ****
  #ifdef __GNUG__
  #pragma implementation
  #endif
! #include <String.h>
  #include <std.h>
  #include <ctype.h>
  #include <limits.h>
--- 22,28 ----
  #ifdef __GNUG__
  #pragma implementation
  #endif
! #include <Strng.h>
  #include <std.h>
  #include <ctype.h>
  #include <limits.h>
diff -crb libg++/src/Strng.h \emx\gnu\libg++/src/Strng.h
*** libg++/src/strng.h	Fri Apr 17 23:50:54 1992
--- /emx/gnu/libg++/src/strng.h	Fri Aug 28 18:41:20 1992
***************
*** 24,30 ****
  #define _String_h 1
  
  #include <stream.h>
! #include <Regex.h>
  
  struct StrRep                     // internal String representations
  {
--- 24,30 ----
  #define _String_h 1
  
  #include <stream.h>
! #include <Regx.h>
  
  struct StrRep                     // internal String representations
  {
diff -crb libg++/test-install/a.cc \emx\gnu\libg++/test-install/a.cc
*** libg++/test-install/a.cc	Sat Oct 05 06:24:26 1991
--- /emx/gnu/libg++/test-install/a.cc	Fri Aug 28 18:41:20 1992
***************
*** 1,5 ****
  #include <stream.h>
! #include <String.h>
  
  String s1 = "Hello";
  String s2 = " world!\n";
--- 1,5 ----
  #include <stream.h>
! #include <Strng.h>
  
  String s1 = "Hello";
  String s2 = " world!\n";
diff -crb libg++/test-install/bf.cc \emx\gnu\libg++/test-install/bf.cc
*** libg++/test-install/bf.cc	Fri Oct 04 07:23:22 1991
--- /emx/gnu/libg++/test-install/bf.cc	Fri Aug 28 18:41:22 1992
***************
*** 1,5 ****
  #include <stream.h>
! #include <String.h>
  
  String s1 = String("Hello ");
  String s2 = String(" world!\n");
--- 1,5 ----
  #include <stream.h>
! #include <Strng.h>
  
  String s1 = String("Hello ");
  String s2 = String(" world!\n");
***************
*** 6,12 ****
  
  int f()
  {
! 	cout << s1 + s2;
          return cout.good();
  }
  
--- 6,12 ----
  
  int f()
  {
! 	cout << s1 << s2;
          return cout.good();
  }
  
diff -crb libg++/tests/tComplex.cc \emx\gnu\libg++/tests/tComplex.cc
*** libg++/tests/tcomplex.cc	Fri Jun 28 21:30:02 1991
--- /emx/gnu/libg++/tests/tcomplex.cc	Fri Aug 28 18:41:22 1992
***************
*** 7,13 ****
  #define tassert(ex) {if ((ex)) cerr << #ex << "\n"; \
                         else _assert(#ex, __FILE__,__LINE__); }
  
! #include <Complex.h>
  
  // to test near-equality
  
--- 7,13 ----
  #define tassert(ex) {if ((ex)) cerr << #ex << "\n"; \
                         else _assert(#ex, __FILE__,__LINE__); }
  
! #include <Complx.h>
  
  // to test near-equality
  
diff -crb libg++/tests/test_h.cc \emx\gnu\libg++/tests/test_h.cc
*** libg++/tests/test_h.cc	Wed Jun 17 23:56:22 1992
--- /emx/gnu/libg++/tests/test_h.cc	Fri Aug 28 18:41:24 1992
***************
*** 18,24 ****
  #include <sys/file.h>
  #include <fcntl.h>
  #include <sys/param.h>
! #include <sys/wait.h>
  #include <sys/signal.h>
  #if _G_HAVE_SYS_SOCKET
  #include <sys/socket.h>
--- 18,24 ----
  #include <sys/file.h>
  #include <fcntl.h>
  #include <sys/param.h>
! /* #include <sys/wait.h> */
  #include <sys/signal.h>
  #if _G_HAVE_SYS_SOCKET
  #include <sys/socket.h>
***************
*** 42,48 ****
  #include <Binomial.h>
  #include <BitSet.h>
  #include <BitString.h>
! #include <Complex.h>
  #include <DiscUnif.h>
  #include <Erlang.h>
  #include <GetOpt.h>
--- 42,48 ----
  #include <Binomial.h>
  #include <BitSet.h>
  #include <BitString.h>
! #include <Complx.h>
  #include <DiscUnif.h>
  #include <Erlang.h>
  #include <GetOpt.h>
***************
*** 52,58 ****
  #include <Rational.h>
  #include <HypGeom.h>
  #include <Integer.h>
- #include <Incremental.h>
  #include <LogNorm.h>
  #include <fcntl.h>
  #include <NegExp.h>
--- 52,57 ----
***************
*** 64,73 ****
  #include <RNG.h>
  #include <Random.h>
  #include <SmplStat.h>
! #include <Regex.h>
  #include <RndInt.h>
  #include <builtin.h>
! #include <String.h>
  #include <Uniform.h>
  #include <Weibull.h>
  
--- 63,72 ----
  #include <RNG.h>
  #include <Random.h>
  #include <SmplStat.h>
! #include <Regx.h>
  #include <RndInt.h>
  #include <builtin.h>
! #include <Strng.h>
  #include <Uniform.h>
  #include <Weibull.h>
  
***************
*** 78,84 ****
  #include <ctype.h>
  #include <errno.h>
  #include <generic.h>
- #include <grp.h>
  #include <istream.h>
  #include <getpagesize.h>
  #include <time.h>
--- 77,82 ----
diff -crb libg++/tests/tString.cc \emx\gnu\libg++/tests/tString.cc
*** libg++/tests/tstring.cc	Fri Jun 28 21:32:54 1991
--- /emx/gnu/libg++/tests/tstring.cc	Fri Aug 28 18:41:24 1992
***************
*** 4,10 ****
   A test file for Strings
  */
  
! #include <String.h>
  #include <std.h>
  #include <assert.h>
  
--- 4,10 ----
   A test file for Strings
  */
  
! #include <Strng.h>
  #include <std.h>
  #include <assert.h>
  
