/* _strtoul.c (emx+gcc) -- Copyright (c) 1990-1993 by Eberhard Mattes */

#include <sys/emx.h>
#include <stdlib.h>
#include <limits.h>

int _strtoul (const char *string, char **end_ptr, int radix,
              unsigned long *dst)
{
  char c, rc;
  unsigned long n, max1, max2;

  n = 0; rc = _S2UL_ERROR;
  if (radix == 0)
    {
      radix = 10;
      if (string[0] == '0')
        {
          if (string[1] == 'x' || string[1] == 'X')
            {
              radix = 16; string += 2;
            }
          else
            radix = 8;
        }
    }
  if (radix >= 2 && radix <= 36)
    {
      max1 = ULONG_MAX / radix; max2 = ULONG_MAX - max1 * radix;
      for (;;)
        {
          c = *string;
          if (c >= '0' && c <= '9')
            c = c - '0';
          else if (c >= 'A' && c <= 'Z')
            c = c - 'A' + 10;
          else if (c >= 'a' && c <= 'z')
            c = c - 'a' + 10;
          else
            break;
          if (c >= radix)
            break;
          if (n >= max1)
            {
              if (n > max1 || (unsigned long)c > max2)
                {
                  rc = _S2UL_OVERFLOW;
                  break;
                }
            }
          n = n * radix + (unsigned long)c;
          ++string; rc = _S2UL_OK;
        }
    }
  if (end_ptr != NULL)
    *end_ptr = (char *)string;
  *dst = n;
  return (rc);
}
