/* startup.c (emx+gcc) -- Copyright (c) 1990-1993 by Eberhard Mattes */

#include <sys/emx.h>
#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <fcntl.h>
#include <sys/ioctl.h>

#if defined (__MT__)
extern void _startup_emxlibc_dll (void);
#endif

static const char _libc_version[] =
  " libc for emx 0.8f";

static const char _version_warning[] =
  "WARNING: emx 0.8f or later required\r\n";

static char ibuf[BUFSIZ];

void _startup (void)
{
  int i, j;

  if (_emx_vcmp < 0x302e3866)   /* 0.8f */
    __write (2, _version_warning, strlen (_version_warning));
#if defined (__MT__)
  _startup_emxlibc_dll ();
#endif
  for (i = 0; i < _nfiles; ++i)
    {
      _files[i] = 0;
      _lookahead[i] = -1;
      _streamv[i].flags = 0;
      if (ioctl (i, FGETHTYPE, &j) >= 0)
        {
          _files[i] |= O_TEXT;
          if (HT_ISDEV (j))
            _files[i] |= F_DEV;
          if (j == HT_NPIPE)
            _files[i] |= F_NPIPE;
          _streamv[i].flags |= _IOOPEN;
          _streamv[i].ptr = NULL;
          _streamv[i].buffer = NULL;
          _streamv[i].rcount = 0;
          _streamv[i].wcount = 0;
          _streamv[i].handle = i;
          _streamv[i].buf_size = 0;
          _streamv[i].tmpidx = 0;
          _streamv[i].pid = 0;
          _streamv[i].flush = _flushstream;
          switch (i)
            {
            case 0:
              _files[0] |= O_RDONLY;
              _streamv[0].flags |= _IOREAD | _IOFBF | _IOBUFUSER;
              _streamv[0].ptr = ibuf;
              _streamv[0].buffer = ibuf;
              _streamv[0].buf_size = BUFSIZ;
              break;
            case 1:
            case 2:
              _files[i] |= O_WRONLY;
              _streamv[i].flags |= (_IOWRT | _IOBUFNONE |
                                    (HT_ISDEV (j) ? _IONBF : _IOFBF));
              break;
            default:
              _files[i] |= O_RDWR;
              _streamv[i].flags |= (_IORW | _IOBUFNONE |
                                    (HT_ISDEV (j) ? _IONBF : _IOFBF));
              break;
            }
        }
    }
}
