/* strtol.c (emx+gcc) -- Copyright (c) 1990-1993 by Eberhard Mattes */

#include <sys/emx.h>
#include <errno.h>
#include <stdlib.h>
#include <limits.h>

long strtol (const char *string, char **end_ptr, int radix)
{
  char neg;
  unsigned long n;

  while (*string == ' ' || *string == '\t')
    ++string;
  neg = 0;
  if (*string == '-')
    {
      ++string; neg = 1;
    }
  else if (*string == '+')
    ++string;
  switch (_strtoul (string, end_ptr, radix, &n))
    {
    case _S2UL_OK:
      if (neg)
        {
          if (n <= (unsigned long)(-LONG_MIN))
            return (-(long)n);
        }
      else
        {
          if (n <= (unsigned long)LONG_MAX)
            return ((long)n);
        }
      /*NOBREAK*/
    case _S2UL_OVERFLOW:
      errno = ERANGE;
      return (neg ? LONG_MIN : LONG_MAX);
    default:
      errno = EINVAL;
      return (0);
    }
  
}
