/*
                       Message Base Reply Chain Linker

              This module was originally written by Bob Hartman
                       Sysop of FidoNet node 1:132/101

   Spark Software, 427-3 Amherst St, CS 2032, Suite 232, Nashua, NH 03061

 This program source code is being released with the following provisions:

 1.  You are  free to make  changes to this source  code for use on your own
 machine,  however,  altered source files may not be distributed without the 
 consent of Spark Software.

 2.  You may distribute "patches"  or  "diff" files for any changes that you
 have made, provided that the "patch" or "diff" files are also sent to Spark
 Software for inclusion in future releases of the entire package.   A "diff"
 file for the source archives may also contain a compiled version,  provided
 it is  clearly marked as not  being created  from the original source code.
 No other  executable  versions may be  distributed without  the  consent of
 Spark Software.

 3.  You are free to include portions of this source code in any program you
 develop, providing:  a) Credit is given to Spark Software for any code that
 may is used, and  b) The resulting program is free to anyone wanting to use
 it, including commercial and government users.

 4.  There is  NO  technical support  available for dealing with this source
 code, or the accompanying executable files.  This source  code  is provided
 as is, with no warranty expressed or implied (I hate legalease).   In other
 words, if you don't know what to do with it,  don't use it,  and if you are
 brave enough to use it, you're on your own.

 Spark Software may be contacted by modem at (603) 888-8179 (node 1:132/101)
 on the public FidoNet network, or at the address given above.

*/

typedef struct {
   unsigned char jmp[3];
   char oem_name[8];
   unsigned int bytes_per_sector;
   unsigned char sectors_per_cluster;
   unsigned int reserved_sectors;
   unsigned char number_of_FATs;
   unsigned int root_directory_entries;
   unsigned int total_sectors;
   unsigned char media_descriptor;
   unsigned int sectors_per_FAT;
   unsigned int sectors_per_track;
   unsigned int number_of_heads;
   unsigned int number_of_hidden_sectors;
   unsigned char junk[482];
} BPB;

typedef struct {
   char filename[8];
   char extension[3];
   unsigned char attribute;
   char reserved[10];
   unsigned int time;
   unsigned int date;
   unsigned int cluster;
   unsigned long size;
} DIR;

typedef struct {
   unsigned char drive;
   char filename[8];
   char extension[3];
   unsigned int block_number;
   unsigned int record_size;
   unsigned long file_size;
   unsigned int date;
   unsigned int time;
   char reserved[8];
   unsigned char curr_record_number;
   unsigned long random_record_number;
} NORM_FCB;

typedef struct {
   unsigned char marker;
   char reserved[5];
   unsigned char attribute;
   NORM_FCB fcb;
} EXT_FCB;


