#include "common.h"

/*--------------------------------------------------------------------*
 *  Handle the KAM dialog procedures.				      *
 *--------------------------------------------------------------------*/
MRESULT EXPENTRY
KAMDlgProc(HWND hwnd, USHORT msg, MPARAM mp1, MPARAM mp2)
{
    char A[10];
    static double Aval = 1.3;
    switch (msg) {
      case WM_INITDLG:
	gcvt(Aval, 5, A);
	WinSetDlgItemText(hwnd, DID_KAM_A, A);

	WinSendDlgItemMsg(hwnd, DID_KAM_A, EM_SETTEXTLIMIT,
	    MPFROM2SHORT(9, 0), NULL);
	return 0;
      case WM_COMMAND:
	switch (COMMANDMSG(&msg)->cmd) {
	  case DID_CANCEL:
	    WinDismissDlg(hwnd, TRUE);
	    return 0;
	  case DID_OK:
	    WinQueryDlgItemText(hwnd, DID_KAM_A, sizeof(A), A);
	    Aval = atof(A);

	    tp.pvalue[0].d = Aval = atof(A);
	    tp.exitflag = 0;


	    DosSemSet(&tp.triggerdraw);
	    DosSemClear(&tp.doingdraw);

	    if (_beginthread(draw_KAM, threadstack,
		    STACKSIZE * sizeof(int), &tp) == -1) {
		WinMessageBox(HWND_DESKTOP, hwnd,
		    "Cannot create second thread!", "Thread2",
		    0, MB_OK | MB_ICONEXCLAMATION);
		return 0;
	    }
	    WinDismissDlg(hwnd, TRUE);
	    setrunning();
	    DosSemClear(&tp.triggerdraw);
	    return 0;
	}
	break;
    }
    return WinDefDlgProc(hwnd, msg, mp1, mp2);
}
/*--------------------------------------------------------------------*
 *  Draw a KAM curve.						      *
 *--------------------------------------------------------------------*/
void far
draw_KAM(threadparms * tp)
{
    HAB hab;

    POINTL ptl;

    double x, y, nx, ny, orbit, x2;
    double A, cosA, sinA;
    register int i;

    MATRIXLF transform;


    DosSemWait(&tp->triggerdraw, SEM_INDEFINITE_WAIT);
    DosSemSet(&tp->doingdraw);

    setfloatscale(&transform, -.75, -.75, .75, .75,
	1000, 1000, tp->xmax, tp->ymax);

    A = tp->pvalue[0].d;
    cosA = cos(A);
    sinA = sin(A);

    hab = WinInitialize(0);

    GpiSetDefaultViewMatrix(tp->memhps, 9L, &transform,
	TRANSFORM_REPLACE);
    GpiErase(tp->memhps);
    GpiSetColor(tp->memhps, CLR_RED);

    ptl.x = 0;
    ptl.y = (-.75 * 1000);
    GpiMove(tp->memhps, &ptl);

    ptl.x = 0;
    ptl.y = (.75 * 1000);
    GpiLine(tp->memhps, &ptl);

    ptl.x = (-.75 * 1000);
    ptl.y = 0;
    GpiMove(tp->memhps, &ptl);

    ptl.x = (.75 * 1000);
    ptl.y = 0;
    GpiLine(tp->memhps, &ptl);

    GpiSetColor(tp->memhps, CLR_DARKBLUE);

    for (orbit = .1; orbit <= 1.6; orbit += .1) {
	if (tp->exitflag)
	    break;
	x = orbit / 3.;
	y = orbit / 3.;
	for (i = 1; i <= 400 && x < 500. && x > -500. && y < 500. && y > -500.; i++) {
	    if (tp->exitflag)
		break;

	    x2 = x * x;
	    nx = (x * cosA) - ((y - x2) * sinA);
	    ny = (x * sinA) + ((y - x2) * cosA);

	    x = nx;
	    y = ny;
	    ptl.x = x * 1000;
	    ptl.y = y * 1000;
	    GpiSetPel(tp->memhps, &ptl);
	}
	refresh(tp->hps, tp->memhps, tp->cxmax, tp->cymax, tp->xmax, tp->ymax);
    }

    DosSemSet(&tp->triggerdraw);
    DosSemClear(&tp->doingdraw);

    DosBeep(440, 200);
    WinPostMsg(hwndClient, WM_USER + 1, NULL, NULL);
    WinTerminate(hab);
    _endthread();
}
