/* QuikMenR - One-stop quick use of Rexx MENU to access commonly used
 *            programs and settings.  This is only a sample of what your
 *            menu might look like.  Some of the options in the file
 *            are path-dependent and so may not work on your system.
 *
 *            QuikMenR works best as a single icon on the desktop to gain
 *            quik hit-and-remoe access to many of the functions you
 *            commonly use throughout the day.  In this way you can keep the
 *            desktop uncluttered and still avoid remembering commands.
 */

'@echo off'
'mode 80,20'

if 1 = RxFuncQuery('RexxMenu') then
   CALL RxFuncAdd 'RexxMenu', 'RexxMenu', 'RexxMenu'
MenuChoice = RexxMenu('QuikMenR.cmd','/Init','ToDo','/Suf','.:','/Com','/* ',,
                      '/Sort','/Prompt','Whaddya want?','/Esc')
if \ 0 = COMPARE(MenuChoice,'') then
   interpret 'CALL' INSERT(MenuChoice,'.');
EXIT


/**********************************************************************/
/* WHAT FOLLOWS IS A LIST OF FUNCTIONS I FREQUENTLY ACCESS BUT DON'T  */
/* WANT TO REMEMBER EXACTLY HOW I ACCESS THEM                         */
/**********************************************************************/

Chess.:
/* OS2 Chess - Play against computer or another player
 */
CALL DIRECTORY 'c:\'
'start /F OS2CHESS.EXE'
RETURN

Solitaire.:
/* Klondike - Solitaire
 */
CALL DIRECTORY 'c:\'
'start /F KLONDIKE.EXE'
RETURN

Cat.And.Mouse.:
/* Chase Neko around the screen
 */
CALL DIRECTORY 'c:\'
'start /F NEKO.EXE'
RETURN

Seek.And.Scan.Files.:
/* PMSEEK: Search disk(s) for files and text
 */
'start /F PMSEEK.EXE'
RETURN

Backup.:
/* Very quick and temporary backup of Arcive-bit files into E:\TempBak
 */
CALL DIRECTORY 'c:\'
'start /F /C mini-backup.cmd'
RETURN

Information.:
/* access manuals or other frequently needed information
 */
CALL DIRECTORY 'E:\Utl\System\Information'
'start /F /C ViewInfo.cmd'
RETURN

Globe.:
/* View the earth and sunlight globe
 */
CALL DIRECTORY 'E:\Utl\PMGlobe'
'start /F PMGlobe.exe'
RETURN

ToDo.:
/* View and edit TODO list
 */
CALL DIRECTORY 'e:\personal'
'start /F c:\os2\apps\pmdtodo.exe e:\personal\ToDo.$T$'
RETURN

Quicken.:
/* Quicken for Windows. Check writing and bank accounts.
 */
CALL DIRECTORY 'e:\Personal\QuickenW'
'startd /DOS /FG /FS /SF E:\Personal\QuickenW\Quicken.ini c:\os2\mdos\winos2\winos2.com e:\Personal\QuickenW\QW.EXE'
RETURN

AmiPro.:
/* Start AmiPro Windows word processor
 */
CALL DIRECTORY 'e:\'
'startd /DOS /FG /FS /SF E:\Utl\AmiPro\AmiPro.ini c:\os2\mdos\winos2\winos2.com e:\Utl\AmiPro\AmiPro.exe'
RETURN

C.Plus.Plus.IDE.:
/* Borland C++ IDE
 */
CALL DIRECTORY 'e:\temp'
'startd /DOS /FG /WIN /SF E:\UTL\BORLANDC\BIN\BC.INI e:\UTL\BORLANDC\BIN\BC.EXE'
RETURN

Windows.:
/* Microsoft Windows 3.0 - WINOS2
 */
CALL DIRECTORY 'e:\'
'startd /DOS /FG /FS /SF C:\OS2\MDOS\WINOS2\WINOS2.INI c:\OS2\MDOS\WINOS2\winos2.com'
RETURN

Check.Disk.on.all.hard.disks.:
/* OS/2 command session to run check disk
 */
curdir = DIRECTORY()
CALL RxFuncAdd 'SysDriveMap', 'rexxutil', 'SysDriveMap'
DriveMap = SysDriveMap()
i = 1
do until DriveLetter = '.'
   DriveLetter = SUBSTR(DriveMap,i,1,'.')
   if \(DriveLetter = '.') then do
      call DIRECTORY INSERT(INSERT(DriveLetter,':'),'\')
      '@cls'
      '@cd'
      '@echo chkdsk'
      'chkdsk'
      'pause'
   end  /* Do */
   i = i + 3
end /* do */
call DIRECTORY curdir
RETURN

Swapper.Size.:
/* Show swapper size
 */
CALL DIRECTORY 'e:\utl'
'start /F dinfo.exe'
RETURN

Memory.Available.:
/* Show system memory for DosQuerySysInfo
 */
'cls'
'e:\utl\MemAvail.exe'
'@echo '
'@echo '
'pause'
RETURN

Stuff....Random.thoughts.:
/* Quick edit of file for storing information
 */
'start /F epm.exe /M /O /W e:\personal\Stuff'
RETURN

Terminal.:
/* Run Modem Terminal program
 */
CALL DIRECTORY 'c:\os2\apps'
'start /F softerm.exe'
RETURN

Names.And.Addresses.:
/* My Phone Book
 */
'start /F pmmbase.exe e:\personal\Addresses.$$F'
RETURN

Edit.This.Menu.:
/* Start editor to add another item to this menu
 */
'start /F epm.exe /M /O /W QuikMenR.cmd'
RETURN

Calculator.:
/* Presentation Manager's Calculator
 */
'start /F c:\os2\apps\pmdcalc.exe'
RETURN

Create.Boot.Disk.for.OS2.:
/* Create a boot disk on floppy A:
 */
'start /F cmd.exe /C makeboot 1 a: c:'
RETURN

Pulse.:
/* Show system activity
 */
'start /F pulse.exe'
RETURN

Backup.Workplace.Shell.:
/* Backup the Workplace Shell to restore when inevitable disaster occurs
 */
CALL DIRECTORY 'e:\Utl\System'
'xdel WPSBckup.old\*.* /s /d /n'
'rename WPSBckup WPSBckup.old'
'start /F E:\utl\System\WPSBackup.exe E:\Utl\System\WPSBckup'
/* Note that this comes from New Freedom Data Center, P.O. Box 461
 * New Freedom Pa, 17349......authored by Dave Lester
 */
RETURN

Workframe.:
/* IBM WorkFrame/2
 */
CALL DIRECTORY 'e:\Utl\IBMWF'
'call WFENV.cmd'
RETURN

CDMenu.:
/* Interactively move among directories
 */
'start /F /C CDMenu.cmd'
RETURN

