


DF(1L)                                                     DF(1L)


NAME
       df - summarize free disk space

SYNOPSIS
       df  [-aikPv]  [-t  fstype]  [-x fstype] [--all] [--inodes]
       [--type=fstype]   [--exclude-type=fstype]    [--kilobytes]
       [--portability] [--help] [--version] [path...]

DESCRIPTION
       This manual page documents the GNU version of df.  df dis-
       plays the amount of disk space available on the filesystem
       containing  each  argument  pathname.  If no pathnames are
       given,  the  space  available  on  all  currently  mounted
       filesystems is shown.  Disk space is shown in 1K blocks by
       default, unless the environment  variable  POSIXLY_CORRECT
       is set, in which case 512-byte blocks are used.

       If  an argument is the full pathname of a disk device node
       containing a mounted filesystem, df shows the space avail-
       able on that filesystem rather than on the filesystem con-
       taining the device node (which is always the root filesys-
       tem).   This version of df cannot show the space available
       on unmounted filesystems, because on most kinds of systems
       doing  so  requires very nonportable intimate knowledge of
       filesystem structures.

   OPTIONS
       -a, --all
              Include in the  listing  filesystems  that  have  0
              blocks,   which   are  omitted  by  default.   Such
              filesystems are typically  special-purpose  pseudo-
              filesystems,  such as automounter entries.  On some
              systems, filesystems of type ``ignore'' or ``auto''
              are  also  omitted  by  default and included in the
              listing by this option.

       -i, --inodes
              List  inode  usage  information  instead  of  block
              usage.   An  inode  (short for ``index node'') is a
              special kind of disk block that  contains  informa-
              tion  about a file, such as its owner, permissions,
              timestamps, and location on the disk.

       -k, --kilobytes
              Print  sizes  in  1K  blocks  instead  of  512-byte
              blocks.   This  overrides  the environment variable
              POSIXLY_CORRECT.

       -P, --portability
              Use the POSIX output  format.   This  is  like  the
              default  format  except  that the information about
              each filesystem is always printed  on  exactly  one
              line;  a  mount  device  is  never put on a line by
              itself.  This means that if the mount  device  name



FSF                     GNU File Utilities                      1





DF(1L)                                                     DF(1L)


              is  more  than 20 characters long (as for some net-
              work mounts), the columns are misaligned.

       -t, --type=fstype
              Limit the listing to filesystems  of  type  fstype.
              Multiple  filesystem  types  can be shown by giving
              multiple -t options.  By  default,  all  filesystem
              types are listed.

       -x, --exclude-type=fstype
              Limit  the  listing  to  filesystems  not  of  type
              fstype.  Multiple filesystem types  can  be  elimi-
              nated  by  giving multiple -x options.  By default,
              all filesystem types are listed.

       -v     Ignored; for compatibility with System  V  versions
              of df.

       --help Print a usage message and exit with a non-zero sta-
              tus.

       --version
              Print version information on  standard  error  then
              exit.

































FSF                     GNU File Utilities                      2


